<?
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
define('IN_DOCLEANUP',1);
include "../includes/inc.php";
$ok = verify_admin_access();
if($ok==0) die('Unauthrised access!');

# setting
$limit = 500;

$baseUrl='docleanup.php?';
$admin=$input[admin];
$act=$input[act];
$server_id=$input[server_id];

$db->setQuery("select * from server where server_id='$server_id'");
$db->query();
$server = $db->loadRow();
$upload_dir = $server[upload_dir];
$upload_dir = (substr($upload_dir,0,1)=='/'?'':'../').$upload_dir;

switch($act){
    case 'domove':
        $can_move = 1;
        $move_errors = '';
        if(!is_dir($input[new_upload_dir]))
        {
            $can_move = 0;
            $move_errors .= '<br>New upload directory does not exist!';
        }
        if(!is_dir($upload_dir))
        {
            $can_move = 0;
            $move_errors .= '<br>The default upload directory does not exist[SYSTEM Errors]!';
        }
        if($input[new_upload_dir]==$upload_dir)
        {
            $can_move = 0;
            $move_errors .= '<br>New upload directory could not be same as original one['.$upload_dir.']!';
        }
        if($can_move)
        {
            $db->setQuery("select id, file from files where server_id='$server_id'");
            $db->query();
            $totals = $db->getNumRows();
            MoveFiles($input[new_upload_dir]);
        }
        else
        {
            redirect($baseWeb.'/'.$admin_directory.'/?admin=server&act=movefiles&id='.$input[server_id],$move_errors);
        }
        break;
    case 'md5':
        $db->setQuery("select id from files where server_id='$server_id' and md5_hash=''");
        $db->query();
        if($db->getNumRows()==0)
        {
            redirect($baseWeb.'/'.$admin_directory.'/?admin=server',"No files need be processed for calculating MD5 hash!");
        }
        $db->setQuery("select id, file from files where server_id='$server_id'");
        $db->query();
        $totals = $db->getNumRows();
        CalculateMD5();
        break;
    case 'duplicate':
        $db->setQuery("select id from files where server_id='$server_id' and md5_hash=''");
        $db->query();
        if($db->getNumRows())
        {
            redirect($baseWeb.'/'.$admin_directory.'/?admin=server',"You need first calculate MD5 hash for all files in order to identify duplicate files!");
        }

        $db->setQuery("select id from files where server_id='$server_id' group by md5_hash");
        $db->query();
        $totals = $db->getNumRows();

        RemoveDuplicateFiles();
        break;
    default:

}

function PrintProcessScreen($totals,$server,$act)
{
global $input,$limit,$upload_dir;
    echo <<<EOF
    <b>$totals</b> files on <b>$server[name]</b> will be processed in directory <b>$upload_dir</b>!
    <br>
    <a href="?&act=$act&s=0">Click here to begin to move files</a>
    <br>
    Note: the script will move <b>$limit</b> files per running and it will be automatcally refreshed to continue moving, don't click stop between refrehing!
EOF;
}

function CalculateMD5()
{
global $input,$limit,$upload_dir,$db;

    $s= intval($input[start]);

    $db->setQuery("select id,file from files
                   where server_id='$server_id'
                   limit $s, $limit
                  ");
    $db->query();
    $rows = $db->loadRowList();

    $i=0;
    foreach($rows as $row)
    {
        $i++;

        if(file_exists($upload_dir.'/'.$row[file]))
        {
            $md5_hash = md5_file($upload_dir.'/'.$row[file]);
            $db->setQuery("update files set md5_hash='$md5_hash' where id='$row[id]'");
            $db->query();
        }
        else
        {
            $db->setQuery("delete from files where id='$row[id]'");
            $db->query();
        }
    }

    BatchProcess($s+$i);
}

function RemoveDuplicateFiles()
{
global $input,$server,$limit,$server_id,$upload_dir,$db;

    $s= intval($input[start]);

    $db->setQuery("select id, file,md5_hash from files where server_id='$server_id' group by md5_hash limit $s, $limit");
    $db->query();
    $md5_hashs = $db->loadRowList();

    $i = 0;
    foreach($md5_hashs as $md5_hash)
    {
        $db->setQuery("select id, file from files where server_id='$server_id' and md5_hash='$md5_hash[md5_hash]'");
        $db->query();
        $dupfiles = $db->loadRowList();

        $dupfile_found = 0;
        $dupfile_name = '';
        foreach($dupfiles as $dupfile)
        {
            if(file_exists($upload_dir.'/'.$dupfile[file]))
            {
                $dupfile_found = 1;
                $dupfile_name = $db->getEscaped($dupfile[file]);
            }
            if($dupfile_found==1&&$dupfile[file]!=$dupfile_name)
            {
                unlink($upload_dir.'/'.$dupfile[file]);
            }
        }


        # delete all files with the same md5_hash
        if($dupfile_found == 0)
        {
            $db->setQuery("delete from files where md5_hash='$md5_hash[md5_hash]'");
            $db->query();
        }
        elseif(strlen($dupfile_name)&&$dupfile_found)
        {
            $db->setQuery("update files set file='$dupfile_name' where md5_hash='$md5_hash[md5_hash]'");
            $db->query();
        }

        $i++;
    }

    BatchProcess($s+$i);
}

function MoveFiles($new_upload_dir)
{
global $input,$server,$limit,$server_id,$upload_dir,$db;

    $s= intval($input[start]);

    $db->setQuery("select id, file from files where server_id='$server_id' limit $s, $limit");
    $db->query();
    $rows = $db->loadRowList();

    $i = 0;
    foreach($rows as $row)
    {
        if($server[keep_name]=='yes') mkdir($new_upload_dir.'/'.dirname($row[file]));
        if(rename($upload_dir.'/'.$row[file],$new_upload_dir.'/'.$row[file]))
        {
            $i++;
        }
    }

    BatchProcess($s+$i);
}

function BatchProcess($start)
{
global $baseWeb,$input,$admin_directory,$admin,$act,$server_id,$totals,$limit;
    if($totals<$start||$totals<$limit)
    redirect($baseWeb.'/'.$admin_directory.'/?admin='.$admin.'&act='.$act.'&server_id='.$server_id, '<b>' . ($start > $totals ? $totals : $start) . '/' . $totals . ' files processed!</b>');

    echo '<b>' . ($start > $totals ? $totals : $start) . '/' . $totals . ' files processed!</b>';   
    echo <<<EOF
    <br>
    Please wait a moment, we will refresh the page to process next <b>$limit</b> files
    <script>
    window.setTimeout("location.href='?admin=$admin&act=$act&start=$start';",2500);
    </script>
EOF;
}
?>