#!/usr/bin/perl

use Fcntl qw(:DEFAULT :flock);
use File::Temp qw/ tempfile tempdir /;
use CGI::Carp qw/fatalsToBrowser/;

$limits = 100;
$deletetime=0;
$tmpdir='/tmp';

require("./header.cgi");
$tmpdir = $tmp_dir;

$count = 0;
$crontime = time()-$deletetime;

sub cleantmp {
    my $path = shift;
    opendir(READ, $path);
   
    while ($count<$limits and $file = readdir(READ))
    {
        if (
           ($file =~m/CGItemp/ or $file =~m/_postdata/ or $file =~m/_progress/ or $file =~m/_flength/ or $file =~m/_signal/ or $file =~m/_qstring/)
           and -f $path . "/" . $file
        )
        {
            @info=stat($path . "/" . $file);
            if(@info[8]<$crontime)
            {
                #$count++;
            
                chmod (0777, $path . "/" .$file);
                if(unlink($path . "/" .$file ))
                {
                    $count++;
                    #print $path . "/" .$file."\n";
                }
            }
        } 
    }
    closedir READ;
}

print "Content-type: text/html\n\n";

cleantmp($tmpdir);

print "Done! $count files deleted!";
