<?
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
define("IN_PAGE",'DOWNLOAD');
define("PAGE_TITLE",'SITEDOWNLOAD');
/**
* the user begin cache callback function will be used to
* filter non-use paramers passed from $_SERVER['REQUEST_URI']
*
* return the required params for current script
*/
function USER_BEGINCACHE_CALLBACK()
{
    return array('id','type','d');
}
include "includes/inc.php";
            
# fetch upload id
$upload_id = preg_replace('/[^A-Z0-9]/','',strtoupper($input[id]));
$id_match = $input[type]==2 ? "f.id='$upload_id'" : "f.upload_id='$upload_id'";

($hook = YABPlugin::fetch_hook('downloadfile_loading',__FILE__,__LINE__)) ? eval($hook) : '';

# query the file
$db->setQuery("select f.uid,f.id,f.file,f.filetype,f.downloads,f.name,f.size,f.descr,f.password,f.upload_id,f.thumb,f.server_id
               from files as f
               where $id_match and f.deleted=0");
$db->query();
$filerow=$db->loadRow();

($hook = YABPlugin::fetch_hook('downloadfile_verify',__FILE__,__LINE__)) ? eval($hook) : '';

## File not found
if(!$filerow)
{
    header('location:'.$baseWeb.'/redirect.php?error=1&code=DL_FileNotFound');
    exit;
}

## Filename changed
if(strlen($input[name])&&$input[name]!=makeurls($filerow[name]).'.html')
{
    $urls=getDownloadUrl(array('id'=>$filerow[id],'name'=>$filerow[name],'upload_id'=>$filerow[upload_id],'delete_id'=>$filerow[delete_id]));
    extract($urls);
    header("HTTP/1.1 301 Moved Permanently");
    header('location:'.$downloadurl);
    exit;
}

## Download Server Busy ...
if($user->servers[$filerow[server_id]][allow_download]==0)
{
    header('location:'.$baseWeb.'/redirect.php?error=1&code=DL_DownloadServerOut');
    exit;
}

$filerow[http]   = $user->servers[$filerow[server_id]][http];
$filerow[domain] = $user->servers[$filerow[server_id]][domain];
$filerow[t_diff] = $user->servers[$filerow[server_id]][time_diff];
$upload_id       = $filerow[upload_id];
$file_id         = $filerow[id];
$filerow[descr]     = htmlspecialchars($filerow[descr]);
$filerow[filename]  = $filerow[name];

## apply the download options by user group
$dl_group = $user->uid==0 ? $user->guest_group : $user->groups[$user->package_id];

if((IS_POST&&$input[d]==1&$input[downloadverify]==1)||($dl_group[dl_direct]==1))
{
    require_once("includes/download.inc.php");
    die;
}


($hook = YABPlugin::fetch_hook('downloadfile_geturls',__FILE__,__LINE__)) ? eval($hook) : '';

##get download url
$urls=getDownloadUrl($filerow);
extract($urls);

## assign vars
$template->assign_vars($filerow);
$template->assign_vars(array(
    'filesize'=>convertsize($filerow[size]),
    'fileextension'=>getExt($filerow[filename]),
    'upload_id'=>$upload_id,
    'thumburl'=>$thumburl,
    'downloadurl'=>$downloadurl,
    'rawdownloadurl'=>rawurlencode($downloadurl),
    'deleteurl'=>$deleteurl,
    'refer_url'=>$downloadurl,
    'd'=>$input[d],
    ));       


($hook = YABPlugin::fetch_hook('download_verify_start',__FILE__,__LINE__)) ? eval($hook) : '';

# choose file template and process script ...
if($filerow[filetype]==1&&$FileViewerMode[1]=='inline'&&$input[d]!=1)
{
    $template->assign_var('filetpl','image');
    require_once("includes/image.inc.php");
}
elseif($filerow[filetype]==2&&$FileViewerMode[2]=='inline'&&$input[d]!=1)
{
    $template->assign_var('filetpl','doc');
    require_once("includes/doc.inc.php");
}
elseif($filerow[filetype]==3&&$FileViewerMode[3]=='inline'&&$input[d]!=1)
{
    $template->assign_var('filetpl','mp3');
    require_once("includes/mp3.inc.php");
}
elseif($filerow[filetype]==4&&$FileViewerMode[4]=='inline'&&$input[d]!=1)
{
    $template->assign_var('filetpl','video');
    require_once("includes/video.inc.php");
}
else
{
    $template->assign_var('filetpl','download');
}


$template->assign_var('captcha_enabled',$dl_group[dl_captcha]);
$template->assign_var('downloadpw_needed',$dl_group[dl_password]&&strlen($filerow[password]));


($hook = YABPlugin::fetch_hook('download_verify_end',__FILE__,__LINE__)) ? eval($hook) : '';

## assign vars loaded in above process
$template->assign_vars(array(
    'downloadfileurl'=>$downloadfileurl,
    'rawdownloadfileurl' => rawurlencode($downloadfileurl),
    'waittime'=>$user->dl_waittime,
    'access_key'=>$access_key,
    'errorcode'=>str_replace('{langWeb}', $langWeb, isset($LANG[$errorcode])?$LANG[$errorcode]:$errorcode),
    ));

# loading codes
$db->setQuery("select * from links where enable = 1 order by ordering desc");
$db->query();
$CODES=$db->loadRowList();
buildLinksCodeTemplate('codes',$filerow,$urls);
foreach($CODES as $CODE)
{
    $js_array[] = "'".$CODE[id]."'";
    $codenames[]="'".htmlspecialchars($CODE[name],ENT_QUOTES)."'";
}
$template->assign_vars(array(
    'codes_array'      => 'var codeids = new Array('.implode(',',$js_array).')',
    'codes_names'      => implode(',',$codenames),
    ));

($hook = YABPlugin::fetch_hook('downloadtemplate_loading',__FILE__,__LINE__)) ? eval($hook) : '';

# decide the template based the server and package
$templatefile=array(
'filewraper.package'.$user->package_id.'.html',
'filewraper.html',
);
foreach($templatefile as $file)
{
    ($hook = YABPlugin::fetch_hook('downloadtemplate_check',__FILE__,__LINE__)) ? eval($hook) : '';

    if(file_exists('skin/'.$user->setting['skin_dir'].'/'.$file)) {$showtemplate=$file;break;}
}

($hook = YABPlugin::fetch_hook('downloadtemplate_end',__FILE__,__LINE__)) ? eval($hook) : '';

$LANG[PAGE_TITLE]   = sprintf($LANG[PAGE_TITLE],strip_tags($filerow[filename]));
$page_keywords      = generateKeywords($filerow[filename]) . ', ';
$page_description   = (strlen($filerow[descr]) ? generateKeywords($filerow[descr])  . ', ' : '') . (strlen($filerow[filename]) ? strip_tags($filerow[filename]) .', '  : '');

## inlcude header
require_once("header.php");

$template->set_filenames(array(
	'body' => $showtemplate)
	);
$template->pparse('body');
include "footer.php";
?>