<?
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
define("IN_PAGE",'UPLOADTHUMB');
define("PAGE_TITLE",'SITEUPLOADTHUMB');
include "includes/inc.php";
include ROOT.'/includes/image.class.php';

/**
* validate access!
*/
$ok = verify_admin_access();
$access_code = base64_decode($input[accessKey]);
$uid         = intval(decryptStr("$access_code",$input[IP_CLIENT]));
if(($uid)>=0&&!$ok)
{
    define('FROMADMIN',0);
    # assign var from script virtually!
    $_SESSION['uid']=$uid;
    $_SESSION['logined']=1;
    $_SESSION['last_click']=time();
    $user = new user('session');

    $user->initiate();
}
elseif(!$ok)
{
    showErrors('Not Logined!'.$input[IP_CLIENT]);
}
if($ok)
{
    define('FROMADMIN',1);
}

/**
* load thumbnail setting for this server
*/
$db->setQuery("select * from server where server_id='$server_id'");
$db->query();
$server = $db->loadRow();
$mod_status = split(',',$server[mod_status]);

/**
* initiate Image class
*/
$i = new Image();
$i->ImageFile  = $ImageFile;
$i->ImageFile2 = $ImageFile2;
$i->VideoFile  = $VideoFile;

//$i->setWorkDirs('files','thumb','temp');
$i->setWorkDirs($server[upload_dir],'thumb',$server[php_temp_dir]);
$i->setModuleStatus($mod_status[0],$mod_status[1],$mod_status[2]);

$i->MPLAYER_PATH = $server[mplayer_path];
$i->FFMPEG_PATH  = $server[ffmpeg_path];
$i->IM_PATH      = $server[im_path];

$i->USE_MPLAYER  = $mod_status[1]?1:0;
$i->USE_IM       = $mod_status[0];

$i->thumb_width  = $user->setting[thumb_width];
$i->thumb_height = $user->setting[thumb_height];
$i->thumb_type   = $user->setting[thumb_type];

/**
* load files
*/
$id = intval($input[id]);
$session_sql = $uid==0? "and upload_session='$input[sessid]'" : "";
$db->setQuery("select * from files where id='$id'".(FROMADMIN==0 ?" and uid='$uid' $session_sql":''));
$db->query();
$row=$db->loadRow();
if(!$row)
{
    showErrors('No files selected!');
}

# filename
$filename = $row[file];
$ext_sep  = $server[keep_name]=='no' ? (getExt($filename,'_')=='' ? '.' : '_') : '.';

# thumbnail, replace _ with .
$thumbfilename =  'thumb_' . $id . '.' . getExt($row[name]);

/**
* make thumb from source files
* only for images files and video files
*/
if($input[act]=='make')
{
    if(!$i->canThumb($filename,$ext_sep))
    {
        showErrors('This file can not support thumb generation:'.$filename);
    }
    else
    {
        if($i->isImage($filename,$ext_sep))
        {
            $image = array(
            'name'  => $filename,
            'thumb' => $thumbfilename,
            );
            $result = $i->createThumb($image,0);
        }
        if($i->isVideo($filename,$ext_sep))
        {
            $thumbfilename = $i->convertFiletype($thumbfilename,'jpg',1);
            $image = array(
            'name'  => $filename,
            'thumb' => $thumbfilename,
            );
            $result = $i->createVideoThumb($image,0);
        }
    
        if($result==-1)
        {
            showErrors($i->errors);
        }
        
        if($user->validate_type=='auto'||FROMADMIN==1)
        {
            $db->setQuery("update files set thumb=1, validate=1 where id='$id'");
        }
        else
        {
            $db->setQuery("update files set thumb=1 where id='$id'");
        }
        $db->query();
        $thumburl=$server[http].$server[domain].'/thumb/'.$image[thumb];

        showSuccess($input[id],$thumburl);
    }
    exit;
}
/**
* Upload thumb for other non images files
*/
if($input[act]=='upload')
{
    # only image files
    if(!$i->isImage($_FILES[thumbfile][name]))
    {
        showErrors('Only Image Filetype is Allowed!'.$_FILES[thumbfile][name]);
    }
    
    # if the original type is image, must keep ext not changed!
    $filetype = getExt($_FILES[thumbfile][name]);
    $filetype2 = getExt($thumbfilename,'.');
    # if IM is not installed, and we need convert filetype, halt here ...
    if($i->IM_INSTALLED==0&&$filetype!=$filetype2)
    {
        if($i->isImage($thumbfilename))
        showErrors('Filetype must be same as the original type '.$filetype2.'! You can click "create thumb" to create thumnails form the original image!');
        // for other filetype, we only allow to use jpg file as thumbnails
        elseif($filetype!='jpg')
        showErrors('Filetype must be .jpg type!');
    }

    # if original type is not image, change type to jpg
    if(!$i->isImage($thumbfilename))
    {
        $thumbfilename = basename($i->convertFiletype($thumbfilename,'jpg'));
        $filetype2 = 'jpg';
    }
    
    # set src as temp directory
    $i->srcdir='temp';
    
    # move the temporay file to upload_dir
    $imagefile = basename($_FILES[thumbfile][tmp_name]).'.'.$filetype;
    if(!copy($_FILES[thumbfile][tmp_name], $i->srcdir.'/'.$imagefile))
    {
        showErrors('Copy error!');
    }
    
    # if IM installed and this is not a image file with same filetype, convert it!
    if($i->IM_INSTALLED==1&&$filetype!=$filetype2)
    {
        $i->tmpdir = $i->srcdir;
        $imagefile2 = $i->convertFiletype($i->srcdir.'/'.$imagefile,$filetype2);
        @unlink($i->srcdir.'/'.$imagefile);
        $imagefile = basename($imagefile2);
    }

    $image = array(
    'name'=>$imagefile,
    'thumb'=>$thumbfilename,
    );

    $result = $i->createThumb($image,0);
    @unlink($i->srcdir.'/'.$imagefile);
    
    //trace('',$thumbfilename,'',$row,'',$_FILES,'',$result,'',$i);
    
    if($result==-1)
    {
        showErrors($i->errors);
    }
    
    if($user->validate_type=='auto'||FROMADMIN==1)
    {
        $db->setQuery("update files set thumb=1 , validate=1 where id='$id'");
    }
    else
    {
        $db->setQuery("update files set thumb=1 where id='$id'");
    }
    $db->query();

    $thumburl=$server[http].$server[domain].'/thumb/'.$image[thumb];

    showSuccess($input[id],$thumburl);
    die;
}

function showErrors($text)
{
    echo <<<EOF
<span id=error>$text</span>
<script>
alert(document.getElementById('error').innerHTML)
</script>
EOF;
    die();
}
function showSuccess($id,$url)
{
global $baseWeb,$input;
    if(FROMADMIN==0)
    $link = urlencode('members.php?showlinks=1&s='.$input[s]);
    else
    $link = urlencode('admin/index.php?&admin=images');
    
    $parts = parse_url($_SERVER[HTTP_REFERER]);
    $refer_host = $parts[host];
    $refer_url = urlencode($_SERVER[HTTP_REFERER]);

    $parts=parse_url($baseWeb);
    $baseWeb = "$parts[scheme]://$refer_host$parts[path]";
    
    $url2 = $baseWeb.'/redirect.php?id='.$id.'&thumburl='.$url;//.'&refer_url='.$refer_url;
    //die($url2);
    do_redirect($url2,'','header');
    echo <<<EOF
<script>
//alert('Created sucessfully!');
//document.location="$url2"
</script>
EOF;
    die();
}
?>
