<?
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: ywyhnchina@163.com
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/ 
if(!defined('IN_PAGE')||IN_PAGE!='GETFILE') session_start();
error_reporting  (E_ERROR | E_WARNING | E_PARSE );
$included_files = get_included_files();
$root_dir = dirname(dirname(end($included_files)));
define('ROOT',$root_dir);

include_once(ROOT.'/config.php');
include_once(ROOT.'/includes/sysvars.php');
include_once(ROOT.'/includes/database.php');
include_once(ROOT.'/includes/function.php');

# start timer
startTimer();

# initiate db connection
$db=new database($sql_host,$sql_user,$sql_pass,$sql_database,"");

# parse input
$input=parse_incoming();

# load Plugin class here
include_once(ROOT.'/includes/plugin.class.php');
$YABPlugin=& YABPlugin::init();

# load front end
if(!defined('IN_ADMIN')&&IN_PAGE!='GETFILE')
{
    include_once(ROOT.'/includes/upload.class.php');
    include_once(ROOT.'/includes/user.class.php');

    $user=new user();
    if(defined("IN_MAIN_SERVER")&&IN_MAIN_SERVER==1)
    {
        include_once(ROOT.'/includes/class.smarttemplate.php');
        include_once(ROOT.'/includes/class.smarttemplateparser.php');
        include_once(ROOT.'/includes/email.class.php');
        include_once(ROOT.'/includes/class.phpmailer.php');
       
        $template = new SmartTemplate( ROOT.'/skin/'.$user->setting['skin_dir'] );
   
        $email = new Email(ROOT.'/language/'.$user->setting[language].'/emails');
        $email->admin_email =$user->setting['adminemail'];

        # sending emails via SMTP?
        if($user->setting[use_smtp])
        {
            $email->handler->IsSMTP();
            $email->handler->SMTPAuth = true;

            $email->handler->Host = $user->setting[smtp_host];
            $email->handler->Username = $user->setting[smtp_user];
            $email->handler->Password = $user->setting[smtp_pass];
           
            $email->handler->SMTPDebug = $user->setting['debug']=='yes' ? 2 : 0;
           
            #
            unset($DATASTORE[setting][smtp_user]);
            unset($user->setting[smtp_pass]);
        }
        # compile HTML template into PHP executable file
        $template->reuse_code = $user->setting[reuse_code];
        # cache site pages into static pages to boost performence for your site!
        $user->setting[cached] = $user->setting[cached] && in_array(IN_PAGE,$CachedPages);
        if($user->setting[cached]) $template->use_cache(array('USER_BEGINCACHE_CALLBACK','USER_ENDCACHE_CALLBACK'));
        # all using PHP code in HTML template?
        $template->use_php=$user->setting['allow_php']=='1';

        ($hook = YABPlugin::fetch_hook('template_init',__FILE__,__LINE__)) ? eval($hook) : '';

    }
    $user->initiate();
}
# enable debug mode for admin panel
if(defined('IN_ADMIN')&&IN_ADMIN==1)
{
    $db->debug = true;
}
# rebuild baseWeb to be compactable Javascript cross domain issue!
if(defined("IN_MAIN_SERVER")&&IN_MAIN_SERVER==1)
{
    $parts=parse_url($baseWeb);
    $parts['host'] = $_SERVER['HTTP_HOST'];
    $baseWeb = "$parts[scheme]://$parts[host]$parts[path]";
}
# build lang url
$langWeb = $baseWeb.($user->setting['lang_page']=='static'?'/'.$user->langcode:'');
/*if($user->setting['lang_page']=='static'&&!isset($input[setlang])&&IN_PAGE!='index')
{
    header("HTTP/1.1 301 Moved Permanently");
    header("location:$langWeb/");
    exit;
}*/

# debug mode
$DEMOMODE=0;
$DEMOTEXT='Some function is disabled in demo mode!';
$debug = $user->setting['debug']=='yes' ? 100 : 0;

if($_SERVER[HTTP_X_REQUESTED_WITH]=='XMLHttpRequest'||$input[inline]==1)
{
    define('IGNORE_HEADER',1);
}

# send headers
if(!IS_POST&&IN_PAGE!='GETFILE'&&IN_PAGE!='GETLINKS'&&IN_DOWNLOAD!=1)
{
    //@header('HTTP/1.1 200 OK');

    if(!$nocache)
    {
        @header("Cache-Control: private");
        @header("Pragma: private");
    }
    else
    {
        @header("Expires: 0"); // Date in the past
		@header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
		@header("Cache-Control: no-store, no-cache, must-revalidate"); // HTTP/1.1
		@header("Pragma: no-cache"); // HTTP/1.0
    }
}
?>
