<?php
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
/**
* @package MFHS
* User class
*/
$DATASTORE       = array();
class user {
	/** basic infomation */
    var $uid         = 0;
    var $last_click  = 0;
    var $running_type= 'cookie';
    var $sess_id     = null;
    var $sess_timeout= 3600;
    var $username    = 'Guest';
    var $email       = '';
    var $reg_date    = 0;
    var $last_login  = 0;
    var $logined     = 0;

    /**system setting*/
    var $setting=array();

    /**host package infomation*/
    var $package             = '';
    var $package_id          = 0;
    var $account_expired     = false;
    var $account_expire_date = 0;
    var $server_id           = 0;
    /**1:Active,0:Unconfirmed,-1:Suspended*/
    var $account_status      = 0;

    /**limition on user! */
    var $allowed_filetypes   = array();
    var $disabled_filetypes  = array();
    var $allowed_filesize    = 0;
    var $max_uploads         = 1;
    var $webspace            = 0;
    var $hosted_files        = 0;
    
    /**download options*/
    var $dl_resume       = 0;
    var $dl_speed        = 100;
    var $dl_threads      = 0;
    var $dl_password     = 0;
    var $dl_waittime     = 30;
    var $dl_timeout      = 0;
    var $dl_captcha      = 1;

    /**what user can do!*/
    var $upload_method   = array('can_formupload','can_ftpupload','can_urlupload','can_flashupload');
    var $can_formupload  = 1;
    var $can_urlupload   = 1;
    var $can_ftpupload   = 1;
    var $can_flashupload = 1;

    /**upload url*/
    var $php_upload_url  = '';
    var $cgi_upload_url  = '';
    var $swf_upload_url  = '';
    var $upload_mode     = 0;
    var $servers         = array();
    var $upload_servers  = array();

    /**package list preload*/
    var $groups          = array();
    var $guest_group     = array();
    var $USER            = array();
  	/**
	* user object constructor
	*/
	function user($type='cookie')
    {
    global $db;
        #load site setting
        $this->setting=$this->loadSetting();
        
        ($hook = YABPlugin::fetch_hook('user_set_sessiontype',__FILE__,__LINE__)) ? eval($hook) : '';

        $this->running_type=$type;

        ($hook = YABPlugin::fetch_hook('user_session_check',__FILE__,__LINE__)) ? eval($hook) : '';

        #no valid sess_id stored,create new one for visitor
        if(strlen($this->sess_id = $this->getValue('sess_id'))!=32)
        {
            $this->newSession();
        }
        
        ($hook = YABPlugin::fetch_hook('user_bannedip_check',__FILE__,__LINE__)) ? eval($hook) : '';

        #checking the banned ips
        if($this->isBanedByIP())
        {
            //die("You has been banned from this ip address!");
            global $baseWeb,$ServerIPBannedPage;
            header("location:$baseWeb/$ServerIPBannedPage");
            exit;
        }

        #if logged
        if($this->getValue('logined')==1)
        {
            $nowtime  = time();
            $timediff = $nowtime-$this->getValue('last_click');

            $this->uid=intval($this->getValue('uid'));
            if(($timediff>$this->sess_timeout||!$this->uid)&&$this->getValue('autologin')==0)
            {
                ($hook = YABPlugin::fetch_hook('user_session_timeout',__FILE__,__LINE__)) ? eval($hook) : '';

                $this->uid     = 0;
                $this->logined = 0;
            }
            else
            {
                # check against the user table to confirm user exists
                if($this->uid)
                {
                    ($hook = YABPlugin::fetch_hook('user_loaddata',__FILE__,__LINE__)) ? eval($hook) : '';

                    $db->setQuery("select * from users where id='$this->uid' limit 1");
                    $db->query();
                    $this->USER=$db->loadRow();
                }
                if(is_array($this->USER))
                {
                    $checked=1;
                    # is auto login?
                    if($this->getValue('autologin')==1)
                    {
                        ($hook = YABPlugin::fetch_hook('user_autologin_start',__FILE__,__LINE__)) ? eval($hook) : '';

                        # pass hash doesn't match!
                        if(md5($this->USER[pass])!=$this->getValue('passhash'))
                        {
                            $checked=0;
                            $this->uid       = 0;
                            $this->logined   = 0;
                            $this->autologin = 0;
                        }
                        else
                        {
                            $this->autologin = 1;
                            # last update or visit
                            if($timediff>$this->sess_timeout)
                            {
                                ($hook = YABPlugin::fetch_hook('user_update_lastlogin',__FILE__,__LINE__)) ? eval($hook) : '';

                                global $input;
                                $db->setQuery("update users set last_login='$nowtime',logined_ip='$input[IP_CLIENT]' where id='$this->uid' limit 1");
                                $db->query();
                            }
                        }
                        
                        ($hook = YABPlugin::fetch_hook('user_autologin_end',__FILE__,__LINE__)) ? eval($hook) : '';

                    }
                    else
                    {
                        $this->autologin = 0;
                    }
                   
                    ($hook = YABPlugin::fetch_hook('user_set_autologin',__FILE__,__LINE__)) ? eval($hook) : '';

                    if($checked)
                    {
                        $this->logined   = 1;
                        $this->setValue('passhash',md5($this->USER[pass]));
                    }
                }
                else
                {
                    $this->uid     = 0;
                    $this->logined = 0;
                }
            }
        }
        else
        {
            $this->uid     = 0;
            $this->logined = 0;
        }
        
        ($hook = YABPlugin::fetch_hook('user_set_loginstatus',__FILE__,__LINE__)) ? eval($hook) : '';

        # set value
        $this->setValue('logined',$this->logined);
        $this->setValue('uid',$this->uid);
        $this->setValue('last_click',time());
	}
    /**
	* create a new session id
    * @return void
	*/
    function newSession()
    {
        $seed = md5(microtime());
        $this->setValue('sess_id',$seed);
        $this->sess_id = $seed;
        
        ($hook = YABPlugin::fetch_hook('user_create_session',__FILE__,__LINE__)) ? eval($hook) : '';
    }
    /**
	* init user:guest or member
    * @return void
	*/
	function initiate()
    {
        global $db,$input,$template,$baseWeb,$LANG,$DATASTORE;

        ($hook = YABPlugin::fetch_hook('user_group_loading',__FILE__,__LINE__)) ? eval($hook) : '';

        if(!is_array($DATASTORE[groups]))
        {
           # grab all groups for future use
            $db->setQuery("select * from groups");
            $db->query();
            $this->groups=$groups=$db->loadRowList('id');
           
            # store data
            $DATASTORE[groups]  = $groups;
        }
        else
        {
            $this->groups=$groups=$DATASTORE[groups];
        }
        
        # expired package for expired users
        $this->expired_group=$groups[$this->setting[expired_package]];
        
        # initiate a group for guest use
        $this->guest_group=$groups[1];
        foreach($groups as $row)
        {
            if($row[guest]==1) {$this->guest_group=$row;break;}
        }

        # logined?
        if($this->uid)
        {
            $USER=$this->USER;
            $old_group=$groups[$USER['gid']];
            $account_expired = $USER[expire_date]>time()||$old_group[subscr_fee]==''?false:true;
            $group = $account_expired ? $this->expired_group : $old_group;
            # custom group?overide the normal group
            $custom_group = $USER[custom]=='yes' ?unserialize($USER[data]):$group;
            if(is_array($custom_group))$group = array_merge($group,$custom_group);
        }
        else
        {
            $group=$this->guest_group;
            $USER=$this->USER=array('user'=>'Guest','email'=>'','regdate'=>time());
        }
        
        ($hook = YABPlugin::fetch_hook('user_group_loaded',__FILE__,__LINE__)) ? eval($hook) : '';

        ($hook = YABPlugin::fetch_hook('user_details_assign',__FILE__,__LINE__)) ? eval($hook) : '';

        # format user data
        $this->username             = $USER[user];
        $this->email                = $USER[email];
        $this->lang                 = $USER[lang];
        $this->reg_date             = $USER[regdate];
        $this->last_login           = $USER[last_login];
        $this->logined_ip           = $USER[logined_ip];
        $this->last_update          = $USER[last_update];
        $this->hosted_files         = $USER[files];
        $this->webspace             = $USER[webspace];
        $this->total_downloads      = $USER[totaldownloads];
        $this->total_points         = $USER[totalpoints];
        $this->paypal               = $USER[paypal];
        $this->adsense_id           = $USER[adsense_id];
        $this->balance              = $USER[balance];
        $this->expire_date          = $USER[expire_date];

        # upload setting
        $this->allowed_filetypes    = $group[allowed_filetype]?split(',',$group[allowed_filetype]):array();
        $this->disabled_filetypes   = $group[disabled_filetype]?split(',',$group[disabled_filetype]):array();
        $this->allowed_filesize     = $group[sizelimit];
        $this->allowed_max_webspace = $group[webspace];
        # limit the max uploads, avoiding the javascript endless loops!
        $group[max_uploads]         = $group[max_uploads] > 15 ? 10 : $group[max_uploads];
        $this->max_uploads          = $group[max_uploads];
        $this->validate_type        = $group[validate_type];

        # upload method setting
        $this->can_formupload       = $group[formupload];
        $this->can_urlupload        = $group[urlupload];
        $this->can_ftpupload        = $group[ftpupload];
        $this->can_flashupload      = $group[flashupload];
       
        # download setting
        $this->dl_resume            = $group[dl_resume];
        $this->dl_speed             = $group[dl_speed];
        $this->dl_threads           = $group[dl_threads];
        $this->dl_password          = $group[dl_password];
        $this->dl_waittime          = $group[dl_waittime];
        $this->dl_timeout           = $group[dl_timeout];
        $this->dl_captcha           = $group[dl_captcha];

        # cronjob setting
        $this->cron_enabled         = $group[cron_enabled];
        $this->cron_days            = $group[cron_days];
        $this->cron_views           = $group[cron_views];
       
        # ad setting
        $this->show_site_ads        = $group[show_site_ads];
        $this->show_sponser_ads     = $group[show_sponser_ads];
       
        $this->can_create_folder    = $group[folder];

        # host package
        $this->package              = $old_group[name];
        $this->is_custom            = $USER[custom]=='yes';
        $this->package_id           = $group[id];
        $this->package_server_id    = $group[server_id];

        # got maximum space
        if($this->allowed_max_webspace<=$this->webspace) $this->setting[site_offline] = 1;

        if(IN_MAIN_SERVER)
        {
            # site ads setting
            ($hook = YABPlugin::fetch_hook('user_set_adsetting',__FILE__,__LINE__)) ? eval($hook) : '';

            $template->assign_var('shakeTime',$this->setting[shaketime]);
            $template->assign_var('startShow',$this->setting[startshow]);
            $template->assign_var('AdTop',$this->setting[adtop]);
            $template->assign_var('AdLeft',$this->setting[adleft]);
            $template->assign_var('slideStep',$this->setting[slidestep]);
            $template->assign_var('slideInternal',$this->setting[slideinternal]);

            $template->assign_var('SHOW_SITE_ADS',$this->show_site_ads);
            $template->assign_var('SHOW_SPONSER_ADS',$this->show_sponser_ads);

            # including lang file
            require_once(ROOT.'/language/'.$this->setting[language].'/lang.php');
            # encode lang string for javascript use
            //require_once(ROOT.'/includes/json.php');
            //$js_obj = new JSON_obj;
            //$LANG['NoFileSelected'] = $js_obj->encode($LANG['NoFileSelected']);

            # assign lang vars into template
            $LANG[TEXTDIR] = strtolower($LANG[TEXTDIR]);
            if(is_array($LANG))foreach($LANG as $text=>$translation) $template->assign_vars(array('L_'.$text=>@preg_replace('/\<br\s*\>/isx','<br />',$translation)));
            # define time format
            $LANG[Units] = array('D'=>$LANG[Days],'M'=>$LANG[Months],'Y'=>$LANG[Years]);
            define('DateFormat', $LANG[DateFormat]);
            define('DateFormat2',$LANG[DateFormat2]);
            define('TimeStamp',  $LANG[TimeStamp]);

            ($hook = YABPlugin::fetch_hook('user_lang_loaded',__FILE__,__LINE__)) ? eval($hook) : '';

        }

        # account status
        $this->account_status       = $USER[status];
        $this->account_expired      = $account_expired;
        $this->account_expire_date  = $old_group[subscr_fee]=='' ? $LANG["NeverExpired"] : date(DateFormat,$USER[expire_date]);

        ($hook = YABPlugin::fetch_hook('user_load_server',__FILE__,__LINE__)) ? eval($hook) : '';

        # select server based package,note a valid package id is required
        if($this->setting[server]==-2)
        {
            if($this->package_server_id) $this->server_id = $this->package_server_id;
            else $this->setting[server]=0;
        }
        # specify server by admin
        if($this->setting[server]>0)
        {
            $this->server_id = $this->setting[server];
        }

        ($hook = YABPlugin::fetch_hook('user_initiated',__FILE__,__LINE__)) ? eval($hook) : '';
        
        # the last one is random server

        # below code moved function showUploadForm()
        # get upload server details
        # $this->getServer();
	}
    /**
    *get upload method:form upload,ftp upload,url upload
    */
    function getServer()
    {
    global $db,$input;

        ($hook = YABPlugin::fetch_hook('server_loaddetails_start',__FILE__,__LINE__)) ? eval($hook) : '';
                  
        # check available servers
        if($this->setting[site_offline] == 1) return array();
        $this->checkServer();
        # after checking the availablity of server,
        if($this->setting[site_offline] == 1) return array();

        $server = array();
        # sepcify by admin or get it at package based
        if($this->setting[server]>0 || $this->setting[server]==-2)
        {
            if(!is_array($this->upload_servers[$this->server_id]))
            {
                #switch to random selection
                $this->setting[server] = 0;
            }
            else
            {
                $server=$this->upload_servers[$this->server_id];
            }
        }
        # select a server randomly to upload
        if($this->setting[server]==0)
        {
            $server = $this->upload_servers[array_rand($this->upload_servers)];
        }
        # build a server list to select by uploader!
        elseif($this->setting[server]==-1)
        {

            $server = current($this->upload_server);
            $this->server_id = $server[server_id];
        }
        
        ($hook = YABPlugin::fetch_hook('server_loaddetails_end',__FILE__,__LINE__)) ? eval($hook) : '';

        # $this->cgi_upload_url   = $server[http].$server[cgiurl].'/upload.cgi';
        if(defined('PHPUPLOADMODULE')&&PHPUPLOADMODULE==1)
        $this->cgi_upload_url   = $server[http].$server[domain].'/uploading.php';
        else
        $this->cgi_upload_url   = $server[http].$server[cgiurl].($server[iswin]=='yes'?'/upload.cgi':'/upload.cgi');

        $this->php_upload_url   = $server[http].$server[domain].'/uploading.php';
        $this->php_progress_url = $server[http].$server[domain].'/progress.php';

        ($hook = YABPlugin::fetch_hook('server_assignurl_done',__FILE__,__LINE__)) ? eval($hook) : '';

        # no other choice
        $server[cgi_prog_mode] = 'ajax';
        
        return $server;
    }
    /**
    *get upload method:form upload,ftp upload,url upload
    */
    function checkServer()
    {
    global $db,$input;
    
        ($hook = YABPlugin::fetch_hook('server_statuscheck_start',__FILE__,__LINE__)) ? eval($hook) : '';

        if(count($this->servers)==0)
        {
            $this->sendNotify(0,'fatal');
            $this->setting[site_offline] = 1;
        }
        else
        foreach($this->servers as $server)
        {
            if($server[enabled]&&$server[max_webspace]&&$server[webspace]>$server[max_webspace])
            {
                $this->sendNotify(0,'fatal');
                $SET[site_offline] = 1;
                continue;
            }
            if($row[warn_webspace]&&$row[webspace]>$row[warn_webspace])
            {
                $this->sendNotify($row[server_id],'warn');
            }
            if($server[enabled]) $this->upload_servers[$server[server_id]]=$server;
        }
        
        if(count($this->upload_servers)==0)
        {
            $this->sendNotify(0,'fatal');
            $this->setting[site_offline] = 1;
        }
        
        ($hook = YABPlugin::fetch_hook('server_statuscheck_end',__FILE__,__LINE__)) ? eval($hook) : '';

    }
    
    function sendNotify($server_id=0,$type='warn')
    {
    global $db,$email;
        ($hook = YABPlugin::fetch_hook('serverstatus_email_start',__FILE__,__LINE__)) ? eval($hook) : '';

        # load the corssponding template
        $email->template->set_filenames(array(
	         'email' => $type=='warn' ? 'server_warning.html':'server_out.html'
        ));
        # assign global vars
        $email->template->assign_vars(array(
            'SITENAME'=>$this->setting[sitename],
            'EMAIL_SIG'=>$user->setting[emailsign],
        ));
        # build server list
        foreach($this->servers as $row)
        {
            $email->template->assign_block_vars('servers', array(
            'name'=>$row[name],
            'server_id'=>$row[server_id],
            'domain'=>$row[domain],
            'webspace'=>convertsize($row[webspace]),
            'warn_webspace'=>convertsize($row[warn_webspace]),
            'max_webspace'=>convertsize($row[max_webspace]),
            'enabled'=>$row[enabled]==1?'Yes':'No',
            ));
            
            ($hook = YABPlugin::fetch_hook('serverstatus_email_info',__FILE__,__LINE__)) ? eval($hook) : '';

            if($server_id == $row[server_id])
            {
                $email->template->assign_var('server_name',$row['name']);
            }
        }
        # get emails list to send
        $emails   = split(',',$this->setting[servermoniter_emails]);
        $emails[] = $this->setting[adminemail];
        $emails   = array_unique($emails);
        
        ($hook = YABPlugin::fetch_hook('serverstatus_email_sending',__FILE__,__LINE__)) ? eval($hook) : '';

        # sending emails
        foreach($emails as $name)
        {
            $email->to($name,$this->setting[sitename]);
        }
        $email->from($this->setting[adminemail]);
        $email->send('email');
        
        ($hook = YABPlugin::fetch_hook('serverstatus_email_sent',__FILE__,__LINE__)) ? eval($hook) : '';

    }
    /**
	* check this user is baned by IP
    * @return bool
	*/
	function isBanedByIP()
    {
        global $input;
        ($hook = YABPlugin::fetch_hook('user_load_bannedips',__FILE__,__LINE__)) ? eval($hook) : '';

        $this->setting[banip]=str_replace('*','[0-9]{1}',$this->setting[banip]);
        $banip=split(',',$this->setting[banip]);
        foreach($banip as $ip)
        {
           $ip=trim($ip);
           if($ip=='') continue;
           $ban=preg_match("'^$ip$'isx",$input[IP_CLIENT]);

           if($ban)
           {
               ($hook = YABPlugin::fetch_hook('user_is_ipbanned',__FILE__,__LINE__)) ? eval($hook) : '';
               return true;
           }
        }
        
        ($hook = YABPlugin::fetch_hook('user_ipban_pass',__FILE__,__LINE__)) ? eval($hook) : '';

        return false;
	}

    /**
	* update stats for user:uploaded files,used spaces,
	*/
	function updateStats($uid=0) {
    global $db,$input;

        ($hook = YABPlugin::fetch_hook('user_updatestats_start',__FILE__,__LINE__)) ? eval($hook) : '';

        $uid = intval($uid);
        if($uid==0) $uid=$this->uid;
        if($uid==0) return '';
        
        $db->setQuery("select count(f.id) as nums,sum(f.size) as webspace from files as f where f.uid ='$uid' and f.deleted=0");
        $db->query();
        $row=$db->loadRow();
        $db->setQuery("update users set
                       webspace='$row[webspace]',
                       files='$row[nums]',
                       logined_ip='$input[IP_CLIENT]'
                       where id='$uid' ");
        $db->query();
        
        ($hook = YABPlugin::fetch_hook('user_updatestats_done',__FILE__,__LINE__)) ? eval($hook) : '';

        return '';
	}
    /**
	* load setting from system
    * @return bool
	*/
	function loadSetting()
    {
        global $db,$input,$DATASTORE,$LANG,$match_lang,$CODE_TO_LANG,$FileViewerMode,$ShowUploadWindow;
        ## load site setting!
        if(!is_array($DATASTORE[setting]))
        {
            # loading setting table
            $db->setQuery("select * from setting where set_id=1");
            $db->query();
            $SET=$db->loadRow();
            
            unset($SET[admin]);
            unset($SET[pass]);
            unset($SET[pass_salt]);
            unset($SET[admin_ip]);
            
            # store data
            $DATASTORE[setting]  = $SET;
        }
        else
        {
            $SET=$DATASTORE[setting];
        }
        
        # loading plugins
        global $YABPlugin;
        include_once(ROOT.'/includes/plugin.class.php');
        $YABPlugin=& YABPlugin::init();
        if($SET[use_plugin]==1) $YABPlugin->loadfromdb($db);
    
        ($hook = YABPlugin::fetch_hook('sitesetting_loaded',__FILE__,__LINE__)) ? eval($hook) : '';

        ## load all servers!
        if(!is_array($DATASTORE[servers]))
        {
            # loading server table
            $db->setQuery("SELECT * FROM server");
            $db->query();
            $this->servers=$db->loadRowList('server_id');
            # store data
            $DATASTORE[servers]  = $this->servers;
        }
        else
        {
            $this->servers=$DATASTORE[servers];
        }
        
        ($hook = YABPlugin::fetch_hook('siteservers_loaded',__FILE__,__LINE__)) ? eval($hook) : '';

        ## choose a skin
        $oldskin=$this->getValue('myskin');
        # request from url
        if(isset($input[setskin])&&eregi("[a-z0-9]+",$input[setskin])&&is_dir(ROOT.'/skin/'.$input[setskin]))
        {
            if($this->setValue('myskin',$input[setskin]));
            $SET['skin_dir']=$input[setskin];
        }
        # old skin is valid?
        elseif(eregi("[a-z0-9]+",$oldskin)&&is_dir(ROOT.'/skin/'.$oldskin))
        {
            $SET['skin_dir']=$oldskin;
        }
        
        ($hook = YABPlugin::fetch_hook('siteskin_loaded',__FILE__,__LINE__)) ? eval($hook) : '';

        # include language
        if(IN_MAIN_SERVER)
        {
            ($hook = YABPlugin::fetch_hook('user_lang_loading',__FILE__,__LINE__)) ? eval($hook) : '';

            ## choose a language
            $oldlang=$this->getValue('mylang');
            if(in_array($input[setlang],array_keys($CODE_TO_LANG))&&is_dir(ROOT.'/language/'.$CODE_TO_LANG[$input[setlang]]))
            {
                $SET[language] = $CODE_TO_LANG[$input[setlang]];
                # record the selected lang
                $this->setValue('mylang',$input[setlang]);
            }
            elseif(in_array($oldlang,array_keys($CODE_TO_LANG))&&is_dir(ROOT.'/language/'.$CODE_TO_LANG[$oldlang]))
            {
                $SET[language] = $CODE_TO_LANG[$oldlang];
            }

            ## choose by browser
            if($SET[language]==-1)
            {
                $SET[language] = $this->guess_lang();
                # record the selected lang
                $this->setValue('mylang',array_search($SET[language],$CODE_TO_LANG));
            }

            # if the language is not available, exit ?
            if(!file_exists(ROOT.'/language/'.$SET[language].'/lang.php'))
            {
                $SET[language]='english';
                $this->setValue('mylang','en');
            }
            $this->langcode = array_search($SET[language],$CODE_TO_LANG);

            ($hook = YABPlugin::fetch_hook('sitelang_loaded',__FILE__,__LINE__)) ? eval($hook) : '';
        }

        $modes = @explode(',', $SET[fileviewermode]);
        while (list($key, $val) = each($FileViewerMode))
        {
            $FileViewerMode[$key] = $modes[$key-1];
        }

        $ShowUploadWindow = $SET[show_upload_window];

        #############################
        $SET[rewardpoint] = 'uploader';
        #############################

        return $SET;
	}
    function guess_lang()
	{
	global $HTTP_SERVER_VARS,$COUNTRY_CODE_TO_MATCH_LANG;

		// The order here _is_ important, at least for major_minor
		// matches. Don't go moving these around without checking with
		// me first - psoTFX
        ($hook = YABPlugin::fetch_hook('sitelang_guess_start',__FILE__,__LINE__)) ? eval($hook) : '';

		if (isset($HTTP_SERVER_VARS['HTTP_ACCEPT_LANGUAGE']))
		{
			$accept_lang_ary = explode(',', $HTTP_SERVER_VARS['HTTP_ACCEPT_LANGUAGE']);
			for ($i = 0; $i < sizeof($accept_lang_ary); $i++)
			{
				@reset($COUNTRY_CODE_TO_MATCH_LANG);
				while (list($lang, $match) = each($COUNTRY_CODE_TO_MATCH_LANG))
				{
					if (preg_match('#' . $match . '#i', trim($accept_lang_ary[$i])))
					{
						if (is_file('language/' . $lang . '/lang.php'))
						{
							return $lang;
						}
					}
				}
			}
		}
  
        ($hook = YABPlugin::fetch_hook('sitelang_guess_end',__FILE__,__LINE__)) ? eval($hook) : '';

		return 'english';
    }
    /**
	* set value for user class:cookie or session
	*/
	function setValue($name,$value)
    {
        $this->$name = $value;
        if($this->running_type=='cookie')
        {
            return @setCookies($name,$value);
        }
        else
        {
            $_SESSION[$name]=$value;
        }
	}

    /**
	* get value for user class:cookie or session
	*/
	function getValue($name)
    {
        if($this->running_type=='cookie')
        return getCookies($name);
        else
        return $_SESSION[$name];
	}

    /**
	* user login method
    * @return status of user:1:active,0:unconfirmed,-1:suspended,4:not found
	*/
	function login($username,$md5password,$autologin=1)
    {
    global $db,$input;

        ($hook = YABPlugin::fetch_hook('user_login_start',__FILE__,__LINE__)) ? eval($hook) : '';

        $db->setQuery("select * from users where user='".$db->getEscaped($username)."' and pass='".($db->getEscaped($md5password))."'");
        $db->query();
        if($db->getNumRows()==1)
        {
            $row=$db->loadRow();
            if($row[status]==1)
            {
                $this->setValue('logined',1);
                $this->setValue('uid',$row[id]);
                $this->setValue('passhash',($md5password));
                $this->setValue('last_click',time());
                $this->setValue('mylang',$row[lang]);
                $this->setValue('autologin',$autologin);

                # on login
                $nowtime = time();
                $db->setQuery("update users set last_login='$nowtime',logined_ip='$input[IP_CLIENT]' where id='$row[id]' limit 1");
                $db->query();
           }

           ($hook = YABPlugin::fetch_hook('user_is_logined',__FILE__,__LINE__)) ? eval($hook) : '';

           return $row[status];
       }
       else
       {
           ($hook = YABPlugin::fetch_hook('user_login_failed',__FILE__,__LINE__)) ? eval($hook) : '';

           return 4;
       }
	}
    /**
	* user login method
    * @return status of user:1:active,0:unconfirmed,-1:suspended,4:not found
	*/
	function logout()
    {
    global $db,$input;
         ($hook = YABPlugin::fetch_hook('user_logout_start',__FILE__,__LINE__)) ? eval($hook) : '';

         $this->setValue('logined',0);
         $this->setValue('uid',0);
         $this->setValue('passhash','');
         $this->setValue('last_click',time());
         $this->setValue('autologin',0);
         
         ($hook = YABPlugin::fetch_hook('user_logout_end',__FILE__,__LINE__)) ? eval($hook) : '';
	}
    /**
    *check this user with such email available
    */
    function checkAvailable($username,$useremail)
    {
    global $db;
        ($hook = YABPlugin::fetch_hook('user_check_available',__FILE__,__LINE__)) ? eval($hook) : '';

        if($username==''||$useremail=='') return false;
        $db->setQuery("select * from users where user='$username' or email='$useremail'");
        $db->query();
        if($db->getNumRows())
        {
            ($hook = YABPlugin::fetch_hook('user_exists',__FILE__,__LINE__)) ? eval($hook) : '';
            return false;
        }
        else
        {
            ($hook = YABPlugin::fetch_hook('user_is_available',__FILE__,__LINE__)) ? eval($hook) : '';
            return true;
        }
    }

    /**
    *check password for this user
    */
    function loadUserDetails($username,$useremail)
    {
    global $db;
       ($hook = YABPlugin::fetch_hook('loaduser_start',__FILE__,__LINE__)) ? eval($hook) : '';

       if(!empty($username))
       $db->setQuery("select * from users where user='$username'");
       elseif(!empty($useremail))
       $db->setQuery("select * from users where email='$useremail'");
       else return -1;
       $db->query();
       if($db->getNumRows()==0)
       {
           ($hook = YABPlugin::fetch_hook('loaduser_fail',__FILE__,__LINE__)) ? eval($hook) : '';
           return -1;
       }
       $row=$db->loadRow();
       
       ($hook = YABPlugin::fetch_hook('loaduser_ok',__FILE__,__LINE__)) ? eval($hook) : '';

       return $row;
    }
    /**
    * build nice package information for users and output
    */
    function showProfile()
    {
    global $template,$LANG_TO_CODE;

        ($hook = YABPlugin::fetch_hook('build_packageinfo_data',__FILE__,__LINE__)) ? eval($hook) : '';

        $lang_list = '';
        if ($dh = opendir("language/")) {
           while (($file = readdir($dh)) !== false)
           {
              if ($file != '..' && $file != '.'&& strlen($LANG_TO_CODE[$file]) && is_dir("language/".$file))
              {
                  $lang_list .= '<option value="'.$LANG_TO_CODE[$file].'" '.($this->lang==$LANG_TO_CODE[$file]?' selected':'').'>'.ucfirst($file).'</option>';
              }
           }
           closedir($dh);
        }

        $template->assign_vars(array(
        'hosted_webspace'=> convertsize($this->webspace),
        'max_webspace'=>convertsize($this->allowed_max_webspace),
        'hosted_files'=>$this->hosted_files,
        'total_downloads'=>$this->total_downloads,
        'total_points'=>$this->total_points,
        'last_update'=>date(DateFormat,$this->last_update),
        'last_login'=>date(DateFormat,$this->last_login?$this->last_login:time()),
        'logined_ip'=>$this->logined_ip,
        'account_reg_date'=>date(DateFormat,$this->reg_date),
        'package_name'=>$this->package,
        'is_custom'=>$this->is_custom,
        'account_expire_date'=>$this->account_expire_date,
        'account_expired'=>$this->account_expired,
        'username'=>$this->username,
        'user_langlist' => $lang_list,
        'user_paypal' => $this->paypal,
        'user_adsenseid' => $this->adsense_id,
        'user_balance' => sprintf("%0.2f",$this->balance),
        ));
    }
}
?>
