<?
/*
+--------------------------------------------------------------------------
|   Auto installer v1.0
|   ========================================
|   by Stephen Yabziz
|   (c) 2005 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: ywyhnchina@163.com
+---------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 7th Jan 2006
+--------------------------------------------------------------------------
*/
if(!function_exists('parse_incoming'))
{
function parse_incoming()
{
  	global $_GET, $_POST, $HTTP_CLIENT_IP, $REQUEST_METHOD, $REMOTE_ADDR, $HTTP_PROXY_USER, $HTTP_X_FORWARDED_FOR;
   	$return = array();

	if( is_array($_GET) )
	{
		while( list($k, $v) = each($_GET) )
		{

			if( is_array($_GET[$k]) )
			{
				while( list($k2, $v2) = each($_GET[$k]) )
				{
					$return[$k][ clean_key($k2) ] =clean_value($v2);
				}
	     	}
			else
			{
				$return[ clean_key($k) ] =clean_value($v);
			}
		}
	}

	// Overwrite GET data with post data

	if( is_array($_POST) )
	{
		while( list($k, $v) = each($_POST) )
        {
    		if ( is_array($_POST[$k]) )
			{
				while( list($k2, $v2) = each($_POST[$k]) )
				{
					$return[$k][ clean_key($k2) ] =clean_value($v2);
				}
			}
			else
			{
				$return[ clean_key($k) ]  =clean_value($v);
			}
		}
	}
    $return['REQUEST_METHOD']=$_SERVER['REQUEST_METHOD'];
    $return['IP_ADDRESS']=$_SERVER['SERVER_ADDR'];
    $return['IP_CLIENT']=$_SERVER['REMOTE_ADDR'];
	return $return;
}
function clean_key($key)
{
  	return $key;
}
function clean_value($val)
{
    if ( get_magic_quotes_gpc()!=0 )
    {
        $val = stripslashes($val);
   	}
  	return $val;
}
}
function printHeader($group)
{
    echo "<table cellSpacing=1 cellPadding=2 width=80% align=center class=tableborder>\n<tr><td colspan=2 align=center class=titlerow>$group</td></tr>\n";
}
function printRow($row)
{
    if($row[type]=='hidden') return false;
    $Field=array(
    'Type' =>$row[type],
    'Value'=>$row[value],
    'Field' =>$row[name],
    );
    echo "<tr><td class=tdrow1 width=40%>$row[descr]</td><td class=tdrow2 width=60%>".buildField($Field)."</td></tr>\n";
}
function printFooter()
{
    echo "</table>\n";
}
function buildField($Field)
{
    /*
    Text field show on pages
    */
    if($Field[Type]=='label')
    {
        #add/mod field code
        $code="$Field[Value]";
    }

    /*
    Text field show on pages
    */
    if($Field[Type]=='text')
    {
        #add/mod field code
        $code="<input type=text size=40 name='$Field[Field]' class=textinput value='$Field[Value]'>";
    }

    /*
    Textarea field show on pages
    */
    if($Field[Type]=='textarea')
    {
        $code="<textarea cols=40 rows=6 name='$Field[Field]'>$Field[Value]</textarea>";
    }
    /*
    select box field show on pages
    */
    if($Field[Type]=='select')
    {
        $type=str_replace("'",'',$Field[Value]);
        $options=split(',',$type );
        $select='';
        $code='<select>';
        foreach($options as $option)
        {
            list($value,$text)=split('=',$option);
            if(!strlen($text)) $text=$value;
            $code.="<option value='$value'>$text</option>";
        }
        $code.='</select>';
    }
    /*
     radios field show on pages
    */
    if($Field[Type]=='radio')
    {
        $type=str_replace("'",'',$Field[Value]);

        $options=split(',',$type );
        $radios='';
        foreach($options as $option)
        {
            list($value,$text)=split('=',$option);
            if(!strlen($text)) $text=$value;
            $code.="<input type=radio name='$Field[Field]' value='$value'>$text";
        }
    }
    return $code;
}
function printMsg($title,$text)
{
    echo "<table cellSpacing=1 cellPadding=2 width=80% align=center class=tableborder>\n<tr><td colspan=2 align=center class=titlerow>$title</td></tr>\n";

    echo "<tr><td class=info width=100%>$text</td></tr>\n";

    echo "</table>\n";
}
?>
