<?
/*
+--------------------------------------------------------------------------
|   Auto installer v1.0
|   ========================================
|   by Stephen Yabziz
|   (c) 2005 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: ywyhnchina@163.com
+---------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 7th Jan 2006
+--------------------------------------------------------------------------
*/
//include "../../includes/inc.php";
include "../includes/inc.php";
include "includes/upgrade.php";
include "includes/form.inc.php";

define('LATEST_VERSION','1.5');

$product       = 1;
$need_account_register = 1;
$need_register = 0;

$candroptable = isset($input['droptable'])?intval($input['droptable']):$_COOKIE['droptable'];
/**
* load the install class
*/
$upgrade =new upgrade('includes/upgrade.ini');
$upgrade->assignVars($input);

if(strlen($input[version]))$upgrade->setUpgradeIni($input[version]);

$step = isset($input[step])?intval($input[step]):0;
if(isset($input['continue'])&&!isset($input[substep])) $step=$step+1;
if(isset($input['back'])&&(!isset($input[substep])||$input[substep]=='STEP1')) $step=$step-1;

$inis = $upgrade->checkUpgradeIni();
if(!is_array($inis)&&$step==1&&isset($input['back'])) $step=0;
$upgrade->step = $step;

/**
* lock the installer!
*/
if(file_exists('upgrade.locked')) $upgrade->step = $step = -1;
$db->setQuery("select * from setting where set_id=1");
$db->query();
$SET = $db->loadRow();
if(LATEST_VERSION==$SET[mfhs_version]) $upgrade->step = $step = -2;

require 'includes/header2.html';
switch($upgrade->step)
{
   /**
   * Step -2
   */
   case '-2' :
   printMsg('Upgrade finished','You are using the latest version:'.LATEST_VERSION);
   break;
   /**
   * Step -1
   */
   case '-1' :
   $upgrade->execINC($upgrade->step,'start');

   $upgrade->printFormHeader();
   printMsg($upgrade->lang['welcome_title'],$upgrade->lang['installer_locked']);
   $upgrade->printFormFooter();
   break;
   /**
   * Step 0:welcome message
   */
   case '0' :
   $upgrade->execINC($install->step,'start');
   
   $upgrade->printFormHeader('');
   printMsg($upgrade->lang['welcome_title'],$upgrade->lang['welcome_text']);
   $upgrade->printFormFooter();

   break;
   /**
   * Step 1:check upgrade ini file
   */
   case '1' :
   $inis = $upgrade->checkUpgradeIni();
   // make choices if auto deciding version fails
   if(is_array($inis))
   {
       $upgrade->printFormHeader();
       printHeader($upgrade->lang['welcome_title']);
       foreach($inis as $version=>$ini)
       {
           $row[value]=$version.'='.$ini;
           $row[type] ='radio';
           $row[name] ='version';
           $row[descr]='version '.$version;
           printRow($row);
       }
       printFooter();
       $upgrade->printFormFooter();
       break;
   }
   elseif($inis==-1)
   {
       printMsg('Upgrade finished','You are using the latest version:'.LATEST_VERSION);
   }
   else
   {
       $input[version]=$inis;
       $upgrade->step = $upgrade->step + 1;
   }

   /**
   * Step 2
   */
   case '2' :
   $upgrade->execINC($install->step,'start');

   $upgrade->setUpgradeIni($input[version]);

   $upgrade->detectENV();
   $upgrade->printFormHeader();
   if($upgrade->results)
   {
       foreach($upgrade->results as $type=>$results)
       {
           printHeader($upgrade->lang[$type]);
           foreach($results as $row)
           {
               $row[value]=$row[status]==1?'<font color=blue>'.$row[descr].'</font>':'<font color=red>Warning:'.$row[descr].'</font>';
               $row[type] ='label';
               $row[descr]=$row[name];
               printRow($row);
           }
           printFooter($type);
       }
       $upgrade->printFormFooter();
       break;
   }
   else
   {
       printMsg($upgrade->lang['welcome_title'],$upgrade->lang['welcome_text']);
   }
   $upgrade->printFormFooter();
   $upgrade->execINC($upgrade->step,'end');
   break;
   /**
   * Step 4:write config files,excute sql query
   */
   case '3' :
   $upgrade->execINC($upgrade->step,'start');

   #$sql_database = 'mfhs11';
   
   $input[sqlhost] = $sql_host;
   $input[sqldb]   = $sql_database;
   $input[sqluser] = $sql_user;
   $input[sqlpass] = $sql_pass;

   $upgradesteps = $upgrade->getSection('UPGRADESTEP');
   $totalsteps   = count($upgradesteps);
   $substep_id   = intval(substr($input[substep],4));
   if(isset($input['continue'])) $substep_id   = $substep_id+1;
   if(isset($input['back'])) $substep_id   = $substep_id-1;
   if($substep_id<=0) $substep_id = 1;

   $substep      = 'STEP'.$substep_id;
   $upgrade_core = $upgrade->getSection($substep);

   if($substep_id<=$totalsteps&&is_array($upgrade_core))
   {
       $upgrade->substep = $substep;
       
       # start inc
       $upgrade->execSubINC($substep,'start');
       /**
       * mysql upgrade
       */
       if($upgrade_core[sqlfile])
       {
           $sql_errors=$sql_details='';
           if(!@mysql_connect( $input[sqlhost], $input[sqluser], $input[sqlpass] ))
           {
               $sql_errors =( 'FATAL ERROR: Connection to database server failed.'.mysql_error().'<br>');
           }
	       if(!@mysql_select_db($input[sqldb]))
           {
               $sql_errors .=("FATAL ERROR: Database not found. Operation failed with error: ".mysql_error());
           }
           if(strlen($sql_errors)==0)
           {
               $support_charset = strcmp (mysql_get_server_info(),'4.1')>=0;
               $support_engine  = strcmp (mysql_get_server_info(),'4.0.18')>=0;

               $SQL=$upgrade->execSubSQLFile($substep);

               if($SQL)
               foreach($SQL as $query)
               {
                   $query=trim($query);
                   $parts=split("\n",$query);
                   $act=strtolower(substr($query,0,6));
                   if($act=='create')
                   {
                       if(!$support_charset)
                       {
                           $query = preg_replace('/DEFAULT\s*CHARSET=([^\s]*)/isx','',$query);
                           $query = preg_replace('/character\s*set\s*([^\s]*)/isx','',$query);
                       }
                       if(!$support_engine)
                       {
                           $query = preg_replace('/ENGINE\s*=/isx','TYPE=',$query);
                       }
                       preg_match("'create\s*table\s*([\`])?(?(1) (.*?)\\1 | ([^\s]+))'isx",$query,$match);
                       $table=$match[1]=='`'?$match[2]:$match[3];
                   }
                   if($act=='insert')
                   {
                       preg_match("'insert\s*into\s*([\`])?(?(1) (.*?)\\1 | ([^\s]+))'isx",$query,$match);
                       $table=$match[1]=='`'?$match[2]:$match[3];
                   }
                   if($act=='update')
                   {
                       preg_match("'update\s*([\`])?(?(1) (.*?)\\1 | ([^\s]+))'isx",$query,$match);
                       $table=$match[1]=='`'?$match[2]:$match[3];
                   }
                   if($act=='delete')
                   {
                       preg_match("'delete\s*from\s*([\`])?(?(1) (.*?)\\1 | ([^\s]+))'isx",$query,$match);
                       $table=$match[1]=='`'?$match[2]:$match[3];
                   }
                   if(substr($act,0,5)=='alter')
                   {
                       if(!$support_charset&&eregi('CHARACTER SET',$query)&&ereg('CHANGE COLUMN',$query))
                       {
                           continue;
                       }
                   
                       $pure_match = array();
                       preg_match("'alter\s*table\s*([\`])?(?(1) (.*?)\\1 | ([^\s]+))\s*([^\s]+)\s*([\`])?(?(5) (.*?)\\5 | ([^\s]+))'isx",$query,$match);
                       foreach($match as $k=>$v)
                       {
                           if(!$v||$v=='`') continue;
                           $pure_match[] = $v;
                       }
                       $table  = $pure_match[1];
                       $subact = strtolower($pure_match[2]);
                       $field  = $pure_match[3];
                       $act    = 'alter';
                   }
                   if(!@mysql_query($query))
                   {
                       $errorline    = '<font color=red>'.mysql_error()."</font>\n";
                       if($candroptable==1&&$act=='create')
                       {
                           if(!mysql_query('DROP TABLE '.$table)){
                           $errorline   = '<font color=red>'.mysql_error().'</font>DROP TABLE '.$table."\n";
                           $sql_errors .= $errorline;
                           $sql_details.= $errorline;
                           }
                           else {
                           mysql_query($query);
                           $sql_details .= "Table '$table' droped\n";
                           }
                       }
                       else
                       {
                           $sql_errors  .= $errorline;
                           $sql_details .= $errorline;
                       }
                   }
                   elseif(in_array($act,array('create','insert','update','delete','alter')))
                   {
                       if($act!='alter')
                       $sql_details .= ucfirst($act)." table '".$table."' sucessfullly\n";
                       else
                       $sql_details .= "'".$field. "' of table '".$table."' ".ucfirst($subact)." sucessfullly\n";
                   }
               }
           }
           if(strlen($sql_errors)==0)
           {
               /**
               * print the sql query details to screen
               */
               if(strlen($sql_details))printSQLResults($sql_details);
           }
           else
           {
               printMsg($upgrade->lang['msg_title'],nl2br($sql_errors));
           }
           $upgrade->printFormHeader();
           printMsg($upgrade->evalLang($upgradesteps[$substep]),$upgrade->evalLang($upgrade_core['info']));
           $upgrade->printFormFooter();
       }
       # end inc
       $upgrade->execSubINC($substep,'end');
   }
   else
   {
       //printMsg($upgrade->lang['db_updated'],$upgrade->lang['install_ok']);
   }
   $upgrade->execINC($install->step,'end');
   if($substep_id<=$totalsteps) break;
   $upgrade->step = $upgrade->step + 1;
   /**
   * Step 5:last step,finish the install and lock the installer
   */
   case '4' :
   $upgrade->execINC($upgrade->step,'start');

   $db->setQuery("update setting set mfhs_version='$upgrade->version' where set_id=1");
   $db->query();
   
   fopen('upgrade.locked','wb');
   printMsg($upgrade->lang['msg_title'],$upgrade->lang['installer_locked']);
   $upgrade->execINC($upgrade->step,'end');
   break;

}

require 'includes/footer2.html';
?>
<?
function printRegisterForm()
{
global $upgrade,$need_account_register,$show_domain,$text;

   $upgrade->printFormHeader();
   if($need_account_register)
   {
       $row = array(
       'value' => $input[username],
       'type'  =>'text',
       'name'  =>'username',
       'descr' =>'Username',
       );
       printRow($row);
       $row = array(
       'value' => $input[password],
       'type'  =>'text',
       'name'  =>'password',
       'descr' =>'Password',
       );
       printRow($row);
   }
   printFooter();
   $upgrade->printFormFooter();
}
function printSQLResults($details)
{
    $details=nl2br($details);
    echo "<table width=80% cellSpacing=1 cellPadding=2 align=center class=tableborder>\n<tr><td align=center class=titlerow>SQL Results:</td></tr>\n";

    echo "<tr><td class=tdrow1 width=100%><a name=1><a href='#1' onclick='showhide(\"details\")'><b>Show mysql query details</b></a><div id=details class=info style='display:none'>$details";

    echo "</div></td></tr>\n</table>\n";
}
function printCFGResults($details)
{
    echo "<table width=80% cellSpacing=1 cellPadding=2 align=center class=tableborder>\n<tr><td align=center class=titlerow>Config Results:</td></tr>\n";

    foreach($details as $file=>$content)
    {
        $i++;
        $content=highlight_string($content,1);
        echo "<tr><td class=tdrow1 width=100%><a name=1></a><b>$file</b>:<a href='#1' onclick='showhide(\"details$i\")'><b>Show file contents</b></a><div id=details$i class=info style='display:none'>$content</div></td></tr>\n";
    }

    echo "</table>\n";
}
?>
