CREATE TABLE `admin_menus` (
  `menu_id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(64) default NULL,
  `parent_id` int(11) default '0',
  `url` varchar(128) default NULL,
  `urltarget` tinyint(4) default NULL,
  `admin` varchar(32) default NULL,
  `allow_actions` varchar(255) default NULL,
  `split` tinyint(1) default '0',
  `hint` varchar(255) default NULL,
  `icon` varchar(128) default NULL,
  `big_icon` varchar(128) default NULL,
  `orders` int(11) default NULL,
  `group_id` int(11) default NULL,
  PRIMARY KEY  (`menu_id`)
) TYPE=MyISAM;
INSERT INTO `admin_menus` VALUES (1,'Home',0,'index.php',0,NULL,NULL,1,'Control Panel','css/Theme/home.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (2,'Site',0,'',0,NULL,NULL,1,'Site Management','css/Theme/controlpanel.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (3,'Files',0,'',0,NULL,NULL,1,'Files Management','css/Theme/folder.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (4,'Host Package',0,'',0,NULL,NULL,1,'Host Package','css/Theme/users.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (5,'Members',0,'',0,NULL,NULL,1,'Members Management','css/Theme/user.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (6,'Servers',0,'?admin=server',0,NULL,NULL,1,'Servers Management','css/Theme/computer.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (7,'Crontabs',0,'',0,NULL,NULL,1,'Manage Crontabs','css/Theme/cronjob.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (8,'Billing',0,'',0,NULL,NULL,1,'Billing','css/Theme/transactions.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (9,'Template & Language',0,'',0,NULL,NULL,1,'Template','css/Theme/template.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (10,'Tools',0,'',0,NULL,NULL,1,'Site Tools','css/Theme/toolbox.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (11,'Help',0,'',0,NULL,NULL,0,'Site Help','css/Theme/help.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (12,'Configuration',2,'?admin=set',0,NULL,NULL,0,'Configuration','css/Theme/controlpanel.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (13,'Site Ads',2,'?admin=siteads',0,NULL,NULL,0,'Change/Edit Site Ads','css/Theme/template.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (14,'News System',2,'?admin=news',0,NULL,NULL,0,'Manage news','css/Theme/news.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (15,'Newsletter',2,'?admin=newsletter',0,NULL,NULL,0,'Mange Newsletter','css/Theme/mass_email.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (16,'FAQ Manager',2,'?admin=faqs',0,NULL,NULL,0,'Manage FAQS','css/Theme/package.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (18,'Files',3,'?admin=images',0,NULL,NULL,0,'List/Search/Delete Files','css/Theme/files.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (19,'Top Downloads Files',18,'?admin=images&img_orderby=f.downloads&img_AD=DESC&search=1',0,NULL,NULL,0,'List Top Downloads Files','css/Theme/favorits.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (20,'Validated Files',18,'?admin=images&img_filter=validated&search=1',0,NULL,NULL,0,'List Validated Files','css/Theme/checkin.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (21,'Deleted Files',18,'?admin=images&img_filter=deleted&search=1',0,NULL,NULL,0,'List Deleted Files','css/Theme/trash.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (22,'Download',3,'',0,NULL,NULL,0,'File Download','css/Theme/download.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (23,'Sessions',22,'?admin=dlsessions',0,NULL,NULL,0,'List download sessions','css/Theme/package.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (24,'History',22,'?admin=dlhistory',0,NULL,NULL,0,'List download history','css/Theme/history.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (25,'Reports',3,'?admin=report',0,NULL,NULL,0,'Process Reports','css/Theme/checkin.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (26,'Prune',3,'?admin=imgprune',0,NULL,NULL,0,'Prune Files','css/Theme/trash.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (27,'List Package',4,'?admin=group',0,NULL,NULL,0,'Add/Edit/Delete Package','css/Theme/users.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (28,'Reward Center',4,'?admin=promotion',0,NULL,NULL,0,'Reward Center','css/Theme/dollar.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (29,'Download Rules',4,'?admin=rule',0,NULL,NULL,0,'Mange Download Rules','css/Theme/download.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (30,'Package Template',4,'?admin=showtemplate',0,NULL,NULL,0,'Customise Package Template','css/Theme/template.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (31,'List Members',5,'?admin=user',0,NULL,NULL,0,'Search/Edit/Add Members','css/Theme/user.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (32,'Add Member',5,'?admin=user&act=add',0,NULL,NULL,0,'Add Members','css/Theme/user_add.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (33,'Points History',5,'?admin=points',0,NULL,NULL,0,'Mange Points History','css/Theme/money.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (34,'Crontabs',7,'?admin=crontab',0,NULL,NULL,0,'Crontabs Setting','css/Theme/cronjob.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (35,'Crontab Logs',7,'?admin=cronlog',0,NULL,NULL,0,'View Crontab Logs','css/Theme/history.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (36,'Transactions',8,'?admin=payment',0,NULL,NULL,0,'View Transactions','css/Theme/transactions.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (37,'Gateway Setting',8,'?admin=gateway',0,NULL,NULL,0,'Setup Payment Gateway','css/Theme/config.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (38,'Template Manager',9,'?admin=template',0,NULL,NULL,0,'Add/Edit/Download Template','css/Theme/template.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (39,'Language Manager',9,'?admin=lang',0,NULL,NULL,0,'Edit/Export Language','css/Theme/language.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (40,'Email Template',9,'?admin=emails',0,NULL,NULL,0,'Configure Email Template','css/Theme/mass_email.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (41,'Backup Database',10,'?admin=backup',0,NULL,NULL,0,'Backup/Email Database','css/Theme/folder_down.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (42,'Database Restore',10,'?admin=restore',0,NULL,NULL,0,'Restore Backup','css/Theme/folder_up.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (43,'Maintain Database',10,'?admin=maintain',0,NULL,NULL,0,'Maintain Database','css/Theme/config.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (44,'Admin Menus',10,'?admin=menu',0,NULL,NULL,0,'Maitain Site Menus','css/Theme/menu.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (45,'Site Plugins',10,'?admin=plugins',0,NULL,NULL,0,'Manage Site Plugins','css/Theme/apps.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (46,'Support forum',11,'http://yabsoft.com/forum/',1,NULL,NULL,0,'Support forum','css/Theme/forum.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (47,'File Links Codes',2,'?admin=link',0,NULL,NULL,0,'Mange Files Links Code Templates','css/Theme/link.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (48,'Show All Files',18,'?admin=images&search=1',0,NULL,NULL,0,'Show All Uploaded Files','css/Theme/files.png','',0,NULL);
CREATE TABLE `links` (
  `id` tinyint(6) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `unique_id` varchar(32) default NULL,
  `code` mediumtext NOT NULL,
  `filetype` mediumtext NOT NULL,
  `enable` tinyint(1) NOT NULL default '1',
  `ordering` tinyint(6) default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
INSERT INTO `links` VALUES (1,'Website Code','WEBSITECODE','{FILENAME}<br><a href=\"{FILEURL}\" target=\"_blank\"><img src=\"{THUMBURL}\" alt=\"Free Filehosting At {SITENAME}\"/></a>','all',1,0);
INSERT INTO `links` VALUES (2,'Forum Code','FORUMCODE','{FILENAME}:\r\n[URL={FILEURL}][IMG]{THUMBURL}[/IMG][/URL]','all',1,0);
INSERT INTO `links` VALUES (3,'Download Url','DOWNLOADURL','{FILENAME}:{FILEURL}','all',1,0);
INSERT INTO `links` VALUES (4,'Share Link','SHARELINK','{FILENAME}:{SHAREURL}','all',1,0);
ALTER TABLE `crontabs` ADD `code_id` varchar(128)  DEFAULT NULL;
ALTER TABLE `crontabs` ADD `descr` text  DEFAULT NULL;
ALTER TABLE `dlsessions` ADD `file_uid` int(11)  DEFAULT NULL;
ALTER TABLE `downloadrules` ADD `dl_filesizes` varchar(255)  DEFAULT NULL;
ALTER TABLE `files` ADD `upload_method` tinyint(4)  DEFAULT NULL;
ALTER TABLE `hookpoint` ADD `file` varchar(255)  DEFAULT NULL;
ALTER TABLE `hookpoint` ADD `line` int(11)  DEFAULT NULL;
ALTER TABLE `plugins` ADD `unique_id` varchar(64)  DEFAULT NULL;
ALTER TABLE `server` ADD `keep_ext` enum('yes','no')  DEFAULT 'no';
ALTER TABLE `server` ADD `keep_name` enum('yes','no')  DEFAULT 'no';
ALTER TABLE `server` ADD `lighttpd_url` varchar(255)  DEFAULT NULL;
ALTER TABLE `server` ADD `allow_download` tinyint(1)  DEFAULT '1';
ALTER TABLE `server` ADD `formupload_type` enum('cgi','php')  DEFAULT 'cgi';
ALTER TABLE `setting` ADD `mulurlupload` tinyint(3)  DEFAULT '1';
ALTER TABLE `setting` ADD `mulftpupload` tinyint(3)  DEFAULT '1';
ALTER TABLE `setting` ADD `last_build` int(11)  DEFAULT NULL;
ALTER TABLE `setting` ADD `smtp_host` varchar(128)  DEFAULT NULL;
ALTER TABLE `setting` ADD `smtp_port` int(4)  DEFAULT NULL;
ALTER TABLE `setting` ADD `smtp_user` varchar(64)  DEFAULT NULL;
ALTER TABLE `setting` ADD `smtp_pass` varchar(64)  DEFAULT NULL;
ALTER TABLE `setting` ADD `use_smtp` tinyint(1)  DEFAULT '0';
ALTER TABLE `setting` ADD `backup_dir` varchar(255)  DEFAULT '../backup';
ALTER TABLE `setting` ADD `reuse_code` tinyint(1)  DEFAULT '1';
ALTER TABLE `setting` ADD `use_plugin` tinyint(1)  DEFAULT '0';
ALTER TABLE `users` ADD `logined_ip` varchar(32)  DEFAULT NULL;
ALTER TABLE `users` ADD `lang` varchar(4)  DEFAULT 'en';
ALTER TABLE `downloadrules` CHANGE `dl_points` `dl_points` varchar(255)  DEFAULT NULL;
ALTER TABLE `files` CHANGE `file` `file` varchar(250) NOT NULL DEFAULT '';
ALTER TABLE `groups` CHANGE `subscr_unit` `subscr_unit` varchar(255)  DEFAULT 'M';
ALTER TABLE `hooks` CHANGE `name` `name` varchar(128)  DEFAULT NULL;
ALTER TABLE `server` CHANGE `hosted` `hosted` bigint(19)  DEFAULT '0';
ALTER TABLE `setting` CHANGE `language` `language` varchar(32)  DEFAULT '-1';
ALTER TABLE `setting` CHANGE `cached` `cached` tinyint(3)  DEFAULT '0';
ALTER TABLE `setting` CHANGE `allow_php` `allow_php` tinyint(1)  DEFAULT '0'
