CREATE TABLE `admin` (
  `admin_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `username` varchar(64) DEFAULT NULL,
  `password` varchar(32) DEFAULT NULL,
  `pass_salt` char(3) DEFAULT NULL,
  `adminemail` varchar(255) DEFAULT NULL,
  `last_reset` int(11) DEFAULT NULL,
  `last_click` int(11) DEFAULT NULL,
  `last_login` int(11) DEFAULT NULL,
  `last_stats` int(11) DEFAULT NULL,
  `login_ip` varchar(32) DEFAULT NULL,
  `fail_times` int(11) DEFAULT NULL,
  `last_fail` int(11) DEFAULT NULL,
  `admin_gid` int(11) DEFAULT NULL,
  PRIMARY KEY (`admin_id`)
) TYPE=MyISAM;
CREATE TABLE `admin_groups` (
  `gid` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `descr` text,
  `last_update` int(11) DEFAULT NULL,
  PRIMARY KEY (`gid`)
) TYPE=MyISAM;
CREATE TABLE `bannedfiles` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `fileids` varchar(255) NOT NULL,
  `md5_hash` varchar(32) DEFAULT NULL,
  `filesize` bigint(19) DEFAULT NULL,
  `descr` text,
  PRIMARY KEY (`id`)
) TYPE=MyISAM;
CREATE TABLE `tags` (
  `tag_id` int(6) unsigned NOT NULL AUTO_INCREMENT,
  `tag_name` varchar(64) DEFAULT NULL,
  `tag_times` int(11) DEFAULT NULL,
  `tag_synonym` varchar(255) DEFAULT NULL,
  `tag_matches` text,
  PRIMARY KEY (`tag_id`),
  UNIQUE KEY `NewIndex` (`tag_name`)
) TYPE=MyISAM;
UPDATE `admin_menus` SET group_id = 1;
INSERT INTO `admin_groups` (`gid`,`name`,`descr`,`last_update`) VALUES (1,'Administrator','Full Priviliges!',NULL);
INSERT INTO `admin_groups` (`gid`,`name`,`descr`,`last_update`) VALUES (2,'Moderators','Retricted Access to Admin Panel!',NULL);
ALTER TABLE `downloadhistory` ADD `points2` int(11)  DEFAULT NULL;
ALTER TABLE `downloadhistory` ADD `downloads2` int(11)  DEFAULT NULL;
ALTER TABLE `downloadhistory` ADD `size2` bigint(19)  DEFAULT NULL;
ALTER TABLE `files` ADD `filetype` tinyint(3)  DEFAULT NULL;
ALTER TABLE `files` ADD `md5_hash` varchar(32)  DEFAULT NULL;
ALTER TABLE `files` ADD `price` varchar(32)  DEFAULT NULL;
ALTER TABLE `files` ADD `access_times` int(11)  DEFAULT NULL;
ALTER TABLE `files` ADD `access_expiry` int(11)  DEFAULT NULL;
ALTER TABLE `files` ADD `tags` varchar(255)  DEFAULT NULL;
ALTER TABLE `files` ADD `tag_ids` varchar(255)  DEFAULT NULL;
ALTER TABLE `groups` ADD `webspace` bigint(19)  DEFAULT NULL;
ALTER TABLE `groups` ADD `show_user_ads` tinyint(1)  DEFAULT '0';
ALTER TABLE `groups` ADD `url_prefix` varchar(255)  DEFAULT NULL;
ALTER TABLE `plugins` ADD `install_code` text  DEFAULT NULL;
ALTER TABLE `plugins` ADD `uninstall_code` text  DEFAULT NULL;
ALTER TABLE `setting` ADD `sitestats_data` varchar(255)  DEFAULT NULL;
ALTER TABLE `setting` ADD `rewardpoint` enum('downloader','uploader','both')  DEFAULT 'both';
ALTER TABLE `users` ADD `totaldownloads2` bigint(19)  DEFAULT NULL;
ALTER TABLE `users` ADD `paypal` varchar(255)  DEFAULT NULL;
ALTER TABLE `users` ADD `adsense_id` varchar(255)  DEFAULT NULL;
ALTER TABLE `users` ADD `balance` decimal(10,2)  DEFAULT '0.00';
ALTER TABLE `server` CHANGE `url_prog_mode` `url_prog_mode` enum('syn','ajax')  DEFAULT 'syn';
ALTER TABLE `server` CHANGE `ftp_prog_mode` `ftp_prog_mode` enum('syn','ajax')  DEFAULT 'syn'
UPDATE `groups` SET webspace = '10737418240'