<?
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
if(!defined('IN_ADMIN')) die("hack attempted!");
$act=$input[act];
$geolite_url='http://geolite.maxmind.com/download/geoip/database/GeoLiteCountry/GeoIP.dat.gz';

switch($act){
    case 'add':
         if(isset($input[update]))
         {
              if($DEMOMODE) redirect('admin=set',$DEMOTEXT);
              $rule = new TABLE($db,'downloadrules','rule_id');
              $rule->inputData();
              $rule->dl_area = remove_blank(@implode(',',$input[areas]));

              clean_input($group,$db_format[groups]);
              $rule->insert();

              redirect('admin=rule','Add Successfully!');
         }
         addEditRule();
         break;
    case 'edit':

         if(isset($input[update]))
         {
              if($DEMOMODE) redirect('admin=set',$DEMOTEXT);
              $rule = new TABLE($db,'downloadrules','rule_id');
              $rule->inputData();
              $rule->dl_area = remove_blank(@implode(',',$input[areas]));
              
              $rule->update();

              redirect('admin=rule','Update Successfully!');
         }
         addEditRule();

         break;
    case 'download':
         include "../includes/http.php";

         $gzcontent = grabRemoteContent($geolite_url);

         $filename = "../temp/GeoIP.dat.gz";
         fputs(fopen($filename,'w'),$gzcontent);
         
         $zd = gzopen($filename, "r");
         $contents='';
         while($readbytes = gzread($zd, 4086))
         $contents .= $readbytes;
         gzclose($zd);
         //echo $contents;
         fputs(fopen('../plugins/MaxMind/GeoIP.dat','w'),$contents);
         redirect('admin=rule',"Downloaded Successfully!");
         break;
    case 'update':
         if($DEMOMODE) redirect('admin=set',$DEMOTEXT);
         $db->setQuery("update setting set rewardpoint='$input[rewardpoint]'");
         $db->query();

         redirect('admin=rule',"Updated Successfully!");
         break;
    case 'del':
         if($DEMOMODE) redirect('admin=set',$DEMOTEXT);
         $db->setQuery("delete from downloadrules where rule_id='$input[id]'");
         $db->query();

         redirect('admin=rule',"Delete Successfully!");
         break;
    default:
         showRulesListForm($input[gid]);
}
?>
<?
function showRulesListForm($group_id=0)
{
global $baseUrl,$input,$db;
global $GEOIP_COUNTRY_NAMES, $GEOIP_COUNTRY_CODES;
    $per_num=10;
    $input[s]=intval($input[s]);
    $where_sql = $group_id?"where d.dl_gid='$group_id'":'';
    
    /**
    * load rules
    */
    $db->setQuery("select d.*,g.name from downloadrules as d
                   left join groups as g on g.id=d.dl_gid
                   $where_sql
                   ");
    $db->query();
    $rows=$db->loadRowList();

    if($group_id&&$rows) $data[caption] = 'For '.$rows[0]['name'];
    
    showRuleTh($data);
    foreach($rows as $row)
    {
        $data=$row;

        $data[maxbytes]=convertsize($row[dl_maxbytes],1);
        $data[donebytes]=convertsize($row[dl_donebytes],1);

        $data[last_update] = $row[dl_lastupdate]?date('Y-m-d H:i:s',$row[dl_lastupdate]):"No yet!";

        $country_list = '';
        $countrynames = split(',',$row[dl_area]);

        foreach($GEOIP_COUNTRY_NAMES as $id=>$country)
        {
            if($country&&in_array($GEOIP_COUNTRY_CODES[$id],$countrynames))
            $country_list .= '<option>'.$country.'</option>';
        }
        $data[area_list] = $country_list;

        $points_list = '';
        $dl_filesizes = split(',',$row[dl_filesizes]);
        $dl_points = split(',',$row[dl_points]);
        foreach($dl_filesizes as $k=>$filesize)
        {
             #$filesize is MB
             $points_list .= '<option>File owner gets '.$dl_points[$k].' points / file with size between '.$filesize.'MB '.($dl_filesizes[$k+1]?'- '.$dl_filesizes[$k+1].'MB':'+').'</option>';
        }
        $data[points_list] = $points_list;

        # js script tfor AJAX loading
        $deljsscript = "return AjaxLink(this.href,'pagecontainer');";
        if(defined('USE_AJAX')&&USE_AJAX==1) $jscript = "onClick=\"ajaxwin$row[rule_id]=dhtmlwindow.open('ajaxbox$row[rule_id]', 'ajax2', this.href, 'Edit $row[name]', 'width=650px,height=400px,center=1,resize=1,scrolling=1'); return false\"";

        $data[del] ="<a href='$baseUrl&admin=rule&act=del&id=$row[rule_id]' onclick=\"if(confirm('Are You Sure Delete This Rule?')) $deljsscript\"><img src='images/icon_delete.gif' border=0></a>";
        $data[del].="&nbsp;<a href='$baseUrl&admin=rule&act=edit&id=$row[rule_id]' $jscript><img src='images/icon_edit.gif' border=0></a>";

        showRuleRow($data);
    }

    showRuleTT();
}
/**
* add/edit a host package template
*/
function addEditRule()
{
global $baseUrl,$input,$db;

    $id=$input[id];
    if($id)
    {
       $db->setQuery("select * from downloadrules where rule_id='$id' ");
       $db->query();
       $row=$db->loadRow();
    }


    $title=$id?"Rule $row[rule_id]":"Rule information";
    $submit_btn=$id?"Update Rule":"Add new Rule";

    $enabled="<option value=1 selected>enabled</option><option value=0>disabled</option>";
    $disabled="<option value=1 >enabled</option><option value=0 selected>disabled</option>";

    $country_list = build_country_list(split(',',$row[dl_area]));

    $db->setQuery("select * from groups");
    $db->query();
    $groups=$db->loadRowList();
    $package_list='';
    foreach($groups as $group)
    {
        $package_list.='<option value='.$group[id].($row[dl_gid]==$group[id]?' selected':'').'>'.$group[name].'</option>';
    }
    # AJAX Submit JSscript
    $JSAjaxSubmit = "onsubmit=\"return AjaxSubmit(this,'pagecontainer');\"";

echo <<<EOF
<form action="index.php?admin=rule" name="myeditform$id" id="myeditform$id" method="post" $JSAjaxSubmit>
<input type="hidden" name="act" value="$input[act]">
<input type="hidden" name="update" value="1">
<input type="hidden" name="tbl_rule_id" value="$id">
<table class=adminlist align=center>
<tr><th align="center" colspan=2><b>$title:</b><input type="submit" name="update" value="$submit_btn"></th></tr>
<tr><td class=tdrow1 width=40%>Downloader's package<br><span class=note>This rule will only be applied to downloaders registered under the package</span></td><td class=tdrow2><select name="tbl_dl_gid">$package_list</select></td></tr>
<tr><td class=tdrow1 width=40%>Downloader's locations?<br><span class=note>Press 'Ctrl' to select multiple location</span></td><td class=tdrow2><select name="areas[]" size=10 multiple>$country_list</select></td></tr>
<tr><th colspan=2 align=center><b>Download points seting:</b><input type="submit" name="update" value="$submit_btn"></th></tr>
<tr><td class=tdrow1 width=40%>Points added for File owner:<br><span class=note>Points depending on filesizes will be added to user who uploaded the files. Multiple points are separated bt comma ','.</span></td><td class=tdrow2><input type="text" name="tbl_dl_points" value="$row[dl_points]"></td></tr>
<tr><td class=tdrow1 width=40%>Based filesizes :<br><span class=note>Assign points based on downloaded filesizes. Multiple corresponding filesizes are separated by comma ','. Units are MB.</span></td><td class=tdrow2><input type="text" name="tbl_dl_filesizes" value="$row[dl_filesizes]"></td></tr>
<!--<tr><td class=tdrow1 width=40%>Max Points per Hour & User:<br><span class=note>For single file</span></td><td class=tdrow2><input type="text" name="tbl_dl_maxbyday" value="$row[dl_maxbyday]"></td></tr>-->
<tr><th colspan=2 align=center><b>Download Bandwidth seting:</b><input type="submit" name="update" value="$submit_btn"></th></tr>
<tr><td class=tdrow1 width=40%>Max Bandwidth per Hour:<br><span class=note>Forom the above countries</span></td><td class=tdrow2><input type="text" name="tbl_dl_maxbytes" value="$row[dl_maxbytes]" onclick="calsize(this,'fsize');" onchange="calsize(this,'fsize');"><span class=note>Enter <b>2b/k/m/g</b> directly or the digital bytes 1024</span><div id=fsize></div></td></tr>
</form>
EOF;
}
/**
* List Rules package template
*/
function showRuleTh($data)
{
global $baseUrl,$SET;

if($SET[rewardpoint] == 'downloader') $rewardoptions = "<option value='downloader' selected>Downloader</option><option value='uploader'>Uploader</option><option value='both'>Both</option>";
if($SET[rewardpoint] == 'uploader') $rewardoptions = "<option value='downloader'>Downloader</option><option value='uploader' selected>Uploader</option><option value='both'>Both</option>";
if($SET[rewardpoint] == 'both') $rewardoptions = "<option value='downloader'>Downloader</option><option value='uploader'>Uploader</option><option value='both' selected>Both</option>";

echo <<<EOF
<form name=myform action="?admin=rule" method="POST">
<input type="hidden" name="admin" value="rule">
<input type="hidden" name="act" value="update">
    <table class=adminlist border=0 align=center>
    <tr>
		<th align="center" colspan='10'>Download Rules List<!--: Credit Points to <select name="rewardpoint">$rewardoptions</select>-->
    <input type="submit" name="update" value="Update"></th>
    </tr>
    <tr>
    <td align=left class='tdrow1' width=5% ><input type='checkbox' name=allbox onclick=checkAll()></td>
    <td align=left class='tdrow1' width=5%><b>ID</b></td>
    <td align=left class='tdrow1' width=10%><b>Downloaders</b></td>
    <td align=left class='tdrow1' width=20%><b>Download Locations</b></td>
    <td align=left class='tdrow1' width=10%><b>Points / Filesizes</b></td>
    <td align=left class='tdrow1' width=15%><b>Bandwidth per Day</b></td>
    <td align=left class='tdrow1' width=15%><b>Last update</b></td>
    <td align=left class='tdrow1' width=10%><b>Action</b></td>
    </tr>
EOF;
}
function showRuleRow($data)
{
global $baseUrl;

echo <<<EOF
    <tr>
    <td align=left class='tdrow1'><input type='checkbox' name=idList[$data[rule_id]] $disabled></td>
    <td align=left class='tdrow2'>$data[rule_id]</a></td>
    <td align=left class='tdrow1'>$data[name]</td>
    <td align=left class='tdrow2'><select>$data[area_list]</select></td>
    <td align=left class='tdrow1'><select>$data[points_list]</select></td>
    <td align=left class='tdrow2'>$data[donebytes]/$data[maxbytes]</td>
    <td align=left class='tdrow1'>$data[last_update]</td>
    <td align=left class='tdrow2'>$data[del]</td>
    </tr>
EOF;
}
function showRuleTT()
{
global $baseUrl,$input,$db,$geolite_url;

# js script for AJAX loading
if(defined('USE_AJAX')&&USE_AJAX==1) $jscript = "onClick=\"ajaxwin=dhtmlwindow.open('ajaxbox', 'ajax2', this.href, 'Add Download Rule', 'width=650px,height=400px,center=1,resize=1,scrolling=1'); return false\"";

echo <<<EOF
    <tr><td align='left' class='tdrow1' valign='middle' colspan=10>
    <a name="add" href='$baseUrl&admin=rule&act=add' $jscript><img src='images/icon_add.gif' border=0>Add a Download Rule</a>
    </td>
    </tr>
    </table>
    </form>
<form name=myform action="" method="POST">
    <table class=adminlist border=0 align=center>
    <tr>
		<th align="center" colspan='9'>Download GeoLite Country Database</th>
    </tr>
    <tr><td align='left' class='tdrow1' valign='middle' colspan=9>
    <a name="add" href="$baseUrl&admin=rule&act=download">Download from $geolite_url</a>
    (<b>plugins/MaxMind/GeoIP.dat</b> should be writable(i.e.: chmod to 0755))
    </td>
    </tr>
    </table>
    </form>
EOF;
}
?>
