<?
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
define('IN_DOWNLOAD',1);
include "../includes/inc.php";
$ok = verify_admin_access();
if($ok==0) die('Unauthrised access!');
/**
* download files
*/
if($input[f])
{
    include '../includes/image.class.php';
    # the filename is rawurlencode!
    $filename = ($input[f]);
    //$file=dirname(valid_path($filename));
    # working for both store methods
    //$file=dirname($filename).'/'.valid_file(rawurlencode(basename($filename)));
    $file= $upload_dir . '/'.valid_file(rawurlencode(basename($filename)));
    $filetype = getExt($file,'_')?getExt($file,'_'):getExt($file,'.');

    $content_type=Image::GetMime('.'.$filetype);
    $filepath = '../'.$file;

    if(strlen($file)&&file_exists($filepath))
    {
        $ImageFile=array('jpg','jpeg','bmp','tiff','tif','gif','png');
        header("Content-type: $content_type");
        header("Content-Length: ".filesize($filepath));

        $filename2 = rawurldecode(basename(str_replace('_','.',$file)));
        if(in_array($filetype,$ImageFile))
        {
            header("Content-Disposition: inline; filename=\"$filename2\"");
        }
        else
        {
            header("Content-Disposition: attachment; filename=\"$filename2\"");
        }

        $fp = fopen($filepath,'r');
        while($data=fread($fp,1024))
        {
            echo $data;
        }
        fclose($fp);
    }
    else
    {
        die($filepath.' doesn\'t exists!');
    }
}
/**
* download fileserver files
*/
if($input[server_id])
{

    include '../includes/zipfile.lib.php';
    include '../includes/fileman.php';

    $zip= new zipfile();
    $FileMan= new FileMan();

    $FileMan->SetSourceDir('../fileserver');
    $filelists = $FileMan->View();

    /**
    * add related files into zip package
    */
    foreach($filelists as $file)
    {
        if($file[folder]) continue;
        if(basename($file[name])=='config.php')
        {
            $file_code  = $input[config];
        }
        else
        {
            $file_code  = file_get_contents($file[name]);
        }
        //$zip->addFile($file_code,substr($file[name],3));
        $zip->addFile($file_code,'fileserver/upload_this/'.substr($file[name],3+strlen('fileserver/')));
    }


    @ob_end_clean();
    header("Content-type:application/zip");
    header("Content-Disposition: attachment; filename=fileserver-$input[server_id].zip");

    //fputs(fopen('1.zip','w'),$zip->file());

    echo $zip->file();
    exit;
}
/**
* download templates
*/
if($input[act]=='downloadtpl')
{
    include '../includes/zipfile.lib.php';

    $zipfile= new zipfile();

    $baseskin = preg_replace('/[^a-zA-Z0-9]/','',$input[skinname]);
    $baseskindir='../skin/'.$baseskin;

    $dirs=array('','flags','images','thumb','windowfiles');
    foreach($dirs as $dir)
    {
        if($dir) $dir = '/'.$dir;
        $hdir=opendir($baseskindir.$dir);
        while($file=readdir($hdir)){
            if (($file != ".") && ($file != "..")){
                if(is_file($baseskindir.$dir.'/'.$file)){
                    $file_code  = file_get_contents($baseskindir.$dir.'/'.$file);
                    $zipfile->addFile($file_code,'skin/'.$baseskin.$dir.'/'.$file);
                }
            }
        }
        closedir($hdir);
    }
    $zipfile->addFile('','skin/'.$baseskin.'/cache/');
    //fputs(fopen($baseskin.'.zip','w'),$zipfile->file());
    @ob_end_clean();
    header("Content-type:application/zip");
    header("Content-Disposition: attachment; filename=$baseskin.zip");

    echo $zipfile->file();
    exit;
}
/**
* download language
*/
if($input[act]=='downloadlang')
{
    include '../includes/zipfile.lib.php';

    $zipfile= new zipfile();

    $langname = preg_replace('/[^a-zA-Z0-9]/','',$input[langname]);
    $langdir='../language/'.$langname;

    $dirs=array('','emails');
    foreach($dirs as $dir)
    {
        if($dir) $dir = '/'.$dir;
        $hdir=opendir($langdir.$dir);
        while($file=readdir($hdir)){
            if (($file != ".") && ($file != "..")){
                if(is_file($langdir.$dir.'/'.$file)){
                    $file_code  = file_get_contents($langdir.$dir.'/'.$file);
                    $zipfile->addFile($file_code,'language/'.$langname.$dir.'/'.$file);
                }
            }
        }
        closedir($hdir);
    }
    @ob_end_clean();
    header("Content-type:application/zip");
    header("Content-Disposition: attachment; filename=$langname.zip");

    echo $zipfile->file();
    exit;
}
/**
* download language
*/
if($input[act]=='exportplugin')
{
    include 'minixml/minixml.inc.php';
    # loading the old data
    $db->setQuery("select * from plugins where plugin_id='$input[id]'");
    $db->query();
    $plugin = $db->loadRow();

    if(!$plugin) redirect('admin=plugins','Plugin does not exist!');

    $db->setQuery("select * from hooks where plugin_id='$plugin[plugin_id]'");
    $db->query();
    $hooks = $db->loadRowlist();
    $s = ExportPlugin($plugin,$hooks);

    $xmlfilename = 'Plugin-'.$plugin['name'].'.xml';
    header("Content-Disposition: attachment; filename=\"$xmlfilename\"");
    header('Content-Length: ' . strlen($s));
    echo $s;
}
function ExportPlugin($plugin,$hooks)
{
    $xmlDoc = new MiniXMLDoc();
    $xmlRoot = & $xmlDoc->getRoot();
    $pluginRoot = & $xmlRoot->createChild('plugin');
    $pluginRoot->attribute('id',$plugin['unique_id']);
    $pluginRoot->attribute('priority',$plugin['plugin_priority']);
    $pluginRoot->attribute('enabled',$plugin['enabled']);

    $node = $pluginRoot->createChild('name');
    $node->text($plugin[name]);
    $node = $pluginRoot->createChild('description');
    $node->cdata($plugin[descr]);
    $node = $pluginRoot->createChild('install');
    $node->cdata($plugin[install_code]);
    $node = $pluginRoot->createChild('uninstall');
    $node->cdata($plugin[uninstall_code]);
    $node = $pluginRoot->createChild('version');
    $node->text($plugin[version]);
    $node = $pluginRoot->createChild('author');
    $node->text($plugin[author]);
    $node = $pluginRoot->createChild('homepage');
    $node->text($plugin[homepage]);

    $hookRoot = $pluginRoot->createChild('codes');
    foreach($hooks as $hook)
    {
        $code = $hookRoot->createChild('code');
        //$code->attribute('priority',$hook['hook_priority']);
        $code->attribute('enabled',$hook['enabled']);

        $subnode = $code->createChild('name');
        $subnode->text($hook['name']);

        $subnode = $code->createChild('location');
        $subnode->text($hook['location']);

        $subnode = $code->createChild('phpcode');
        $subnode->cdata($hook['code']);
    }
    return $xmlDoc->toString();
}
?>