<?
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
include "../includes/inc.php";
###########################################################
# Crontab id
###########################################################
$cron_id = substr(basename(__FILE__),0,-4);

###########################################################
# Crontab code begin
###########################################################
$expiry_download = time()+1*60*60;
if(!$user->setting[cache_sessions]) $expiry_download = time()-60;
$store_queries = array();
$batch_query   = 0;
$curent_month_start = strtotime(date('Y-m-01',time()).' 0:0:0');

/**
* clean statics of last month for users
*/
$db->setQuery("update users set bandwidth=0 where last_update<$curent_month_start");
if($batch_query) $store_queries[]=$db->_sql;
else $db->query();

/**
* update statics for user account
*/
###########################################################
# File owners get points from their uploaded files
###########################################################
# files being download and credits points to the owner of files: guest files will not counted!
# this way will encourage users to upload files and share with more people
# since they got points when their files are downloaded!
# note we donot count downloads by uploader theirself!
if($user->setting[rewardpoint]=='uploader'||$user->setting[rewardpoint]=='both')
{
    $db->setQuery("select d.uid, d.file_uid, count(if(d.dl_size=d.size,1,null)) as downloads,
                   sum(d.size) as size, sum(if(d.dl_size=d.size,d.points,0)) as points, DATE_FORMAT(FROM_UNIXTIME(d.start_time),'%Y%m%d') as day,
                   max(d.start_time) as last_download, u.last_update
                   from dlsessions as d
                   left join users as u on u.id=d.file_uid
                   where d.file_uid!=0 and d.start_time<=$expiry_download
                   group by d.file_uid, day
                  ");
    $db->query();
    $logs=$db->loadRowList();
    foreach($logs as $log)
    {
        # at the same day, update download logs only
        if(date('Ymd',$log[last_update])==date('Ymd',$expiry_download))
        {
            $db->setQuery("update downloadhistory
                           set points=points+$log[points],downloads=downloads+$log[downloads],
                           size=size+$log[size]
                           where uid='$log[file_uid]' and date='$log[day]'
                          ");
            if($batch_query) $store_queries[]=$db->_sql;
            else $db->query();
        }
        else
        {
            # no download logs this day, create one
            $db->setQuery("insert into downloadhistory
                           set uid='$log[file_uid]',date='$log[day]',points='$log[points]',
                           downloads='$log[downloads]',size='$log[size]',status='valid'
                          ");
            if($batch_query) $store_queries[]=$db->_sql;
            else $db->query();
        }

        # update points, bandwidth, date on fileowner
        $db->setQuery("update users set
                       totalpoints=totalpoints+$log[points],
                       totaldownloads=totaldownloads+$log[downloads],
                       bandwidth=bandwidth+$log[size],
                       last_update='$log[last_download]'
                       where id='$log[file_uid]'
                      ");
        if($batch_query) $store_queries[]=$db->_sql;
        else $db->query();
    }
}

###########################################################
# File downloader get points by downloading other files
###########################################################
# download files and get points to the download account: guest will not get points in any way!
# this way will encourage registered users to download files
# since they got points when they download others files!
# note we donot count downloads of files uploaded by theirself!
if($user->setting[rewardpoint]=='downloader'||$user->setting[rewardpoint]=='both')
{
    $db->setQuery("select d.uid, d.file_uid, count(if(d.dl_size=d.size,1,null)) as downloads,
                   sum(d.size) as size, sum(if(d.dl_size=d.size,d.points,0)) as points, DATE_FORMAT(FROM_UNIXTIME(d.start_time),'%Y%m%d') as day,
                   max(d.start_time) as last_download, u.last_update
                   from dlsessions as d
                   left join users as u on u.id=d.uid
                   where d.uid!=0 and d.start_time<=$expiry_download
                   group by d.uid, day
                  ");
    $db->query();
    $logs=$db->loadRowList();
    foreach($logs as $log)
    {
        # at the same day, update download logs only
        if(date('Ymd',$log[last_update])==date('Ymd',$expiry_download))
        {
            $db->setQuery("update downloadhistory
                           set points2=points2+$log[points],downloads2=downloads2+$log[downloads],
                           size2=size2+$log[size]
                           where uid='$log[uid]' and date='$log[day]'
                          ");
            if($batch_query) $store_queries[]=$db->_sql;
            else $db->query();
        }
        else
        {
            # no download logs this day, create one
            $db->setQuery("insert into downloadhistory
                           set uid='$log[uid]',date='$log[day]',points2='$log[points]',
                           downloads2='$log[downloads]',size2='$log[size]',status='valid'
                          ");
            if($batch_query) $store_queries[]=$db->_sql;
            else $db->query();
        }

        # update points, downloads, date on downloader
        $db->setQuery("update users set
                       totalpoints=totalpoints+$log[points],
                       totaldownloads2=totaldownloads2+$log[downloads],
                       last_update='$log[last_download]'
                       where id='$log[uid]'
                      ");
        if($batch_query) $store_queries[]=$db->_sql;
        else $db->query();
    }
}

/**
* clean statics of last month for files
*/
$db->setQuery("update files set bandwidth=0 where lastdownload<$curent_month_start");
if($batch_query) $store_queries[]=$db->_sql;
else $db->query();
/**
* clean statics of last month for users
*/
$db->setQuery("update users set bandwidth=0 where last_update<$curent_month_start");
if($batch_query) $store_queries[]=$db->_sql;
else $db->query();

/**
* update statics for files
*/
$db->setQuery("select d.file_id, d.file_uid, d.uid, count(d.dl_id) as downloads, sum(d.size) as size,
               max(d.start_time) as last_download
               from dlsessions as d
               where d.start_time>$curent_month_start and d.start_time<=$expiry_download
               group by d.file_id
              ");
$db->query();
$dlsess=$db->loadRowList();
foreach($dlsess as $sess)
{
    $sess[downloads] = intval($sess[downloads]);
    $sess[size] = intval($sess[size]);

    # update date on user page
    $db->setQuery("update files
                   set downloads=downloads+$sess[downloads],
                   bandwidth=bandwidth+$sess[size],
                   lastdownload=$sess[last_download]
                   where id='$sess[file_id]' limit 1
                  ");
    if($batch_query) $store_queries[]=$db->_sql;
    else $db->query();
}

//print_r($store_queries);
//die();

if($batch_query)
foreach($store_queries as $query)
{
    $db->setQuery($query);
    $db->query();
}

$db->setQuery("delete from dlsessions where start_time<$expiry_download");
$db->query();

###########################################################
# Record crontab result
###########################################################
$results = count($logs) . ' users updated, '.count($dlsess) .' files updated!';
CrontabLog($cron_id,$results);
echo $results;
?>