<?
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: ywyhnchina@163.com
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
include "../includes/inc.php";
###########################################################
# Crontab id
###########################################################
$cron_id = is_numeric($input[cron_id]) ? $input[cron_id] : substr(basename(__FILE__),0,-4);

###########################################################
# Crontab code begin
###########################################################
if(function_exists('register_shutdown_function'))
register_shutdown_function('shutdown_update_db');

/*
* loading groups
*/
$db->setQuery("select * from groups where 1");
$db->query();
$groups=$db->loadRowList();

$files=array();
/*
* loading can cron files of groups with cron_enabled
*/
foreach($groups as $group)
{
    $minviews = $group[cron_views];
    $deldate  = time()-$group[cron_days]*24*60*60;
    $gid      = intval($group[id]);

    if($group[cron_enabled]==1)
    {
        $group_cron = "
                  (f.downloads<=$minviews
                  and (f.lastdownload<$deldate
                     OR (f.time<$deldate AND f.lastdownload is NULL)
                      )
                  and ".($group[guest]==0 ? "(u.gid='$gid')":"(f.uid=0)")."
                  )
        ";
        $db->setQuery("select f.*,u.gid,f.id,f.file,s.domain,s.upload_dir from files as f
                  left join server as s on s.server_id=f.server_id
                  left join users as u on u.id=f.uid
                  where f.deleted=0 and f.server_id='$server_id'
                  and
                  $group_cron
                  limit 100
                  ");
        $db->query();
        $newfiles=$db->loadRowList('id');
        $files=($files+$newfiles);
    }
}
/*
* loading deleted files by user owner!
*/
$db->setQuery("select f.*,f.id,f.file,s.domain,s.upload_dir,s.keep_name from files as f
              left join server as s on s.server_id=f.server_id
              where f.deleted=1 and f.server_id='$server_id'
              limit 100
              ");
$db->query();
$newfiles=$db->loadRowList('id');
$files=($files+$newfiles);

//print_r($files);die;

/**
* delete files
*/
$ids=array();
foreach($files as $file)
{
    $filename=valid_file($file[file].($file[keep_name]=='yes'?'/'.urlrawencode($file[name]):''));
    unlink((substr($file[upload_dir],0,1)=='/'?'':'../').$file[upload_dir].'/'.$filename);

    $ids[]=$file[id];
}
if(!function_exists('register_shutdown_function'))
shutdown_update_db();
/**
* update the server's stats
*/
function shutdown_update_db()
{
global $db,$ids,$cron_id,$server_id;
    $whereids = implode(',',$ids);
    if(!$whereids)
    {
        echo 'No files are deleted!';
        return '';
    }
    $db->setQuery("delete from files where id in ($whereids)");
    $db->query();
    
    $db->setQuery("select server_id,count(id) as hosted,sum(size) as webspace from files where server_id='$server_id' and deleted=0 group by server_id");
    $db->query();
    $row=$db->loadRow();

    $db->setQuery("update server set hosted='$row[hosted]',webspace='$row[webspace]' where server_id='$row[server_id]' ");
    $db->query();
    
    ###########################################################
    # Record crontab result
    ###########################################################
    $results = 'Server ID '.$server_id.':'.count($ids).' files are deleted!';
    if(count($ids))CrontabLog($cron_id,$results);
    echo '<br>'.$results;
    unset($ids);
    exit;
}
?>
