<?
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.4
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
define("IN_PAGE",'GETFILE');
define("PAGE_TITLE",'SITEGETFILE');

include "includes/inc.php";

# IMPORTANT to fix the long response.
session_write_close();

($hook = YABPlugin::fetch_hook('getfile_start',__FILE__,__LINE__)) ? exec($hook) : '';

## parse the download url!
if(!is_numeric($input[id]))
{
    $parts = split('/',$_SERVER["PHP_SELF"]);
    foreach($parts as $k=>$v)
    {
        if($v=='getfile.php')
        {
            $input[id]   = $parts[++$k];
            $input[access_key] = $parts[++$k];
            $input[t] = $parts[++$k];
            $input[o] = $parts[++$k];
            $input[name] = $parts[++$k];
            break;
        }
    }
}
else
{
    $input[name] = $input[n];
    $input[access_key] = $input[a];
}
$file_id = intval($input[id]);

## step 1: validate the upload id and the download code from setting table!
$expiry_download = time()-1*60*60;
$download_time = time()-1*60*60;

($hook = YABPlugin::fetch_hook('getfile_loadsetting',__FILE__,__LINE__)) ? exec($hook) : '';

$db->setQuery("select * from setting where set_id=1 limit 1");
$db->query();
$SET = $db->loadRow();

$download_code   = $SET[download_code];
$download_code   = $download_code . $file_id;
$download_code   = substr(md5($download_code . $file_id),0,32);

## proxy checking
($hook = YABPlugin::fetch_hook('getfile_checkproxy',__FILE__,__LINE__)) ? eval($hook) : '';

## avoid google reader
if(!$SET[allow_proxy] && isset($_SERVER['HTTP_X_FORWARDED_FOR']) && strpos($_SERVER['HTTP_USER_AGENT'],'docs.google.com/viewer')===false)
{
    ($hook = YABPlugin::fetch_hook('getfile_checkproxy_fails',__FILE__,__LINE__)) ? eval($hook) : '';

    $errorcode = 'DL_ProxyDisabled';
    header('location:'.$baseWeb.'/redirect.php?error=1&code='.$errorcode.'&id='.$file_id.'&url='.rawurlencode($_SERVER[HTTP_REFERER]));
    exit;
}


## step 2: check the access key

#1: restire $dl_options and $file options
$dl_options  = array();
$option_list = array(
    'dl_resume','dl_speed','dl_threads',
    'dl_ips','dl_timeout',/*'dl_maxsbyip',
    'dl_sizebyhour','dl_maxpointsbyday', */
    'uid','owner','file','area','points',
    'rule_id','update'
    );
//$options = split(',',unserialize(decryptStr($input[o],$download_code)));
$options = split(',',(decryptStr($input[o],$download_code)));
foreach($options as $k=>$v) $dl_options[$option_list[$k]]=$v;
$remotetime = hexdec($input[t]);

#2: regenerating the access key code
$access_key  = md5($remotetime.$download_code.$dl_options[file]);

#3: check the integraty of access key
($hook = YABPlugin::fetch_hook('getfile_checkcaptcha',__FILE__,__LINE__)) ? eval($hook) : '';
if($input[access_key] != $access_key)
{
    ($hook = YABPlugin::fetch_hook('getfile_checkcaptcha_fails',__FILE__,__LINE__)) ? eval($hook) : '';

    $errorcode = 'DL_CaptchaInvalid';
    header('location:'.$baseWeb.'/redirect.php?error=1&code='.$errorcode.'&id='.$file_id.'&url='.rawurlencode($_SERVER[HTTP_REFERER]));
    exit;
}

## Step 3: apply the time out checking if this is a new connection
# check the connection is from the same download but in different threads
$thread_started = $dl_options[dl_resume]
                  && (
                  isset($_SERVER['HTTP_RANGE']) || isset($HTTP_SERVER_VARS['HTTP_RANGE'])
                  );
($hook = YABPlugin::fetch_hook('getfile_checktimeout',__FILE__,__LINE__)) ? eval($hook) : '';

## apply the time out checking if this is a new connection
## link expired or click "too fast"!
if(!$thread_started && (time()>$remotetime || time()<$remotetime-$dl_options[dl_timeout]))
{
    ($hook = YABPlugin::fetch_hook('getfile_checktimeout_fails',__FILE__,__LINE__)) ? eval($hook) : '';

    $errorcode = 'DL_AccessKeyExpired';
    header('location:'.$baseWeb.'/redirect.php?error=1&code='.$errorcode.'&id='.$file_id.'&url='.rawurlencode($_SERVER[HTTP_REFERER]));
    exit;
}

($hook = YABPlugin::fetch_hook('getfile_checkfileexists',__FILE__,__LINE__)) ? eval($hook) : '';

## Step 4: check the file exists or not!
$dl_options[file]    = valid_file($dl_options[file]);
$download_path = $upload_dir . '/' . $dl_options[file];
if(!$dl_options[file]||!file_exists($download_path))
{
    ($hook = YABPlugin::fetch_hook('getfile_checkfileexists_fails',__FILE__,__LINE__)) ? eval($hook) : '';

    $errorcode = 'DL_FileNotFound';
    header('location:'.$baseWeb.'/redirect.php?error=1&code='.$errorcode.'&id='.$file_id.'&url='.rawurlencode($_SERVER[HTTP_REFERER]));
    exit;
}
$file[size] = filesize($download_path);
$filetype=getExt($dl_options[file],'_')?getExt($dl_options[file],'_'):getExt($dl_options[file]);

# make unlimited threads if the requests are from DIVX player
if(($filetype=='divx'||$filetype=='avi'))
{
    $thread_started = 0;
}
#2.if resume is disabled, set dl_threads to 1
if($dl_options[dl_resume]==0) $dl_options[dl_threads] = 1;

($hook = YABPlugin::fetch_hook('getfile_checkthread',__FILE__,__LINE__)) ? eval($hook) : '';

$ip_limit = $ip_strict ? "ip='$input[IP_CLIENT]' and" : '';
$db->setQuery("select * from dlsessions where $ip_limit access_key='".$db->getEscaped($input[access_key])."'");
$db->query();
$dl_session = $db->loadRow();

## 2.a).check the active download threads at the same access key
if($thread_started && $dl_session[threads] >= $dl_options[dl_threads])
{
    ($hook = YABPlugin::fetch_hook('getfile_checkthread_fails',__FILE__,__LINE__)) ? eval($hook) : '';

    $errorcode = 'DL_GotMaxThreads';
    //header("HTTP/1.1 404 Not Found");
    @ob_end_clean();
    //header("HTTP/1.1 301 Moved Permanently");
    header('Location: http://www.example.com/');
    //header('location:'.$baseWeb.'/redirect.php?error=1&code='.$errorcode.'&id='.$file_id);
    exit;
}

# 3.initiate download class
include_once "includes/class.httpdownload.php";
$dl = new httpdownload;
$dl->force_download = intval($input[i]!=1);
$dl->filename = $SET[download_prefix].rawurldecode($input['name']);

# 4.Apply the download options
$dl->speed      = $dl_options[dl_speed];
$dl->use_resume = $dl_options[dl_resume];
$dl->set_byfile($download_path);

($hook = YABPlugin::fetch_hook('getfile_apply_limitions',__FILE__,__LINE__)) ? eval($hook) : '';

# 5.try to update the active threads for the same access key
if ( $dl_options[dl_resume]
     &&
     (
     isset($_SERVER['HTTP_RANGE']) || isset($HTTP_SERVER_VARS['HTTP_RANGE'])
     )
   )
{
    ($hook = YABPlugin::fetch_hook('getfile_threadupdate',__FILE__,__LINE__)) ? eval($hook) : '';

    $db->setQuery("update dlsessions set threads=threads+1
                   where access_key='".$db->getEscaped($input[access_key])."'
                  ");
    $db->query();
}

## 6.if no records is affected,we will insert access key into database
## because the access key maybe expired,if the downlaod ip changes when a new thread is open
else
{
    ($hook = YABPlugin::fetch_hook('getfile_session_create',__FILE__,__LINE__)) ? eval($hook) : '';

    # record dl sessions
    $nowtime = time();
    $db->setQuery("insert into dlsessions set
                   file_id='$file_id',
                   file_uid='$dl_options[owner]',
                   uid='$dl_options[uid]',
                   start_time='$nowtime',
                   size='$file[size]',
                   points='$dl_options[points]',
                   ip='$input[IP_CLIENT]',
                   area='$dl_options[area]',
                   access_key='".$db->getEscaped($input[access_key])."'");
    $db->query();

    # update the download rule!
    $nowtime = time();
            
    ($hook = YABPlugin::fetch_hook('getfile_downloadrule_update',__FILE__,__LINE__)) ? eval($hook) : '';

    $updatedonebytes = $file[update]==1?"dl_donebytes='$file[size]',":"dl_donebytes=dl_donebytes+$file[size],";
    $db->setQuery("update downloadrules set $updatedonebytes dl_lastupdate='$nowtime' where rule_id='$dl_options[rule_id]'");
    $db->query();

}
($hook = YABPlugin::fetch_hook('getfile_startdownload',__FILE__,__LINE__)) ? eval($hook) : '';

## 7.all check is passed,download now!
list($leftsize, $dlsize)= $dl->download();

($hook = YABPlugin::fetch_hook('getfile_update_sessions',__FILE__,__LINE__)) ? eval($hook) : '';

$db->setQuery("update dlsessions set dl_size=dl_size+$dlsize,threads=threads-1,last_update='$nowtime' where access_key='".$db->getEscaped($input[access_key])."' limit 1");
$db->query();

($hook = YABPlugin::fetch_hook('getfile_end',__FILE__,__LINE__)) ? eval($hook) : '';
exit;
?>
