<?
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
/**
* load downlaod rules based on $group_id,$country_code
*/
function loadDownloadRules($group_id,$country_code)
{
global $input,$db,$user;
    # clean input
    $group_id = intval($group_id);
    $country_code = strtoupper($country_code);
    $default_rule = array(
        'rule_id'=>0,
        'dl_gid'=>0,
        'dl_area'=>'NA',
        'dl_points'=>0,
        'dl_maxbyday'=>0,
        'dl_donebytes'=>0,
        'dl_maxbytes'=>0,
    );
    
    ($hook = YABPlugin::fetch_hook('downloadrule_loading',__FILE__,__LINE__)) ? eval($hook) : '';

    # load rules by host package
    $db->setQuery("select * from downloadrules where dl_gid='$group_id'");
    $db->query();
    $rows=$db->loadRowList();

    # load rules
    foreach($rows as $row)
    {
          $codes = @split(',', strtoupper($row[dl_area]));

          # if a match rule is found, ignore the default rule
          if(in_array($country_code,$codes))
          {
              ($hook = YABPlugin::fetch_hook('downloadrule_loaded',__FILE__,__LINE__)) ? eval($hook) : '';

              return $row;
          }
    }

    ($hook = YABPlugin::fetch_hook('downloadrule_loaddefault',__FILE__,__LINE__)) ? eval($hook) : '';

    return $default_rule;
}
/**
* Show uplaod form
*/
function showUploadForm()
{
global $input, $user, $template, $server_id, $baseWeb, $_SERVER, $debug;
global $UploadSpeedUnit,$UploadProgressUnit,$UploadTotalSizeUnit,$ShowUploadWindow,$CustomFields;
    ($hook = YABPlugin::fetch_hook('uploadform_start',__FILE__,__LINE__)) ? eval($hook) : '';

    # initiate the uploader class and create the upload session
    $uploader = new uploader($server_id);
    $uploader->create_session($user->uid);

    # get upload server details
    $server = $user->getServer();

    $uploadmode = getCookies('uploadmode')?getCookies('uploadmode'):$input[uploadmode];
    $user_uploads = array();
    if($user->can_formupload!=-1) $user_uploads[] = 1;
    if($user->can_urlupload!=-1) $user_uploads[] = 2;
    if($user->can_ftpupload!=-1) $user_uploads[] = 3;
    if($user->can_flashupload!=-1) $user_uploads[] = 4;
    if(!in_array($uploadmode,$user_uploads)) $uploadmode=@current($user_uploads);

    # cross domain access:Javscript and Ajax Use!
    $localhost=$_SERVER[HTTP_HOST];
    $parts=parse_url($baseWeb);

    ($hook = YABPlugin::fetch_hook('uploadform_data_assign',__FILE__,__LINE__)) ? eval($hook) : '';

    # assign vars
    $template->assign_vars(array(
    'allowed_filesize'   => $user->allowed_filesize,
    'allowed_types'      => implode(',',$user->allowed_filetypes),
    'disabled_types'     => implode(',',$user->disabled_filetypes),
    'format_filesize'    => convertsize($user->allowed_filesize),
    'max_uploads'        => $user->max_uploads,
    'use_flash_progress' => $user->setting[use_flash_progress],
    'upload_session'     => $uploader->upload_session,
    'AccessKey'          => $uploader->access_code,
    'ServerID'           => $server[server_id],
    'uploadmode'         => $uploadmode,
    'show_options'       => $user->setting[show_options]==1?'block':'none',
    'password_disabled'  => $user->dl_password==1?'':' onclick="RegisterNow()"',
    # set php uploader script as action url for url and ftp upload if the progress bar is ajax
    'cgi_upload_url'     => $user->cgi_upload_url,
    'url_upload_url'     => $server[url_prog_mode]=='ajax'?$user->php_upload_url:$baseWeb.'/cross.php',
    'ftp_upload_url'     => $server[ftp_prog_mode]=='ajax'?$user->php_upload_url:$baseWeb.'/cross.php',
    'php_upload_url'     => $user->php_upload_url,
    'php_progress_url'   => $user->php_progress_url,
    'flash_progress_url' => $baseWeb.'/skin/'.$user->setting[skin_dir].'/images/progress_bar.swf',
    # url on main site:
    'swf_upload_url'     => $baseWeb.'/includes/uploader.swf',//$user->swf_upload_url,
    'return_url'         => $baseWeb.'/cross.php',
    # upload speed format
    'UploadSpeedUnit'    => $UploadSpeedUnit,
    'UploadProgressUnit' => $UploadProgressUnit,
    'UploadTotalSizeUnit'=> $UploadTotalSizeUnit,
    # show upload DHTML windows
    'ShowUploadWindow'   => $ShowUploadWindow,
    'custom_fields'      => implode(',', $CustomFields),
    # using textarea to input urls or ftps?
    'show_mulurlupload'  => $user->setting[mulurlupload],
    'show_mulftpupload'  => $user->setting[mulftpupload],
    # use APC module for obtaining progress?
    'use_php_apc'        => defined('PHPUPLOADMODULE')&&PHPUPLOADMODULE==1,
    'debug'              => $debug,
    ));

    # assign onbeforeunload javascript
    $template->assign_var('onbeforeunloadjscript', 'onbeforeunload="return stopUpload()"');
    
    # select the upload method
    $template->assign_var('file_selected', $uploadmode==1&&$user->can_formupload!=-1?'checked="checked"':' ');
    $template->assign_var('url_selected',  $uploadmode==2&&$user->can_urlupload!=-1?'checked="checked"':' ');
    $template->assign_var('ftp_selected',  $uploadmode==3&&$user->can_ftpupload!=-1?'checked="checked"':' ');
    $template->assign_var('flash_selected',$uploadmode==4&&$user->can_flashupload!=-1?'checked="checked"':' ');

    # site offline
    if($user->setting[site_offline]==1)
    {
        $template->assign_var('is_siteoffline',1);
        $template->assign_block_vars('siteoffline', array());

        ($hook = YABPlugin::fetch_hook('site_offline',__FILE__,__LINE__)) ? eval($hook) : '';
    }
    elseif($user->setting[site_registered]==1 && $user->uid == 0)
    {
        $template->assign_var('is_siteoffline',1);
        $template->assign_block_vars('siteoffline', array());


        global $LANG;
        $template->assign_var('L_SiteOffline', $LANG[SiteRegistered]);
    }
    else
    {
        # show or not
        $template->assign_var('show_formupload',  $user->can_formupload!=-1);
        $template->assign_var('show_urlupload',   $user->can_urlupload!=-1);
        $template->assign_var('show_ftpupload',   $user->can_ftpupload!=-1);
        $template->assign_var('show_flashupload', $user->can_flashupload!=-1);

        # enabled or not
        $template->assign_var('can_formupload',  $user->can_formupload);
        $template->assign_var('can_urlupload',   $user->can_urlupload);
        $template->assign_var('can_ftpupload',   $user->can_ftpupload);
        $template->assign_var('can_flashupload', $user->can_flashupload);
        
        # enabled or not
        $template->assign_var('cgi_prog_mode',  $server[cgi_prog_mode]);
        $template->assign_var('url_prog_mode',  $server[url_prog_mode]);
        $template->assign_var('ftp_prog_mode',  $server[ftp_prog_mode]);
        
        # set upload interface status
        $template->assign_var('file_block',  $uploadmode==1&&$user->can_formupload!=-1?'block':'none');
        $template->assign_var('url_block',   $uploadmode==2&&$user->can_urlupload!=-1?'block':'none');
        $template->assign_var('ftp_block',   $uploadmode==3&&$user->can_ftpupload!=-1?'block':'none');
        $template->assign_var('flash_block', $uploadmode==4&&$user->can_flashupload!=-1?'block':'none');
    }
    ($hook = YABPlugin::fetch_hook('uploadform_end',__FILE__,__LINE__)) ? eval($hook) : '';
}
function PHPunescape ($source)
{
    $decodedStr = "";
    $pos = 0;
    $len = strlen ($source);
    while ($pos < $len) {
        $charAt = substr ($source, $pos, 1);
        if ($charAt == '%') {
            $pos++;
            $charAt = substr ($source, $pos, 1);
            if ($charAt == 'u') {
                // we got a unicode character
                $pos++;
                $unicodeHexVal = substr ($source, $pos, 4);
                $unicode = hexdec ($unicodeHexVal);
                $entity = "&#". $unicode . ';';
                $decodedStr .= utf8_encode ($entity);
                $pos += 4;
            }
            else {
                // we have an escaped ascii character
                $hexVal = substr ($source, $pos, 2);
                $decodedStr .= chr (hexdec ($hexVal));
                $pos += 2;
            }
        } else {
            $decodedStr .= $charAt;
            $pos++;
        }
    }
    return $decodedStr;
}
/**
* Show links for files
*/
function showFileLinks()
{
global $input,$baseUrl,$baseWeb,$db,$user,$template;
    $per_num=10;
    $input[s]=intval($input[s]);

    ($hook = YABPlugin::fetch_hook('showfiles_start',__FILE__,__LINE__)) ? eval($hook) : '';

    $db->setQuery("select count(*) as nums from files as f where f.uid='$user->uid' and f.deleted=0");
    $db->query();
    $total=$db->loadRow();

    $db->setQuery("select f.*,s.name as server,s.http,s.domain,s.mod_status from files as f
                  left join server as s on s.server_id=f.server_id
                  where f.uid='$user->uid' and f.deleted=0
                  order by f.time DESC limit $input[s],$per_num");
    $db->query();
    $rows=$db->loadRowList();

    $cur_page=@($input[s]/$per_num);
    $info=array('total'      =>$total[nums],
                'page'       =>$per_num,
                'cur_page'   =>$cur_page,
                'baseUrl'    =>$baseUrl."&showlinks=1"
                );
                
    $pageLinks=buildPageLinks($info);
    $template->assign_vars(array('pageLinks'=>$pageLinks,'filenums'=>$total[nums],'pages'=>$per_num));

    buildLinksCode($rows);

    ($hook = YABPlugin::fetch_hook('showfiles_end',__FILE__,__LINE__)) ? eval($hook) : '';

}
/**
*  generate links code
*/
function buildLinksCode($images)
{
global $LANG,$input,$baseWeb,$db,$user,$template,$CODES;
global $ImageFile,$ImageFile2,$VideoFile;

    ($hook = YABPlugin::fetch_hook('build_filerow_begin',__FILE__,__LINE__)) ? eval($hook) : '';

    # load CODE templates
    $db->setQuery("select * from links where enable = 1 order by ordering desc");
    $db->query();
    $CODES=$db->loadRowList();

    $i=0;
    foreach($images as $image)
    {
        $i++;
        # retrieve the urls
        $urls=getDownloadUrl($image);
        extract($urls);
       
        //$filetype = getExt($image[file],'_') ? getExt($image[file],'_') : getExt($image[file]);
        $filetype = getExt($image[name]);
        list($im,$mplayer,$ffmpeg) = split(',',$image[mod_status]);
        $image[can_makethumb] = (in_array($filetype,$ImageFile))
                                ||(($im)&&in_array($filetype,$ImageFile2))
                                ||(($mplayer||$ffmpeg)&&in_array($filetype,$VideoFile));
        
        $image[showthumb] = $image['thumb'];
       
        $image[remoteWeb] = $image[http].$image['domain'];
        $image[accessKey] = base64_encode(encryptStr("$user->uid",$input[IP_CLIENT]));

        $image[size]=convertsize($image[size]);
        $image[s]=$input[s];
        
        $image[thumb_url]    = $thumburl;
        $image[delete_url]   = $deleteurl;
        $image[download_url] = $downloadurl;
        $image[status_url]   = $statusurl;
        $image[upload_date]  = date(TimeStamp,$image['time']);
        $image[descr]=htmlspecialchars($image[descr]);
        $image[password]=htmlspecialchars($image[password]);
        $image[rawdownloadurl] = rawurlencode($downloadurl);

        ($hook = YABPlugin::fetch_hook('build_filerow_data',__FILE__,__LINE__)) ? eval($hook) : '';

        $template->assign_block_vars('row', $image);

        # append download link codes
        buildLinksCodeTemplate('row.codes',$image,$urls);
    }
    ($hook = YABPlugin::fetch_hook('build_filerow_end',__FILE__,__LINE__)) ? eval($hook) : '';
}
function emailFileLinks($files,$fromemail,$to_emails)
{
global $email,$user;
    $email->template->set_filenames(array(
    'email'  => 'filedelivered.html',
    'email2' => 'filedelivery.html'
    ));

    ($hook = YABPlugin::fetch_hook('build_emaildownloadlinks_start',__FILE__,__LINE__)) ? eval($hook) : '';

    $uploaded_size = 0;
    foreach($files as $file)
    {
        ($hook = YABPlugin::fetch_hook('build_emaildownloadlinks_data',__FILE__,__LINE__)) ? eval($hook) : '';

        $urls=getDownloadUrl($file);
        extract($urls);

        $uploaded_size += $file[size];

        $email->template->assign_block_vars('links', array(
        'filename'=>$file[name],
        'filesize'=>$file[size],
        'file_password'=>$file[password],
        'downloadurl'=>$downloadurl,
        'deleteurl'=>$deleteurl,
        'file_descr'=>$file[descr],
        ));
    }
    ($hook = YABPlugin::fetch_hook('build_emaildownloadlinks_end',__FILE__,__LINE__)) ? eval($hook) : '';

    /**
    * sending email
    */
    ($hook = YABPlugin::fetch_hook('email_downloadlinks_start',__FILE__,__LINE__)) ? eval($hook) : '';

    $email->template->assign_vars(array(
    'SITENAME'=>$user->setting[sitename],
    'uploaded_num'=>count($files),
    'uploaded_size'=>$uploaded_size,
    'EMAIL_SIG'=>$user->setting[emailsign],
    'from_email'=>$fromemail,
    ));
    if(strlen($fromemail))
    {
        $email->to($fromemail,$fromemail);
        $email->from($user->setting[adminemail],$user->setting[sitename]);
        $email->send('email');

        $to_emails = array_slice($to_emails, 0, 1000);

        if($to_emails)
        foreach($to_emails as $to_email)
        {
            ($hook = YABPlugin::fetch_hook('email_downloadlinks_sending',__FILE__,__LINE__)) ? eval($hook) : '';

            if($debug) echo  $to_email.'<br>';
            $email->to($to_email,$to_email);
            $email->from($fromemail,$fromemail);
            $email->send('email2');
        }
    }
    ($hook = YABPlugin::fetch_hook('email_downloadlinks_end',__FILE__,__LINE__)) ? eval($hook) : '';
}
/**
* Build Code Template
*/
function buildLinksCodeTemplate($block,$fileobj,$urls)
{
global $user,$baseUrl,$db,$LANG,$template,$CODES;
    $GLOBALCODES = $code_names = array();
    
    ($hook = YABPlugin::fetch_hook('build_linkcodes_begin',__FILE__,__LINE__)) ? eval($hook) : '';

    foreach($CODES as $code)
    {
        $filetypes = split(',',$code['filetype']);
        if(in_array(getExt($fileobj[name]),$filetypes)||in_array('all',$filetypes))
        {
            $linkcode = array();
            $linkcode[id]   = $code[id];
            $linkcode[name] = $LANG[$code[unique_id]]?$LANG[$code[unique_id]]:$code[name];

            $linkcode[code] = str_replace('{FILEURL}', $urls[downloadurl],$code[code]);
            $linkcode[code] = str_replace('{SHAREURL}',$urls[shareurl],$linkcode[code]);
            $linkcode[code] = str_replace('{THUMBURL}',$urls[thumburl],$linkcode[code]);
            $linkcode[code] = str_replace('{STATUSURL}',$urls[statusurl],$linkcode[code]);
            $linkcode[code] = str_replace('{SITENAME}',$LANG[SiteName] ? $LANG[SiteName] : $user->setting[sitename],$linkcode[code]);
            $linkcode[code] = str_replace('{FILENAME}',htmlspecialchars($fileobj[filename],ENT_QUOTES),$linkcode[code]);
            $linkcode[code] = htmlspecialchars($linkcode[code],ENT_QUOTES);

            $GLOBALCODES[$code[unique_id]] = $linkcode[code];

            $code_names[] = "'".htmlspecialchars($code[name],ENT_QUOTES)."'";

            ($hook = YABPlugin::fetch_hook('build_linkcodes_assignvars',__FILE__,__LINE__)) ? eval($hook) : '';

            $template->assign_block_vars($block,$linkcode);
        }
    }

    ($hook = YABPlugin::fetch_hook('build_linkcodes_end',__FILE__,__LINE__)) ? eval($hook) : '';

    $template->assign_vars($GLOBALCODES);
}
/**
* show all package information
*/
function ListHostPackages($group_id=0)
{
global $db,$template,$user,$LANG,$baseWeb,$DATASTORE;
    ($hook = YABPlugin::fetch_hook('listpackages_start',__FILE__,__LINE__)) ? eval($hook) : '';

    # load package list
    if(!is_array($DATASTORE[groups]))
    {
        $db->setQuery("select * from groups ".($group_id? " where id = '$group_id'": ''));
        $db->query();
        $rows=$db->loadRowList();
    }
    else
    {
        $rows=$group_id?array($DATASTORE[groups][$group_id]):$DATASTORE[groups];
    }

    # image template
    $tick_img = '<img src="'.$baseWeb.'/skin/'.$user->setting[skin_dir].'/images/tick.png" alt="tick"/>';
    $x_img = '<img src="'.$baseWeb.'/skin/'.$user->setting[skin_dir].'/images/x.png" alt="x"/>';

    $template->assign_var('show_package_nums',count($rows)+1);

    # assign vars of host package to template
    foreach($rows as $row)
    {
        ($hook = YABPlugin::fetch_hook('build_packages_data',__FILE__,__LINE__)) ? eval($hook) : '';

        # hide guest package if necessary
        if($group_id==0&&$user->setting[show_guest_package]==0&&$row[guest]==1) continue;
        # or hide private packages
        if($group_id==0&&$row[guest]==-1) continue;

        # build subscription info
        $ps=split(',',$row[subscr_period]);
        $fs=split(',',$row[subscr_fee]);
        $us=split(',',$row[subscr_unit]);

        $price_list='';
        if($row[subscr_fee]=='')
        {
            $price_list=$LANG['Free'];
        }
        else
        {
            for($i=0;$i<count($ps);$i++)
            {
                $price_list.=$LANG[CurrencySymbol].($fs[$i]).'/'.$ps[$i].' '.$LANG[Units][isset($us[$i])?$us[$i]:$us[0]].'<br />';
            }
        }
        # upload limitions
        $template->assign_block_vars('name',array('var'=>$row[name]));
        $template->assign_block_vars('sizelimit',array('var'=>convertsize($row[sizelimit])));
        $template->assign_block_vars('max_uploads',array('var'=>$row[max_uploads]));

        $filetype = $row[allowed_filetype]?
                    $LANG[AllowedFiletypes].':'.$row[allowed_filetype]:
                    ($row[disabled_filetype]?
                     $LANG[DisabledFiletypes].':'.$row[disabled_filetype]:
                     $LANG[AllFiletypeAllowed]
                    );
        $template->assign_block_vars('filetype',array('var'=>$filetype));
        $template->assign_block_vars('allow_filetype',array('var'=>$row[allow_filetype]));
        $template->assign_block_vars('disabled_filetype',array('var'=>$row[disabled_filetype]));

        # download options
        $template->assign_block_vars('dl_speed',array('var'=>$row[dl_speed]==0?$LANG['Unlimited']:$row[dl_speed].'kb/s'));
        $template->assign_block_vars('dl_ips',array('var'=>$row[dl_ips]==0?$LANG['Unlimited']:$row[dl_ips]));
        $template->assign_block_vars('dl_resume',array('var'=>$row[dl_resume]==1?$tick_img:$x_img));
        $template->assign_block_vars('dl_captcha',array('var'=>$row[dl_captcha]==0?$tick_img:$x_img));
        $template->assign_block_vars('dl_waittime',array('var'=>$row[dl_waittime]>0?$row[dl_waittime].' seconds':$x_img));
        $template->assign_block_vars('dl_direct',array('var'=>$row[dl_direct]==1?$tick_img:$x_img));
        $template->assign_block_vars('dl_password',array('var'=>$row[dl_password]==1?$tick_img:$x_img));
        $template->assign_block_vars('dl_checkarea',array('var'=>$row[dl_checkarea]==1?$tick_img:$x_img));

        # upload method
        $template->assign_block_vars('formupload',array('var'=>$row[formupload]==1?$tick_img:$x_img));
        $template->assign_block_vars('urlupload',array('var'=>$row[urlupload]==1?$tick_img:$x_img));
        $template->assign_block_vars('ftpupload',array('var'=>$row[ftpupload]==1?$tick_img:$x_img));
        $template->assign_block_vars('flashupload',array('var'=>$row[flashupload]==1?$tick_img:$x_img));

        # ads setting
        $template->assign_block_vars('show_sponser_ads',array('var'=>$row[show_sponser_ads]==1?$tick_img:$x_img));
        $template->assign_block_vars('show_site_ads',array('var'=>$row[show_site_ads]==1?$tick_img:$x_img));
        $template->assign_block_vars('folder',array('var'=>$row[folder]==1?$tick_img:$x_img));

        # delete days
        $template->assign_block_vars('cron_days',array('var'=>$row[cron_enabled]?$row[cron_days].' '.$LANG[NoDownloads]:$LANG['NeverDelete']));

        # order
        $template->assign_block_vars('price',array('var'=>$price_list));
        $template->assign_block_vars('order',array('is_guest'=>$row[guest],'group_id'=>$row[id]));
    }

    ($hook = YABPlugin::fetch_hook('listpackages_end',__FILE__,__LINE__)) ? eval($hook) : '';

}
function verifyDownload($direct=0)
{
global $db,$dl_group,$input,$downloadrule,$filerow,$template,$publickey;

    $errorcode = '';
    $download_time = time()-1*60*60;

    ($hook = YABPlugin::fetch_hook('download_checkcaptcha_start',__FILE__,__LINE__)) ? eval($hook) : '';

    #1. check the captchacode match
    if(strlen($errorcode)==0&&$direct==0&&$dl_group[dl_captcha])
    {
        //if the check is from post, show error
        if(IS_POST&&(strlen($input[captchacode])==0
         ||$_SESSION['authkey_expire']<time()
         ||$input[captchacode]!=$_SESSION[authkey]))
        {
            if(strlen($publickey)==0) $errorcode = 'DL_CaptchaInvalid';
        }
        $_SESSION[authkey] = '';

        ($hook = YABPlugin::fetch_hook('download_checkcaptcha_end',__FILE__,__LINE__)) ? eval($hook) : '';

    }

    ($hook = YABPlugin::fetch_hook('download_checkpassword_start',__FILE__,__LINE__)) ? eval($hook) : '';

    #2. check the password match
    if(strlen($errorcode)==0&&$direct==0&&$dl_group[dl_password])
    {
        //if direct download is allowed, ignore the check
        if(!$dl_group[dl_direct]) $can_download = 0;
        //if the check is from post, show error
        if(IS_POST&&$input[downloadpw]!=$filerow[password])
        {
            $errorcode = 'DL_PasswordErr';
        }

        ($hook = YABPlugin::fetch_hook('download_checkpassword_end',__FILE__,__LINE__)) ? eval($hook) : '';

    }

    ($hook = YABPlugin::fetch_hook('download_checksizebyhour_start',__FILE__,__LINE__)) ? eval($hook) : '';

    #3. check the download amounts by IP
    if(strlen($errorcode)==0&&$dl_group[dl_sizebyhour])
    {
        ($hook = YABPlugin::fetch_hook('download_check_currentsize',__FILE__,__LINE__)) ? eval($hook) : '';

        $db->setQuery("select sum(d.dl_size) as total
                       from dlsessions as d
                       where d.ip='$input[IP_CLIENT]' and
                       ((d.last_update&&d.last_update>$download_time)||d.start_time>$download_time)
                      ");
        $db->query();
        $downloadrow=$db->loadRow();
        if($downloadrow[total]+$filerow[size] > $dl_group[dl_sizebyhour])
        {
            $errorcode = 'DL_GotMaxSizeByHour';

            ($hook = YABPlugin::fetch_hook('downloaderr_getmaxsize',__FILE__,__LINE__)) ? eval($hook) : '';
        }
        ($hook = YABPlugin::fetch_hook('download_checksizebyhour_end',__FILE__,__LINE__)) ? eval($hook) : '';

    }

    ($hook = YABPlugin::fetch_hook('download_checkips_start',__FILE__,__LINE__)) ? eval($hook) : '';

    #4. check the download sessions by IP
    if(strlen($errorcode)==0&&$dl_group[dl_ips])
    {
        ($hook = YABPlugin::fetch_hook('download_check_currentips',__FILE__,__LINE__)) ? eval($hook) : '';

        //$db->setQuery("select * from dlsessions where ip='$input[IP_CLIENT]' and (last_update>$download_time and dl_size!=size)");
        $db->setQuery("select * from dlsessions where ip='$input[IP_CLIENT]' and (((last_update!=0&&last_update>$download_time)||start_time>$download_time) and dl_size!=size)");
        $db->query();
        if($db->getNumRows() >= $dl_group[dl_ips])
        {
            $errorcode = 'DL_GotMaxIP';

            ($hook = YABPlugin::fetch_hook('downloaderr_getmaxip',__FILE__,__LINE__)) ? eval($hook) : '';
        }
        ($hook = YABPlugin::fetch_hook('download_checkips_end',__FILE__,__LINE__)) ? eval($hook) : '';

    }

    #5. load download rules if it is possible to begin a download!
    if(strlen($errorcode)==0)
    {
        ($hook = YABPlugin::fetch_hook('downloadrule_load_start',__FILE__,__LINE__)) ? eval($hook) : '';

        require_once(ROOT."/plugins/MaxMind/run.php");
        $dl_area = 'NA';
        $dl_area =  getCountryCodeByMaxMind();
        if($dl_area=='') $dl_area = 'UN';

        # load download rule by user package and download location
        # if none is matched, a default rule(defined in function.php) is loaded without any limitation
        global $downloadrule;
        $downloadrule = loadDownloadRules($dl_group[id],$dl_area);
        $downloadrule[dl_area]=$dl_area;

        ($hook = YABPlugin::fetch_hook('downloadrule_load_end',__FILE__,__LINE__)) ? eval($hook) : '';

    }

    ($hook = YABPlugin::fetch_hook('download_checkarea_start',__FILE__,__LINE__)) ? eval($hook) : '';

    #6. check the download amounts by country by DAY
    if(strlen($errorcode)==0&&$downloadrule[rule_id]&&$dl_group[dl_checkarea])
    {
        ($hook = YABPlugin::fetch_hook('download_check_currentarea',__FILE__,__LINE__)) ? eval($hook) : '';

        # check last update and excess the max allowed bytes
        if($downloadrule[dl_maxbytes] && (time()-$downloadrule[dl_lastupdate]<24*60*60) && $downloadrule[dl_donebytes]+$filerow[size] > $downloadrule[dl_maxbytes])
        {
            $errorcode = 'DL_GotMaxSizeByArea';
        }
        # a new day, but a configuration cause the a big file is not allowed to download!
        elseif($downloadrule[dl_maxbytes] && (time()-$downloadrule[dl_lastupdate]>24*60*60) && $filerow[size] > $downloadrule[dl_maxbytes])
        {
            $errorcode = 'DL_GotMaxSizeByArea';
        }

        # a new day? update it!
        $downloadrule[dl_update] = (int)(time()-$downloadrule[dl_lastupdate]>24*60*60);

        ($hook = YABPlugin::fetch_hook('download_checkarea_end',__FILE__,__LINE__)) ? eval($hook) : '';

    }

    return array(strlen($errorcode)==0,$errorcode);
}
function buildDownloadLink($file_id,$forcedownload='download',$staticurl=0)
{
global $filerow,$dl_group,$user,$input,$downloadrule;
    ($hook = YABPlugin::fetch_hook('download_buildlink_start',__FILE__,__LINE__)) ? eval($hook) : '';

    # avoid generating links without entring the valid window
    if($forcedownload=='inline') $dl_group[dl_waittime] = 0;

    ## build extras fileds
    ## build download options
    $dl_options  = array();
    $option_list = array(
    'dl_resume','dl_speed','dl_threads',
    'dl_ips','dl_timeout',/*'dl_maxsbyip',
    'dl_sizebyhour','dl_maxpointsbyday', */
    'uid','owner','file','area','points',
    'rule_id','update'
    );
    # limitations by user group
    $dl_options['dl_resume'] = $dl_group[dl_resume];
    $dl_options['dl_speed'] = $dl_group[dl_speed];
    $dl_options['dl_threads'] = $dl_group[dl_threads];
    $dl_options['dl_ips'] = $dl_group[dl_ips];
    $dl_options['dl_timeout'] = $dl_group[dl_timeout];

    $dl_options['uid'] = $user->uid;
    $dl_options['owner'] = intval($filerow[uid]);
    $dl_options['file'] =  $filerow[file];
    # limitations by download rule
    $dl_options['area'] = $downloadrule[dl_area];

    # assign points by filesize
    $dl_options['points'] = 0;
    if($filerow[uid]!=$user->uid)
    {
        $dl_filesizes = split(',',$downloadrule[dl_filesizes]);
        $dl_points = split(',',$downloadrule[dl_points]);
        foreach($dl_filesizes as $k=>$filesize)
        {
            #$filesize is MB
            if($filerow[size]>=$filesize*1024*1024)
            {
                $dl_options['points'] = $dl_points[$k];
            }
        }
    }

    $dl_options['rule_id'] = $downloadrule[rule_id];
    $dl_options['update'] = $downloadrule[dl_update];

    ## build download secret code
    #1: add the download code to avoid ip changes
    $download_code   = $user->setting[download_code];
    #2: append the upload id to disable access key to download other files
    $download_code   = $download_code . $file_id;
    $download_code   = substr(md5($download_code . $file_id),0,32);

    ## build access key
    #1: timestamp the access key and generating the auth key
    $remotetime      = time()+$dl_group[dl_timeout]+$dl_group[dl_waittime]-$filerow[t_diff];
    $remotetime_hex  = sprintf("%08x", $remotetime);
    $access_key      = md5(trim($remotetime.$download_code.$filerow[file]));

    #2: generate file options code
    //$encoded_options = encryptStr(serialize(implode(',',$dl_options)),$download_code);
    $encoded_options = encryptStr((implode(',',$dl_options)),$download_code);

    ## build download url with the access key!
    $downloadfilename = rawurlencode($filerow[filename]); //str_replace('&','-',$filerow[filename]);
    # dynamical file url
    if($staticurl==0)
    {
        $downloadfileurl = $filerow[http].$filerow[domain].'/getfile.php?id='.$file_id.'&a='.$access_key.'&t='.$remotetime_hex.'&o='.$encoded_options.'&n='.$downloadfilename;
        # force the file be embeddable
        if($forcedownload=='inline') $downloadfileurl .= '&i=1';
    }
    else
    {
        # static download url
        $downloadfileurl = $filerow[http].$filerow[domain] . '/getfile.php/' . $file_id . '/' . $access_key . '/' . $remotetime_hex . '/' . $encoded_options . '/' . $downloadfilename;
    }

    # lighttpd server download url
    if($user->servers[$filerow[server_id]][lighttpd]==1)
    {
        $secret_code = $dl_group[secret_code];
        $url_prefix = $dl_group[url_prefix];

        //$urlparts = parse_url($filerow[http].$filerow[domain]);

        $downloadfileurl = $filerow[http].$user->servers[$filerow[server_id]][lighttpd_url].'/'.buildLightDownloadUrl('/'.$filerow[file],$secret_code,$url_prefix.'/',$filerow[t_diff]);
    }


    ($hook = YABPlugin::fetch_hook('download_buildlink_end',__FILE__,__LINE__)) ? eval($hook) : '';

    return $downloadfileurl;
}
function buildLightDownloadUrl($file,$secret='mycode',$uri_prefix='files/',$time_diff)
{
    $server_time = time()+$time_diff;
    $t_hex = sprintf("%08x", $server_time);
    $mdstr = md5($secret.$file.$t_hex);
    # generate link
    return sprintf('%s%s/%s%s', $uri_prefix, $mdstr, $t_hex, $file);
}
/**
* list files by condition
*/
function ListFiles($searchtext, $orderby='f.time',$filetype=0,$ads_nums=1,$limit=5,$cols=1,$start=0)
{
global $user,$db,$template,$LANG;
    $nowtime=time();

    # filter files by having thumbnails
    $condition = "true";
    if($user->setting[featured_type]==2)
    {
        $condition = "f.validate=1 AND f.thumb=1";
    }
    elseif($user->setting[featured_type]==1)
    {
        $condition = "f.validate=1";
    }
    elseif($user->setting[featured_type]==0)
    {
        $condition = "f.thumb=1";
    }

    $searchsql = 'true';
    if(strlen($searchtext))
    {
        $searchsql  = "f.name like '%" . $db->getEscaped($searchtext) . "%'";
        $searchsql .= "or f.descr like '%" . $db->getEscaped($searchtext) . "%'";
    }

    # filter files by filetypes
    $filetypes = array(
    'image' => 1,
    'audio' => 3,
    'doc' => 2,
    'video' => 4,
    'soft' => 5,
    );
    if($filetypes[$filetype]>0&&$filetypes[$filetype]<6)
    {
        $condition .= " and filetype='".$filetypes[$filetype]."'";
    }

    ($hook = YABPlugin::fetch_hook('topfiles_loading',__FILE__,__LINE__)) ? eval($hook) : '';

    $db->setQuery("select f.*,s.http,s.domain from files as f
                  left join server as s on s.server_id=f.server_id
                  where $condition AND $searchsql AND f.deleted=0
                  order by $orderby DESC
                  limit $start,$limit");
    $db->query();
    $rows=$db->loadRowList();

    if(!$rows) return 0;
    $nums = count($rows);
    
    # mixed the ads unit!
    for($i=0;$i<$ads_nums;$i++)
    array_splice($rows, rand(1, $nums), 0, array(array("is_ads"=>1)));

    $nums = count($rows);

    ($hook = YABPlugin::fetch_hook('topfiles_start',__FILE__,__LINE__)) ? eval($hook) : '';

    $i=0;
    foreach($rows as $row)
    {
        $i++;
        $urls=getDownloadUrl($row);
        extract($urls);

        $start = ($i%$cols==1)||($cols==1);
        $end = ($i%$cols==0)||($cols==1)||($nums==$i);

        # mixed in ads!
        if($row[is_ads]==1)
        {
            $template->assign_block_vars('row',array(
                    'is_end'      => $end,
                    'is_start'    => $start,
                    'is_ads'      => 1
                    ));
        }
        else
        {
            $add_time = time()-$row['time'];
            if($add_time>=24*3600)
            $add_days = intval($add_time/(24*3600)) .$LANG[DaysAgo] ;
            elseif($add_time>3600)
            $add_days = intval($add_time/(3600)) .$LANG[HoursAgo] ;
            else
            $add_days = intval($add_time/(60)) .$LANG[MinutesAgo] ;

            $template->assign_block_vars('row', array(
    	 			'downloadurl' => $downloadurl,
                    'thumburl'    => $thumburl,
                    'size'        => convertsize($row[size]),
                    'downloads'   => $row[downloads],
                    'descr'       => $row[descr],
                    'name'        => $row[name],
                    'add_date'    => date(DateFormat,$row['time']),
                    'add_days'    => $add_days,
                    'is_end'      => $end,
                    'is_start'    => $start,
                    'is_ads'      => 0,
    				));
        }
        ($hook = YABPlugin::fetch_hook('build_topfiles_data',__FILE__,__LINE__)) ? eval($hook) : '';
    }

    ($hook = YABPlugin::fetch_hook('topfiles_end',__FILE__,__LINE__)) ? eval($hook) : '';

}
/**
* get total files to be listed
*/
function GetFileNums($searchtext='',$filetype=0)
{
global $db,$user;
    ($hook = YABPlugin::fetch_hook('getfiles_nums_start',__FILE__,__LINE__)) ? eval($hook) : '';

    $condition = "true";
    if($user->setting[featured_type]==2)
    {
        $condition = "f.validate=1 AND f.thumb=1";
    }
    if($user->setting[featured_type]==1)
    {
        $condition = "f.validate=1";
    }
    if($user->setting[featured_type]==0)
    {
        $condition = "f.thumb=1";
    }

    $searchsql = 'true';
    if(strlen($searchtext))
    {
        $searchsql  = "f.name like '%" . $db->getEscaped($searchtext) . "%'";
        $searchsql .= "or f.descr like '%" . $db->getEscaped($searchtext) . "%'";
    }

    # filter files by filetypes
    $filetypes = array(
    'image' => 1,
    'audio' => 3,
    'doc' => 2,
    'video' => 4,
    'soft' => 5,
    );
    if($filetypes[$filetype]>0&&$filetypes[$filetype]<6)
    {
        $condition .= " and filetype='".$filetypes[$filetype]."'";
    }

    $db->setQuery("SELECT count(f.id) as num
                   FROM files as f
                   WHERE $condition AND $searchsql AND f.deleted=0");
    $db->query();
    $row=$db->loadRow();
    
    ($hook = YABPlugin::fetch_hook('getfiles_nums_end',__FILE__,__LINE__)) ? eval($hook) : '';

    return $row[num];
}
/**
*Build url for download files,short, seo url
* @info =array('id'=>,'file'=>,'upload_id'=>,'delete_id'=>,'thumb'=>,'http'=>,'domain'=>,)
*/
function getDownloadUrl($info, $urltype='')
{
global $langWeb,$baseWeb,$user,$SET,$ThumbFileTypes;
    ($hook = YABPlugin::fetch_hook('get_downloadurl_start',__FILE__,__LINE__)) ? eval($hook) : '';

    if(isset($user))
    {
        $SET[skin_dir] = $user->setting[skin_dir];
        $SET[static_url] = $user->setting[static_url];
    }
    
    # get thumbnail url
    $ImageFile= array('jpg','jpeg','gif','png');
    $filetype = getExt($info[name]); 
    $thumbfilename = !in_array($filetype,$ImageFile) ? $info[id].'.jpg':$info[id].'.'.$filetype;

    # get thumbnail url
    if($info[thumb]==1)
    {
        $return[thumburl] = $info[http].$info[domain].'/thumb/thumb_'.$thumbfilename;
    }
    elseif(in_array($filetype,$ThumbFileTypes))
    {
        $return[thumburl] = $baseWeb.'/skin/'.$SET[skin_dir].'/thumb/thumb_'.$filetype.'.png';
    }
    else
    {
        $filetypes = array(
        1 => 'image',
        2 => 'audio',
        3 => 'document',
        4 => 'video',
        5 => 'software',
        6 => 'file',
        );
        $return[thumburl] = $baseWeb.'/skin/'.$SET[skin_dir].'/thumb/thumb_'.$filetypes[$info[filetype]].'.png';
    }
    
    $urltype = $urltype ? $urltype : $SET[static_url];

    ($hook = YABPlugin::fetch_hook('get_downloadurl_process',__FILE__,__LINE__)) ? eval($hook) : '';

    # get download url for different modes
    $return[shareurl]=$baseWeb.'/?d='.$info[upload_id];
    if($urltype=='short')
    {
        $return[downloadurl]=$baseWeb.'/?d='.$info[upload_id];
        $return[deleteurl]=$baseWeb.'/?d='.$info[upload_id].$info[delete_id];
    }
    elseif($urltype=='seo')
    {
        $return[downloadurl]=$langWeb.'/file/'.$info[id].'/'.makeurls($info[name]).'.html';
        $return[deleteurl]=$langWeb.'/delete.php?id='.$info[upload_id].$info[delete_id];
    }
    else
    {
        $return[downloadurl]=$langWeb.'/download.php?id='.$info[upload_id];
        $return[deleteurl]=$langWeb.'/delete.php?id='.$info[upload_id].$info[delete_id];
    }

    $return[statusurl]=$baseWeb.'/filestatus/'.$info[id].'.png';

    ($hook = YABPlugin::fetch_hook('get_downloadurl_end',__FILE__,__LINE__)) ? eval($hook) : '';

    return $return;
}
/**
*Build url for download files,short, seo url
*/
function validateDownloadUrl($urls)
{
global $baseWeb,$db;
    ($hook = YABPlugin::fetch_hook('validate_downloadurl_start',__FILE__,__LINE__)) ? eval($hook) : '';

    if(!is_array($urls)) $urls=array($urls);

    # extract nice info
    $parts = parse_url($baseWeb);
    $domain = strtolower(substr($parts[host],0,4))=='www.' ? substr($parts[host],4):$parts[host];
    $path = str_replace('/','([/]?)',$parts[path]);

    # process the
    $upload_id=$file_id=array();
    if($urls)
    foreach($urls as $url)
    {
        ($hook = YABPlugin::fetch_hook('validate_downloadurl_process',__FILE__,__LINE__)) ? eval($hook) : '';

        $urlparts = parse_url($url);

        if(strlen($urlparts[query]))
        {
            parse_str($urlparts[query],$params);
            if($params[d])
            {
                $upload_id[]= "'".preg_replace('/[^A-Z0-9]/','',$params[d])."'";
            }
            elseif($params[id])
            {
                $upload_id[]=("'".$params[id]."'");
            }
        }
        elseif(strlen($urlparts[path]))
        {
            if(preg_match('#/file/([0-9]+)#', $urlparts[path], $matchesL))
            {
                $file_id[]=intval($matchesL[1]);
            }
        }
    }
    else
    {
        return 0;
    }
    # build query
    $upload_ids=implode(',',$upload_id);
    $file_ids=implode(',',$file_id);

    $upload_ids = $upload_ids ? "upload_id in ($upload_ids) or " : '';
    $file_ids   = $file_ids ? "id in ($file_ids)" : '0';
    
    ($hook = YABPlugin::fetch_hook('validate_downloadurl_ids',__FILE__,__LINE__)) ? eval($hook) : '';

    if(!$upload_ids&&!$file_ids) return 0;
    
    # check against db
    $db->setQuery("select id from files where ($upload_ids $file_ids) and deleted=0");
    $db->query();
    $rows = $db->loadRowList('id');
    
    ($hook = YABPlugin::fetch_hook('validate_downloadurl_end',__FILE__,__LINE__)) ? eval($hook) : '';

    if(!count($rows)) return 0;

    return array_keys($rows);
}
/**
* get the urls for fodlers!
*/
function getFolderUrl($info,$isadmin=0)
{
global $baseWeb,$langWeb;
    ($hook = YABPlugin::fetch_hook('get_folderurl_start',__FILE__,__LINE__)) ? eval($hook) : '';

    $folderurl = $langWeb.'/myfolders/'.$info[fid].'-'.makeurls($info[name]).'.html';

    ($hook = YABPlugin::fetch_hook('get_folderurl_end',__FILE__,__LINE__)) ? eval($hook) : '';

    return $folderurl;
}
function showMyFolders($filelists='')
{
global $db,$template,$LANG,$user,$baseWeb,$input;
    $db->setQuery("select * from folders where uid='$user->uid'");
    $db->query();
    $folders=$db->loadRowList();
    foreach($folders as $folder)
    {

        # get number of files in fodler
        $folder[file_ids] = remove_blank($folder[file_ids]);
        if($folder[file_ids])
        {
            $file_ids = split(',',$folder[file_ids]);
            $folder[files]=count($file_ids);
        }
        else
        {
            $folder[files]=0;
        }
        $folderurl = getFolderUrl($folder);
        $folder[folderurl] = $folderurl;

        # build folder action
        $folder[action]  = '<a href="'.$baseWeb.'/folders.php?folders=1&fid='.$folder[fid].'&act=addfiles&filelists='.$filelists.'">'.$LANG[AddFiles].'</a>';
        $folder[action] .= '::<a href="'.$folderurl.'" target=blank>'.$LANG[ViewFolder].'</a>';

        # output
        $template->assign_block_vars('folder',$folder);
    }
    $template->assign_var('show_folders',1);
}
/**
* ban files by fileid and all others with same md5_hash and size!
*/
function banFiles($fileid,$reason='')
{
global $db,$input;
    # obtain file info
    $db->setQuery("select * from files where id= '$fileid' and deleted=0");
    $db->query();
    $filerow = $db->loadRow();

    if(!$filerow) return 0;

    # find others with same md5_hash and size
    $db->setQuery("select id from files where md5_hash='$filerow[md5_hash]' and size='$filerow[size]'");
    $db->query();
    $filerows = $db->loadRowList();
    $fileids = implode(',',$filerows);

    # ban files and record into db
    $reason = $db->getEscaped($reason);
    $db->setQuery("insert into bannedfiles set fileids= '$fileids', md5_hash='$filerow[md5_hash]', filesize='$filerow[size]', descr='$reason'");
    $db->query();

    # delete them
    $db->setQuery("update files set deleted=1 where md5_hash='$filerow[md5_hash]' and size='$filerow[size]'");
    $db->query();

    return count($filerows);
}
/**
* auth the remote access to upload thumb!
*/
function verify_admin_access()
{
global $db,$input;
    $timeout = time() - 3600;
    $db->setQuery("select * from admin where last_click > $timeout and login_ip= '$input[IP_CLIENT]'");
    $db->query();
    return $db->getNumRows();
}
/**
* build lang list!
*/
function build_lang_list($mylang='',$type='url')
{
global $LANG_TO_MATCH, $CODE_TO_LANG;
    $lang_list = '';
    foreach($LANG_TO_MATCH as $lang=>$matchcode)
    {
        $lang_code  = array_search($lang,$CODE_TO_LANG);
        $lang_list .= '<option value="'.$lang_code.'" '.((is_array($mylang)?in_array($lang_code,$mylang):$lang_code==$mylang)?' selected':'').'>'.ucfirst($lang).($type=='url'?'[?setlang='.$lang_code.'])':'').'</option>';
    }
    return $lang_list;
}
/**
* build lang list!
*/
function build_country_list($mycountry='')
{
global $GEOIP_COUNTRY_NAMES, $GEOIP_COUNTRY_CODES;
    $country_list = '';
    foreach($GEOIP_COUNTRY_NAMES as $id=>$country)
    {
        if($country)
        $country_list .= '<option value="'.$GEOIP_COUNTRY_CODES[$id].'" '.((is_array($mycountry)?in_array($GEOIP_COUNTRY_CODES[$id],$mycountry):$GEOIP_COUNTRY_CODES[$id]==$mycountry)?' selected':'').'>'.$country.'</option>';
    }
    return $country_list;
}
/**
* site stats:today/yesterday uploads
*/
function siteStats()
{
global $db,$user,$template;
    ($hook = YABPlugin::fetch_hook('sitestats_start',__FILE__,__LINE__)) ? eval($hook) : '';

    # check sitestats is enabled
    if($user->setting[sitestats]!=1) return 0;

    list($updatedate,$totalfiles,$todayfiles,$yesterdayfiles,$totalusers) = @split(',',$user->setting[sitestats_data]);

    # make sure the stats be latest
    if($updatedate != date('ymd'))
    {
        list($updatedate,$totalfiles,$todayfiles,$yesterdayfiles,$totalusers) = @split(',', updateUploadStats());
    }

    # template assigning
    $template->assign_vars(array(
    'todayfiles'=>intval($todayfiles),
    'yesterdayfiles'=>intval($yesterdayfiles),
    'totalfiles'=>intval($totalfiles),
    'totalusers'=>intval($totalusers),
    'show_site_stats' => $user->setting[sitestats],
    ));

    ($hook = YABPlugin::fetch_hook('sitestats_end',__FILE__,__LINE__)) ? eval($hook) : '';
}
function updateUploadStats()
{
global $db;
    # build date filter
    $today=date('d');
    $month=date('m');
    $year=date('y');
    $today_time=mktime(0,0,0,$month,$today,$year);
    $yestoday_time=mktime(0,0,0,$month,$today-1,$year);
    $thisweek_time=mktime(0,0,0,$month,$today-6,$year);

    # get stats from db
    $db->setQuery("select count(*) as nums,count(if(time>$today_time,1,NULL)) as todays,count(if($today_time>time and time>$yestoday_time,1,NULL)) as yesterdays from files where deleted=0");
    $db->query();
    $stats=$db->loadRow();
    $totalfiles=$stats[nums];
    $todayfiles=$stats[todays];
    $yesterdayfiles=$stats[yesterdays];

    $db->setQuery("select count(*) as num from users");
    $db->query();
    $stats=$db->loadRow();
    $totalusers=$stats[num];

    # update date
    $updatestr = "$year$month$today,$totalfiles,$todayfiles,$yesterdayfiles,$totalusers";
    $db->setQuery("update setting set sitestats_data='$updatestr' where set_id=1");
    $db->query();

    return $updatestr;
}
/**
* show news
*/
function showNews($clientarea=0,$titleonly=1)
{
global $input,$db,$user,$template;
    ($hook = YABPlugin::fetch_hook('sitenews_start',__FILE__,__LINE__)) ? eval($hook) : '';

    $nowtime=time();
    if($user->uid==0) $wherex=' AND public=1';
    if($clientarea==1) $wherex=' AND public=0';

    $limit=$clientarea?'limit 5':'';

    ($hook = YABPlugin::fetch_hook('sitenews_loading',__FILE__,__LINE__)) ? eval($hook) : '';

    $db->setQuery("select * from news
                   where ((start_date<=$nowtime AND end_date>=$nowtime)
                   OR
                   (start_date=0 AND end_date=0)
                   OR
                   (start_date is null AND end_date is null)
                   )
                   and lang in('na','$user->langcode')
                   $wherex order by date desc $limit");
    $db->query();
    $rows=$db->loadRowList();
    if(!$rows) return '';

    foreach($rows as $row)
    {
        ($hook = YABPlugin::fetch_hook('build_sitenews_data',__FILE__,__LINE__)) ? eval($hook) : '';

        $template->assign_block_vars('news', array(
                'id' =>$row[news_id],
				'title' =>$row[title],
                'publish_date' =>date(DateFormat,$row[date]),
                'body' =>$row[body],
				)
			    );
    }
    
    ($hook = YABPlugin::fetch_hook('sitenews_end',__FILE__,__LINE__)) ? eval($hook) : '';

}
/**
* $cron_id is the filename of crontab script!
*/
function CrontabLog($cron_id, $results)
{
global $input,$db;
    ($hook = YABPlugin::fetch_hook('cronlog_start',__FILE__,__LINE__)) ? eval($hook) : '';

    if(strlen($cron_id)==0) return 0;
    $update_time = time();

    $db->setQuery("insert into cronlogs set results='$results', date='$update_time', cron_id='$cron_id.php'");
    $db->query();

    # update timestamp of crontabs
    $db->setQuery("update crontabs set last_update='$update_time' where cronscript='$cron_id.php'");
    $db->query();
 
    ($hook = YABPlugin::fetch_hook('cronlog_end',__FILE__,__LINE__)) ? eval($hook) : '';

}
/*
* build nav pages links
*/
function buildPageLinks($info,$static=0)
{
global $input,$baseUrl,$LANG;

    if(!is_array($LANG))
    {
        $LANG[Pages]='Pages';
        $LANG[FirstPage]='First page';
        $LANG[LastPage]='Last page';
        $LANG[NextPage]='Next page';
    }

    $pages=  @ceil($info[total]/$info[page]);
    if($pages==1 || $pages== 0) return;
    $span=10;
    $s=intval(($info[cur_page]/$span))*$span;
    for($i=$s;$i<$s+$span; $i++)
    {
       if($i>=$pages) break;
       $start=$i*$info[page];
       $tag=$i+1;
       if($tag==$info[cur_page]+1)
       {
           $html.="&nbsp;<b>$tag</b>";
       }
       else
       {
           if($static)
           $html.=" &nbsp;<a href='$info[baseUrl]/index".($tag>1?$tag:'').".html" . ($info[urlparam]?'?'.$info[urlparam]:'') . "' class=pagenav>$tag</a>";
           else
           $html.=" &nbsp;<a href='$info[baseUrl]&s=$start'".($info[jscript]?' '.$info[jscript]:'')." class=pagenav>$tag</a>";
       }
    }
    if($start+$info[page]>$info[total])
    $start=$start+$info[page];

    $start2=($s-1)*($info[page]);
    $start2=$start2>=0?$start2:0;
    $endpage=($pages-1)*$info[page];
    if($static)
    return "<a href='$info[baseUrl]/index.html". ($info[urlparam]?'?'.$info[urlparam]:''). "' class=pagenav>$LANG[FirstPage]</a>&nbsp;<a href='$info[baseUrl]/index".($start2/$info[page]>0?$start2/$info[page]:'').".html" . ($info[urlparam]?'?'.$info[urlparam]:''). "'><<</a>".$html."&nbsp;<a href='$info[baseUrl]/index".($start/$info[page]+1).".html" . ($info[urlparam]?'?'.$info[urlparam]:''). "'>>></a> <a href='$info[baseUrl]/index".($endpage/$info[page]+1).".html" . ($info[urlparam]?'?'.$info[urlparam]:'') . "'>$LANG[LastPage]</a>($pages $LANG[Pages])";
    else
    return "<a href='$info[baseUrl]&s=0'".($info[jscript]?' '.$info[jscript]:'')." class=pagenav>$LANG[FirstPage]</a>&nbsp;<a href='$info[baseUrl]&s=$start2'".($info[jscript]?' '.$info[jscript]:'')." class=pagenav><<</a>".$html."&nbsp;<a href='$info[baseUrl]&s=$start'".($info[jscript]?' '.$info[jscript]:'')." class=pagenav>>></a> <a href='$info[baseUrl]&s=$endpage'".($info[jscript]?' '.$info[jscript]:'')." class=pagenav>$LANG[LastPage]</a> ($pages $LANG[Pages])";

}
/**
* calculate the progress bar info
*/
function calculateProgress($iTotal,$iRead,$dtstart,$progtype='ajax')
{
global $status,$dtnow,$dtRemainingf,$dtelapsedf,$bSpeedf,$percent,$filename;
global $monitor_file,$data_file,$signal_file, $iMode;
    ##
    # Elapsed time
    # Calculate elapsed time and format for display
    ##
    if($dtnow<1) $dtnow=time();
    
    $dtelapsed = $dtnow - $dtstart;
    $dtelapsed_sec = ($dtelapsed % 60); # gets number of seconds
    $dtelapsed_min = ((($dtelapsed - $dtelapsed_sec) % 3600) / 60); # gets number of minutes
    $dtelapsed_hours = (((($dtelapsed - $dtelapsed_sec) - ($dtelapsed_min * 60)) % 86400) / 3600);
    # gets number of hours; assuming that we won't be going into days!
    if ($dtelapsed_sec < 10) { $dtelapsed_sec = "0$dtelapsed_sec"; } # append leading zero
    if ($dtelapsed_min < 10) { $dtelapsed_min = "0$dtelapsed_min"; } # append leading zero
    if ($dtelapsed_hours < 10) { $dtelapsed_hours = "0$dtelapsed_hours"; } # append leading zero
    $dtelapsedf = "$dtelapsed_hours:$dtelapsed_min:$dtelapsed_sec"; # display as 00:00:00

    ##
    # Upload speed
    ##
    $bSpeed = $iRead; # if not yet determined
    if ($dtelapsed > 0) # avoid divide by zero errors
    {
    	$bSpeed = $iRead / $dtelapsed; # Bytes uploaded / Seconds elapsed = Bytes/Second speed
    	$bitSpeed = $bSpeed * 8; # bps
    	$kbitSpeed = $bSpeed; # Kbps
    }
    else
    {
    	$kbitSpeed = $bSpeed; # just pass the zero value
    }

    if(defined('PHPUPLOADMODULE')&&PHPUPLOADMODULE==1)
    {
        global $statusinfo;
        if($statusinfo['rate']) $kbitSpeed = $statusinfo['rate'];//*8/1000;
    }
    
    $bSpeedf = sprintf("%d",$kbitSpeed); # remove decimals


    ##
    # Est remaining time
    # Calculate remaining time based on upload speed so far
    ##

    $bRemaining = $iTotal - $iRead; # Total size - amount uploaded = amount remaining
    $dtRemaining = 0;
    if ($bSpeed > 0) {
    	# Bytes remaining / Bytes/Second = Seconds
    	$dtRemaining = $bRemaining / $bSpeed;
    }
    $dtRemaining = sprintf("%d",$dtRemaining); # remove decimals
    $dtRemaining_sec = ($dtRemaining % 60); # gets number of seconds
    $dtRemaining_min = ((($dtRemaining - $dtRemaining_sec) % 3600) / 60); # gets number of minutes
    $dtRemaining_hours = (((($dtRemaining - $dtRemaining_sec) - ($dtRemaining_min * 60)) % 86400) / 3600); # gets number of hours; assuming that we won't be going into days!
    if ($dtRemaining_sec < 10)
    {
     	# append leading zero
    	$dtRemaining_sec = "0$dtRemaining_sec";
    }
    if ($dtRemaining_min < 10)
    {
    	# append leading zero
    	$dtRemaining_min = "0$dtRemaining_min";
    }
    if ($dtRemaining_hours < 10)
    {
     	# append leading zero
    	$dtRemaining_hours = "0$dtRemaining_hours";
    }
    $dtRemainingf = "$dtRemaining_hours:$dtRemaining_min:$dtRemaining_sec"; # display as 00:00:00
    $percent = @($iRead * 100 / $iTotal);
    $percent = sprintf("%d",$percent ); # remove decimals
    
    #
	# division results in truncation errors at times so don't compare percentage
	# There have been occaisional reports of the progress bar showing 100% but not
	# disappearing even after file upload has been completed.
	#
	# Nils Menrad came up with the solution which is to modify the end of upload
	# test.
	#
    if($progtype=='ajax')
    {
        if($status ==0)
	    if((($iTotal == $iRead) && $iRead != 0)
        || $iRead>$iTotal
        || file_exists($signal_file))
	    {
  		    show_complete();
            @unlink($progress_file);
            @unlink($monitor_file);
            // for form upload, files will be deleted by upload.cgi
            if($iMode!=1) @unlink($data_file);
            @unlink($signal_file);

            exit;
        }
        else
        flush();
    }
    else
    {
        echo "<script>parent.showProgress('$iRead:$filename,$iTotal,$dtRemainingf,$dtelapsedf,$bSpeedf,$percent')</script>";
    }

}
/**
* validate path, remove the relative path...
*/
function valid_path($path)
{
    $path = str_replace(base64_decode('XA=='),'/',$path);
    $absolute=0;
    if(substr($path,0,1)=='/')
    {
        $absolute=1;
        $path = substr($path,1);
    }
    $parts=split('/',$path);

    $valid_path = '';
    foreach($parts as $part)
    {
        $part = str_replace('..','',$part);
        if(!$part) continue;
        $valid_path.=$valid_path?'/'.$part:$part;
    }
    if($absolute)
    $valid_path = '/'.$valid_path;
    return $valid_path;
}
/**
* validate file, call valid_path
*/
function valid_file($file)
{
    $path = valid_path($file);

    //$path = str_replace('/','',$path);

    return $path;
}
/**
* get extention by the specified separater
*/
function getExt($name,$sep='.')
{
    $ext = substr(strtolower(strrchr($name,$sep)),1);
    #if($ext==''&&strpos($name,$sep)!==false) return ' ';
    return $ext;
}
function blank($var)
{
    return ($var != '');
}
function remove_blank($string,$sep=',')
{
    return implode($sep,array_filter(explode($sep,$string),'blank'));
}

/**
* encrypt and decrypt a string
*/
// --------------
// This function takes a clear-text password and returns an encrypted password
// Written by Jakub
// --------------
function encryptStr($str,$encryption_string=null)
{
    ($hook = YABPlugin::fetch_hook('encryptstr_start',__FILE__,__LINE__)) ? eval($hook) : '';

	$str_encrypted = "";
	$encryption_string = $encryption_string==null?'~!@#$%^&*()_+|':$encryption_string;
	if ($encryption_string % 2 == 1) { // we need even number of characters
		$encryption_string .= $encryption_string{0};
	}
	for ($i=0; $i < strlen($str); $i++) { // encrypts one character - two bytes at once
		$str_encrypted .= sprintf("%02X", hexdec(substr($encryption_string, 2*$i % strlen($encryption_string), 2)) ^ ord($str{$i}));
	}
 
    ($hook = YABPlugin::fetch_hook('encryptstr_end',__FILE__,__LINE__)) ? eval($hook) : '';

	return $str_encrypted;

} // End function encryptPassword
function decryptStr($str_encrypted,$encryption_string=null) {

// --------------
// This function takes an encrypted password and returns the clear-text password
// Written by Jakub
// --------------
// XOR with random string (which is set in settings.inc.php)
    ($hook = YABPlugin::fetch_hook('decryptstr_start',__FILE__,__LINE__)) ? eval($hook) : '';

	$password = "";
    $encryption_string = $encryption_string==null?'~!@#$%^&*()_+|':$encryption_string;
	if ($encryption_string % 2 == 1) { // we need even number of characters
		$encryption_string .= $encryption_string{0};
	}
	for ($i=0; $i < strlen($str_encrypted); $i += 2) { // decrypts two bytes - one character at once
		$password .= chr(hexdec(substr($encryption_string, $i % strlen($encryption_string), 2)) ^ hexdec(substr($str_encrypted, $i, 2)));
	}
 
    ($hook = YABPlugin::fetch_hook('decryptstr_end',__FILE__,__LINE__)) ? eval($hook) : '';

	return $password;

} // End function decryptPassword
/**
* create a temp file with $prefix and $postfix
*/
function mytempname($dir, $prefix='', $postfix='')
{
	if ($dir[strlen($dir) - 1] == '/') { $trailing_slash = ""; }
	else { $trailing_slash = "/"; }

    // Check if the $dir is a directory
	if (!is_dir(realpath($dir)) || filetype(realpath($dir)) != "dir") { return false; }

    // Check if the directory is writeable
	if (!is_writable($dir)){ return false; }

    // Create the temporary filename
	do {
		$seed = substr(md5(microtime()), 0, 8);
		$filename = $dir . $trailing_slash . $prefix . $seed . $postfix;
        #clear cache
        clearstatcache();
	} while (file_exists($filename));
    $filename = $prefix . $seed . $postfix;
	return $filename;

} // end mytempnam

function myfileperms ($filename)
{
    $perms = base_convert(fileperms($filename), 10, 8);
    $perms = substr($perms, (strlen($perms) - 3));
    return $perms;
}

function myparseurl ($uri)
{
    $index = strrpos($uri,':');
    $uri = str_replace('@','+',substr($uri,0,$index)) . substr($uri,$index);
    $parts=@parse_url($uri);
    $parts[user] = str_replace('+','@',$parts[user]);
    return $parts;
}
function shortFilename($filename, $maxlenth)
{
    $filetype     = substr(strtolower(strrchr($filename,'.')),1);
    $fullname = substr($filename,0,-strlen($filetype)-1);

    $shortername = substr($fullname,0,$maxlenth-5).''.substr($fullname,strlen($fullname)-5).'.'.$filetype;

    return $shortername;
}
/**
* convert special character to "-"
*/
function makeurls($name,$separator='-')
{
global $SpecialCharsConvert;
    $name = html_entity_decode($name);

    $name = @str_replace(array_keys($SpecialCharsConvert),array_values($SpecialCharsConvert),$name);

    # replace nonenglish characters
    $name = htmlentities($name);
    $name = preg_replace("/&([a-z])[a-z]+;/i","$1",$name);

    $name = preg_replace("/[^a-z\.A-Z0-9]/i",$separator,$name);

    $maxlenth = 30;
    if(strlen($fullname)>$maxlenth)
    {
        $name = shortFilename($name,$maxlenth);
    }

    $name=str_replace($separator.'.','.',$name);
    $name = preg_replace('/['.$separator.']+/',$separator,$name);
    if(substr($name,0,1)==$separator) $name = substr($name,1);
    if(substr($name,-1,1)==$separator) $name = substr($name,0,strlen($name)-1);

    return strtolower($name);
}
function generateKeywords($name)
{
global $SpecialCharsConvert;
    $name = html_entity_decode($name);

    $name = @str_replace(array_keys($SpecialCharsConvert),array_values($SpecialCharsConvert),$name);

    # replace nonenglish characters
    $name = htmlentities($name);
    $name = preg_replace("/&([a-z])[a-z]+;/i","$1",$name);
    $name = strtolower($name);
    $words = preg_split("#[^a-z0-9]#", $name, -1, PREG_SPLIT_NO_EMPTY);
    foreach ($words as $key => $word)
    {
        if (strlen($word)<=2)
        {
			unset($words[$key]);
            continue;
        }
        if (@in_array($word, array('a','and','www')))
        {
			unset($words[$key]);
            continue;
        }
    }

    $name = implode(', ', $words);

    return $name;
}
/**
* Returns a string where HTML entities have been converted back to their original characters
*
* @param	string	String to be parsed
* @param	boolean	Convert unicode characters back from HTML entities?
*
* @return	string
*/
function unhtmlspecialchars($text, $doUniCode = false)
{
	if ($doUniCode)
	{
		$text = preg_replace('/&#([0-9]+);/esiU', "convert_int_to_utf8('\\1')", $text);
	}

	return str_replace(array('&lt;', '&gt;', '&quot;', '&amp;'), array('<', '>', '"', '&'), $text);
}
/**
* Converts an integer into a UTF-8 character string
*
* @param	integer	Integer to be converted
*
* @return	string
*/
function convert_int_to_utf8($intval)
{
	$intval = intval($intval);
	switch ($intval)
	{
		// 1 byte, 7 bits
		case 0:
			return chr(0);
		case ($intval & 0x7F):
			return chr($intval);

		// 2 bytes, 11 bits
		case ($intval & 0x7FF):
			return chr(0xC0 | (($intval >> 6) & 0x1F)) .
				chr(0x80 | ($intval & 0x3F));

		// 3 bytes, 16 bits
		case ($intval & 0xFFFF):
			return chr(0xE0 | (($intval >> 12) & 0x0F)) .
				chr(0x80 | (($intval >> 6) & 0x3F)) .
				chr (0x80 | ($intval & 0x3F));

		// 4 bytes, 21 bits
		case ($intval & 0x1FFFFF):
			return chr(0xF0 | ($intval >> 18)) .
				chr(0x80 | (($intval >> 12) & 0x3F)) .
				chr(0x80 | (($intval >> 6) & 0x3F)) .
				chr(0x80 | ($intval & 0x3F));
	}
}

/**
* Converts Unicode entities of the format %uHHHH where each H is a hexadecimal
* character to &#DDDD; or the appropriate UTF-8 character based on current charset.
*
* @param	string	Encoded text
*
* @return	string	Decoded text
*/
function convert_urlencoded_unicode($text,$charset='ISO-8859-1')
{
	$return = preg_replace(
		'#%u([0-9A-F]{1,4})#ie',
		"convert_unicode_char_to_charset(hexdec('\\1'), \$charset)",
		$text
	);

	$lower_charset = strtolower($charset);

	if ($lower_charset != 'utf-8' AND function_exists('html_entity_decode'))
	{
		// this converts certain &#123; entities to their actual character
		// set values; don't do this if using UTF-8 as it's already done above.
		// note: we don't want to convert &gt;, etc as that undoes the effects of STR_NOHTML
		$return = preg_replace('#&([a-z]+);#i', '&amp;$1;', $return);

		if ($lower_charset == 'windows-1251' AND phpversion() >= '5')
		{
			// there's a bug in PHP5 html_entity_decode that decodes some entities that
			// it shouldn't. So double encode them to ensure they don't get decoded.
			$return = preg_replace('/&#(128|129|1[3-9][0-9]|2[0-4][0-9]|25[0-5]);/', '&amp;#$1;', $return);
		}

		$return = @html_entity_decode($return, ENT_NOQUOTES, $charset);
	}

	return $return;
}

/**
* Converts a single unicode character to the desired character set if possible.
* Attempts to use iconv if it's available.
* Callback function for the regular expression in convert_urlencoded_unicode.
*
* @param	integer	Unicode code point value
* @param	string	Character to convert to
*
* @return	string	Character in desired character set or as an HTML entity
*/
function convert_unicode_char_to_charset($unicode_int, $charset)
{
	$is_utf8 = (strtolower($charset) == 'utf-8');

	if ($is_utf8)
	{
		return convert_int_to_utf8($unicode_int);
	}

	if (function_exists('iconv'))
	{
		// convert this character -- if unrepresentable, it should fail
		$output = @iconv('UTF-8', $charset, convert_int_to_utf8($unicode_int));
		if ($output !== false AND $output !== '')
		{
			return $output;
		}
	}

	return "&#$unicode_int;";
}
function buildGETQuery($input)
{
    if(is_array($input))
    foreach($input as $key=> $value)
    {
        if(is_array($value))
        {
            foreach($value as $k=> $v)
            {
                if(!is_array($v))
                $myquery.=$key.'%5B'.$k."%5D=".rawurlencode(clean_value($v))."&";
            }
        }
        else
        $myquery.=$key."=".urlencode(clean_value($value))."&";
    }
    return $myquery;
}
/**
* parse request info and build in one array $input
*/
function parse_incoming()
{
  	global $_GET, $_POST, $HTTP_CLIENT_IP, $REQUEST_METHOD, $REMOTE_ADDR, $HTTP_PROXY_USER, $HTTP_X_FORWARDED_FOR;
   	$return = array();

	if( is_array($_GET) )
	{
		while( list($k, $v) = each($_GET) )
		{
			if( is_array($_GET[$k]) )
			{
				while( list($k2, $v2) = each($_GET[$k]) )
				{
					$return[$k][ clean_key($k2) ] =clean_value($v2);
				}
	     	}
			else
			{
				$return[ clean_key($k) ] =clean_value($v);
			}
		}
	}

	// Overwrite GET data with post data

	if( is_array($_POST) )
	{
		while( list($k, $v) = each($_POST) )
        {
    		if ( is_array($_POST[$k]) )
			{
				while( list($k2, $v2) = each($_POST[$k]) )
				{
					$return[$k][ clean_key($k2) ] =clean_value($v2);
				}
			}
			else
			{
				$return[ clean_key($k) ]  =clean_value($v);
			}
		}
	}
    $return['REQUEST_METHOD']=$_SERVER['REQUEST_METHOD'];
    $return['IP_ADDRESS']=$_SERVER['SERVER_ADDR'];
    $return['IP_CLIENT']=$_SERVER['REMOTE_ADDR'];
    $return['IP_CLIENT'] = $_SERVER['HTTP_X_FORWARDED_FOR'] ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
    define('IS_POST',$return['REQUEST_METHOD']=='POST');

	return $return;
}
/**
* called in parse_incoming
*/
function clean_key($key)
{
  	return $key;
}
/**
* called in parse_incoming
*/
function clean_value($val)
{
    if ( get_magic_quotes_gpc()!=0 )
    {
        $val = stripslashes($val);
   	}
  	return $val;
}
/**
* set cookie with a nice interface
* $name: string
* $value: string
*/
function setCookies($name,$value,$sticky=1)
{
global $CookiePrefix;
    
    if ($sticky == 1)
    {
       	$expires = time() + 60*60*24*365;
    }
    if($_SERVER[HTTP_HOST]!='127.0.0.1'&&$_SERVER[HTTP_HOST]!='localhost')
    {
        if(strtolower(substr($_SERVER[HTTP_HOST],0,4))=='www.')
        $cookie_domain = substr($_SERVER[HTTP_HOST],3);
        else
        $cookie_domain = '.'.$_SERVER[HTTP_HOST];
    }
    else
    {
        $cookie_domain = "";
    }
    $cookie_path   = "/";

    $name = $CookiePrefix.$name;
    setcookie($name, $value, $expires, $cookie_path, $cookie_domain);
}
/**
* get cookie with a nice interface
* $name: string
*/
function getCookies($name)
{
global $_COOKIE,$CookiePrefix;

    if (isset($_COOKIE[$CookiePrefix.$name]))
    {
    	return urldecode($_COOKIE[$CookiePrefix.$name]);
   	}
   	else
   	{
   		return FALSE;
   	}

}
/**
* get cookie with a nice interface
* $name: string
*/
function getCookieFrom($cookiename,$source,$prefix='yab_')
{
global $CookiePrefix;
    $prefix = $CookiePrefix;
    $cookiename = $prefix.$cookiename;
    $cookiestring=$source;
    $index1=strpos($cookiestring,$cookiename);
    if ($index1===false || $cookiename=="") return "";
    $index2=strpos($cookiestring,';',$index1);
    if ($index2===false) $index2=strlen($cookiestring);
    return PHPunescape(substr($cookiestring,$index1+strlen($cookiename)+1,$index2-$index1-strlen($cookiename)-1));
}
/**
* record input into the cookie of client side
* used in admin panle to remember the search info on user PC
* $input: array, the source vars
* $prefix: string, a filter on vars
*/
function input2cookie($input,$prefix='')
{
    $parts=split(',',$prefix);
    foreach($input as $name=>$value)
    {
        if(!is_array($value))
        {
            if($parts)
            foreach($parts as $part)
            {
                if(substr($name,0,strlen($part))==$part)
                {
                    setCookies($name,$value);
                    break;
                }
            }
            else
            {
                setCookies($name,$value);
            }
        }
    }
}
/**
* record input into the session of users
* used in admin panle to remember the search info
* $input: array, the source vars
* $prefix: string, a filter on vars
*/
function input2session($input,$prefix='')
{
    $parts=split(',',$prefix);
    foreach($input as $name=>$value)
    {
        if(!is_array($value))
        {
            if($parts)
            foreach($parts as $part)
            {
                if(substr($name,0,strlen($part))==$part)
                {
                    $_SESSION[$name]=$value;
                    break;
                }
            }
            else
            {
                $_SESSION[$name]=$value;
            }
        }
    }
}
/**
* record cookie into the session
* $prefix: string, a filter on vars
*/
function cookie2session($prefix='')
{
global $_COOKIE;
    $parts=split(',',$prefix);
    foreach($_COOKIE as $name=>$value)
    {
        $name=substr($name,4);
        if($parts)
        foreach($parts as $part)
        {
            if(substr($name,0,strlen($part))==$part)
            {
                $_SESSION[$name]=$value;
                break;
            }
        }
        else
        {
            $_SESSION[$name]=$value;
        }
    }
}
/**
* record session into the cookie
* $prefix: string, a filter on vars
*/
function session2cookie($prefix='')
{
global $_COOKIE;
    $parts=split(',',$prefix);
    foreach($_SESSION as $name=>$value)
    {
        if(!is_array($value))
        {
            if($parts)
            foreach($parts as $part)
            {
                if(substr($name,0,strlen($part))==$part)
                {
                    setCookies($name,$value);
                    break;
                }
            }
            else
            {
                setCookies($name,$value);
            }
        }
    }
}
/**
* build nice format for bytes
* $size: digital
* $mode: set to 1 will remove the numbers after the first dot
*/
function convertsize($size,$mode=0)
{
   $times = 0;
   $comma = '.';
   while ($size>1024){
      $times++;
      $size = $size/1024;
   }
   $size2 = floor($size);
   $rest = $size - $size2;
   $rest = $rest * 100;
   $decimal = floor($rest);

   $addsize = $decimal;
   if ($decimal<10) {$addsize .= '0';};

   if ($times == 0){$addsize=$size2;} else
   {$addsize=$size2.$comma.substr($addsize,0,2);}

   switch ($times) {
      case 0 : $mega = " Byte"; break;
      case 1 : $mega = " KB"; break;
      case 2 : $mega = " MB"; break;
      case 3 : $mega = " GB"; break;
      case 4 : $mega = ' TB'; break;
   }
   if($mode==1&&(($pos=strrpos($addsize,'.')))!==false)$addsize=substr($addsize,0,$pos);
   $addsize .= $mega;
   return $addsize;
}
/**
* clean input data
* @ $input is a array or object
* @ $filters is a array
*/
function clean_input(&$input,$filters=array())
{
    if(!is_array($input)&&!is_object($input)) return '';
    $is_obj = is_object($input);
    foreach($filters as $varname=>$vartype)
    {
        if((!$is_obj&&!isset($input[$varname]))||($is_obj&&!isset($input->$varname))) continue;
        $varvalue = $is_obj ? $input->$varname:$input[$varname];
        
        if(is_array($vartype)) {$varfunc = $vartype[1];$vartype = $vartype[0];}
        switch ($vartype)
 	    {
            case INT:      $is_obj ? $input->$varname = intval($varvalue)
                                   : $input[$varname] = intval($varvalue);
                           break;
			case UINT:
                           $is_obj ? $input->$varname = ($varvalue = intval($varvalue)) < 0 ? 0 : $varvalue
                                   : $input[$varname] = ($varvalue = intval($varvalue)) < 0 ? 0 : $varvalue;
                           break;
            case NUM:
                           $is_obj ? $input->$varname = strval($varvalue) + 0
                                   : $input[$varname] = strval($varvalue) + 0;
                           break;
			case UNUM:
                           $is_obj ? $input->$varname = ($varvalue = (strval($varvalue)) < 0) ? 0 : $varvalue
                                   : $input[$varname] = ($varvalue = (strval($varvalue)) < 0) ? 0 : $varvalue;
                           break;
			case STR:      $is_obj ? $input->$varname = strval($varvalue)
                                   : $input[$varname] = strval($varvalue);
                           break;
            case BRSTR:    $is_obj ? $input->$varname = nl2br(strval($varvalue))
                                   : $input[$varname] = nl2br(strval($varvalue));
                           break;
            case ESC:      $is_obj ? $input->$varname = @mysql_real_escape_string($varvalue)
                                   : $input[$varname] = @mysql_real_escape_string($varvalue);
                           break;
			case NOHTML:   $is_obj ? $input->$varname = htmlspecialchars(trim(strval($varvalue)))
                                   : $input[$varname] = htmlspecialchars(trim(strval($varvalue)));
                           break;
			case BOOL:     $is_obj ? $input->$varname = intval(!empty($varvalue))
                                   : $input[$varname] = intval(!empty($varvalue));
                           break;
			case ARR:      $is_obj ? $input->$varname = (is_array($varvalue)) ? $varvalue : array()
                                   : $input[$varname] = (is_array($varvalue)) ? $varvalue : array();
                           break;
            case XSS:      $is_obj ? $input->$varname = preg_replace(array('#javascript#i', '#vbscript#i'),array('java script',   'vb script',$varvalue))
                                   : $input[$varname] = preg_replace(array('#javascript#i', '#vbscript#i'),array('java script',   'vb script',$varvalue));
            case CNT:      $is_obj ? $input->$varname = $varfunc
                                   : $input[$varname] = $varfunc;
                           break;
            case DATE:     $is_obj ? $input->$varname = ($varvalue) ? strtotime(($varvalue)) : time()
                                   : $input[$varname] = ($varvalue) ? strtotime(($varvalue)) : time();
                           break;
            case CSM:
                           if(!function_exists($varfunc)) break;
                           $is_obj ? $input->$varname = $varfunc($input->$varname)
                                   : $input[$varname] = $varfunc($input[$varname]);
                           break;
            case ENUM:     $is_obj ? $input->$varname = in_array($input->$varname,$varfunc) ? $input->$varname : current($varfunc)
                                   : $input[$varname] = in_array($input[$varname],$varfunc) ? $input[$varname] : current($varfunc);
                           break;
        }
    }
}
/**
* clean single input data
* @ $var is a array or object
* @ $vartype is a var type to convert
* @ $varfunc is a custom function to apply the $var
*/
function clean_var(&$var,$vartype=INT,$varfunc=null)
{
    if(is_array($input)||is_object($input)) return '';
    $varvalue = $var;
    switch ($vartype)
 	{
        case INT:   $var = intval($varvalue);   break;
		case UINT:  $var = ($varvalue = intval($varvalue)) < 0 ? 0 : $varvalue;  break;
        case NUM:   $var = strval($varvalue) + 0;  break;
		case UNUM:  $var = ($varvalue = (strval($varvalue)) < 0) ? 0 : $varvalue; break;
		case STR:   $var = strval($varvalue); break;
        case BRSTR: $var = nl2br(strval($varvalue)); break;
        case ESC:   $var = mysql_real_escape_string($varvalue); break;
		case NOHTML:$var = htmlspecialchars(trim(strval($varvalue))); break;
		case BOOL:  $var = !empty($varvalue); break;
        case XSS:   $var = preg_replace(array('#javascript#i', '#vbscript#i'),array('java script',   'vb script',$varvalue));
        case CNT:   $var = $varfunc; break;
        case DATE:  $var = ($varvalue) ? strtotime(($varvalue)) : time(); break;
        case CSM:   if(!function_exists($varfunc)) break;
                    $var = $varfunc($var); break;
        case ENUM:  $var = in_array($var,$varfunc) ? $var : current($varfunc); break;
    }
}
function grabRemoteContent($url)
{
    $content = '';
    if(function_exists('curl_init'))
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        $content = curl_exec($ch);
        curl_close($ch);
    }
    elseif(function_exists('fsockopen'))
    {
        if(!defined(ROOT)) define('ROOT',dirname(dirname(__FILE__)));
        require_once(ROOT.'/includes/http.php');
        $http = new http_class();
        $http->follow_redirect=0;

        $error=$http->GetRequestArguments($url,$arguments);
        $arguments["Headers"]["Pragma"]="nocache";
        $arguments["Referer"]=$url;
        $error=$http->Open($arguments);
        if($error=="")
        {
           $error=$http->SendRequest($arguments);
           if($error=="")
           {
               $headers=array();
               $error=$http->ReadReplyHeaders($headers);
               if($error=="")
               {
                   $red_location = $headers['location'];
                   for(;;)
  		           {
                       $error=$http->ReadReplyBody($body,4096);
                       if(strlen($body)==0) break;
                       $content .= $body;
		           }
               }
    	    }
	    }
	    $http->Close();
        if(!empty($error))
        {
            $content = $error;
        }
    }
    elseif(ini_get('allow_url_fopen'))
    {
        $content = file_get_contents($url);
    }
    else
    {
        $content = ('could not get contents from $url');
    }
    return $content;
}
/**
* debug function
*/
function trace_write()
{
    $direct = 1;
    ob_start();
    for ($i=1; $i<func_num_args(); $i=$i+1)
    {
        $var = func_get_arg($i);
        echo "<pre>".(!$direct?'<textarea cols=60>':'');
	    print_r($var);
	    echo (!$direct?'</textarea>':'')."</pre>";
    }
    $info = ob_get_contents();
    ob_end_clean();

    $fp = @fopen(func_get_arg(0),'a');
    @fputs($fp,$info);
    @fclose($fp);
}
function trace_echo()
{
    $direct = 0;
    for ($i=0; $i<func_num_args(); $i=$i+1)
    {
        $var = func_get_arg($i);
        echo "MFHS debug output: <br><pre>".(!$direct?'<textarea cols=80 cols=1>':'');
	    print_r($var);
	    echo (!$direct?'</textarea>':'')."\r\r</pre>";
    }
}
function mybasename($filepath)
{
    $lastslash = strrpos($filepath, "/"); 
    if($lastslash !== false)
    {
        $filepath = substr($filepath,$lastslash+1);
    } 
    $lastslash = strrpos($filepath, "\\"); 
    if($lastslash !== false)
    {
        $filepath = substr($filepath,$lastslash+1); 
    }  
    
    return $filepath; 
} 
function startTimer()
{
global $starttime;
    $mtime = microtime ();
    $mtime = explode (' ', $mtime);
    $mtime = $mtime[1] + $mtime[0];
    $starttime = $mtime;
}
function endTimer()
{
global $starttime;
    $mtime = microtime ();
    $mtime = explode (' ', $mtime);
    $mtime = $mtime[1] + $mtime[0];
    $endtime = $mtime;
    $totaltime = round (($endtime - $starttime), 5);
    return $totaltime;
}
/**
* redirect to a new page at front end
* @ $url is the url to redirect
*/
function do_redirect($url,$printinfo,$type='standby')
{
global $baseUrl,$db,$baseWeb,$langWeb,$user,$LANG,$input,$template;
    ($hook = YABPlugin::fetch_hook('redirect_start',__FILE__,__LINE__)) ? eval($hook) : '';

    $redirect_url = strtolower(substr($url,0,7))=='http://' ? "$url" : "$baseWeb/$baseUrl$url";

    if($input[inline]==1) $redirect_url = $redirect_url.(strpos($redirect_url,'?')!==false?'&inline=1':'?&inline=1');

    if ($type=='header')
    {
        ($hook = YABPlugin::fetch_hook('redirect_headermode',__FILE__,__LINE__)) ? eval($hook) : '';

        if(!@headers_sent($filename, $linenum))
        {
            header('Location: '.$redirect_url);
            exit;
        }
    }
    if ($type=='simple')
    {
        ($hook = YABPlugin::fetch_hook('redirect_simplemode',__FILE__,__LINE__)) ? eval($hook) : '';

        echo <<<EOF
        <html><head>
        <meta http-equiv="content-type" content="text/html; charset=UTF-8">
        <meta HTTP-EQUIV=Refresh CONTENT="1; URL=$url">
        <title>Redirecting....</title>
        </head>
        <body>
        <script>
        window.setTimeout("location.href='$url';",1000);
        </script>
        $filename, $linenum
        </body>
        </html>
EOF;
        exit;
    }
    
    ($hook = YABPlugin::fetch_hook('redirect_standbymode',__FILE__,__LINE__)) ? eval($hook) : '';

    require_once("header.php");

    $template->assign_vars(array(
        'redirect_url'=>$redirect_url,
        'error_text'  =>$printinfo,
        'PAGETILE'    =>$LANG[SITEERRORS],
    ));
    $template->set_filenames(array(
    	'body' => 'siteerrors.html')
    	);
    $template->pparse('body');
    require_once("footer.php");
    exit();
}
/**
* redirect to a new page in admin panel
* @ $url is the url to redirect
*/
function redirect($url,$html,$error=0)
{
global $baseUrl,$baseWeb,$input,$admin_directory;

    if(strtolower(substr($url,0,7))=='http://')
    $redirect_url="$url";
    else
    $redirect_url=$baseWeb.(defined('IN_ADMIN')?'/'.$admin_directory:'').'/'.$baseUrl.$url;

    if(defined('IN_AJAX')&&IN_AJAX==1)
    {
        //if($error)
        $redirect_url=htmlspecialchars($redirect_url);
        $html=htmlspecialchars($html);
        if(headers_sent($filename, $linenum)) die("Headers already sent in $filename on line $linenum");

        header('Content-type: text/xml');
        echo '<?xml version="1.0" encoding="UTF-8"?>'."\n";
        echo <<<EOF
        <response>
           <error>$error</error>
           <url>$redirect_url</url>
           <body>$html</body>
        </response>
EOF;
        exit;
    }
    # POST from form action
    if($_SERVER['REQUEST_METHOD']=='POST'&&defined('IN_AJAX')&&IN_AJAX==1) {exit($redirect_url);}
    # GET by clicking some link
    if($_SERVER['REQUEST_METHOD']=='GET'&&defined('IN_AJAX')&&IN_AJAX==1) {header("location:".$redirect_url."&IN_AJAX=1");exit;}
    echo <<<EOF
    <style>
    TABLE, TR, TD                   { font-family: Verdana,Arial; font-size: 12px;  }
    BODY                            { font: 10px Verdana; background-color: #FCFCFC; padding: 0; margin: 0 }
    .tablewrap {background-color:#EEF2F7;
                border-bottom:1px solid #D1DCEB;
                border-right:1px solid #D1DCEB ;
    		    border-top:1px solid #FFF;
    			border-left:1px solid #FFF; }
    </style>
    <br><br>
    <script>
    window.setTimeout("location.href='$redirect_url';",2500);
    </script>
    <table width=70% align=center class=tablewrap><tr><td>

              $html<br /><br />
    		  Please wait while we transfer you...<br /><br />
    	      (<a href='$redirect_url'>Or click here if you do not wish to wait</a>)
    </td></tr></table>
EOF;
    exit();
}
?>
