<?php
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
/**
* @package MFHS
* Uploader class
*/
class uploader {
	/** basic infomation */
    var $upload_session = null;
    var $access_code    = '';
    var $upload_mode    = 1;
    var $upload_method  = array('can_formupload','can_ftpupload','can_urlupload','can_flashupload');
    var $server_id      = 0;
    var $upload_dir     = 'files';
    var $temp_dir       = 'temp';
    var $upload_time    = 0;
    var $uploaded_num   = 0;
    var $uploaded_size  = 0;
    var $upload_start   = 0;
    var $uploaded_files = array();
    var $uploader_id    = 0;
    
    var $timeout        = 0;
    var $max_uploads    = 10;
    var $keep_ext       = false;
    var $keep_name      = false;
    
    var $upload_errors  = null;
    
    /** upload url */
    var $upload_url='';
    var $applet_upload_url='';

    var $extras      = array();

    var $sizelimit   = 1000000000000;
    var $typelimit   = array();
    var $typelimit2  = array();
    
    var $size_func   = array(2=>'getUrlFileSize',3=>'getFTPFileSize');
    var $get_func    = array(1=>'getLocalFile',2=>'getUrlFile',3=>'getFTPFile',4=>'getLocalFile');
    
    /** progress bar setting */
    var $progbar     = 'total';//or 'single'
    var $progtype    = 'ajax';//or 'syn'
    var $use_progbar = true;// false to disable progress bar
	/**
	* uploader object constructor
	*/
	function uploader($server_id=1,$type=0)
    {
    global $db, $DATASTORE;
        ($hook = YABPlugin::fetch_hook('uploader_initiating',__FILE__,__LINE__)) ? eval($hook) : '';

        $this->server_id     = $server_id;
        
        # new added
        $this->upload_server = $DATASTORE[servers][$server_id];

        # used in ver 1.1
        if($type==1&&!$this->upload_server)
        {
            ($hook = YABPlugin::fetch_hook('uploader_server_loading',__FILE__,__LINE__)) ? eval($hook) : '';

            $db->setQuery("select * from server where server_id='$server_id'");
            $db->query();
            $server = $db->loadRow();
            # for flash upload use!
            $this->server_domain = $server[domain];
            $server[cgi_prog_mode] = 'ajax';
            
            #
            $this->upload_server = $server;
        }
        # delete the private info for possible old version
        unset($this->upload_server[ftp]);
        unset($this->upload_server[user]);
        unset($this->upload_server[pass]);
        
        ($hook = YABPlugin::fetch_hook('uploader_apply_setting',__FILE__,__LINE__)) ? eval($hook) : '';

        # upload setting
        $this->upload_dir = $this->upload_server[upload_dir];
        $this->keep_ext   = $this->upload_server[keep_ext]=='yes';

        # set form upload backend script
        define('PHPUPLOADMODULE', intval($this->upload_server[formupload_type]=='php'));

        # will be configurable in future version 1.3+
        $this->keep_name   = $this->upload_server[keep_name]=='yes';
        
        ($hook = YABPlugin::fetch_hook('uploader_initiated',__FILE__,__LINE__)) ? eval($hook) : '';

	}
    function setUploadMode($upload_mode)
    {
        ($hook = YABPlugin::fetch_hook('uploader_setuploadmode_start',__FILE__,__LINE__)) ? eval($hook) : '';

        $this->upload_mode = $upload_mode;

        if($upload_mode == 1) $this->progtype    = 'ajax';//$this->upload_server[cgi_prog_mode];
        if($upload_mode == 2) $this->progtype    = $this->upload_server[url_prog_mode];
        if($upload_mode == 3) $this->progtype    = $this->upload_server[ftp_prog_mode];

        if($upload_mode == 1)
        {
            $this->temp_dir = $this->upload_server[cgi_temp_dir];
        }
        else
        {
            $this->temp_dir = $this->upload_server[php_temp_dir];
        }
        
        ($hook = YABPlugin::fetch_hook('uploader_setuploadmode_end',__FILE__,__LINE__)) ? eval($hook) : '';

    }
    function create_session($user_id=0)
    {
        ($hook = YABPlugin::fetch_hook('uploader_uploadsession_create',__FILE__,__LINE__)) ? eval($hook) : '';

        $session = md5(microtime());
        $this->access_code    = base64_encode(encryptStr("$user_id",$session));
        $this->upload_session = $session;
        
        ($hook = YABPlugin::fetch_hook('uploader_uploadsession_finish',__FILE__,__LINE__)) ? eval($hook) : '';

	}
    function validate_session(&$user,$access_code,$upload_session)
    {
        ($hook = YABPlugin::fetch_hook('uploader_uploadsession_validate',__FILE__,__LINE__)) ? eval($hook) : '';

        $this->access_code    = $access_code;
        $this->upload_session = preg_replace('/[^a-z0-9]/','',$upload_session);

        $uid = decryptStr(base64_decode($this->access_code),$this->upload_session);

        if(is_numeric($uid))
        {
            ($hook = YABPlugin::fetch_hook('uploader_uploadsession_loaduser',__FILE__,__LINE__)) ? eval($hook) : '';

            $this->uploader_id = $uid;

            # check if this is member!
            if($uid&&$user->uid!=$uid)
            {
                # assign var from script vitually!
                $_SESSION['uid']=$uid;
                $_SESSION['logined']=1;
                $_SESSION['last_click']=time();
                # important: to recover the langauge choice!
                $_SESSION['mylang']=$user->getValue('mylang');
                $user = new user('session');

                # initiate user
                $user->initiate();
            }
            
            # apply the upload setting from users
            $this->sizelimit   = $user->allowed_filesize;
            $this->typelimit   = $user->allowed_filetypes;
            $this->typelimit2  = $user->disabled_filetypes;
            $this->max_uploads = $user->max_uploads;
            
            ($hook = YABPlugin::fetch_hook('uploader_uploadsession_ok',__FILE__,__LINE__)) ? eval($hook) : '';

            return true;
        }
        
        ($hook = YABPlugin::fetch_hook('uploader_uploadsession_fail',__FILE__,__LINE__)) ? eval($hook) : '';

        $this->setError('invalid upload session!'.$this->upload_session.','.$this->access_code);
        return false;
	}
    function accept($files)
    {
    global $db,$user,$input;
        # empty the vars
        $this->uploaded_files  = array();
        $this->uploaded_num    = 0;
        # especially designed for flash uplaod, since multiple upload file are send to server independently!
        $this->upload_time     = abs($_SESSION[upload_time]-time())<60 ? $_SESSION[upload_time] : time()+rand(1,60);

        ($hook = YABPlugin::fetch_hook('uploadfile_inputcheck_start',__FILE__,__LINE__)) ? eval($hook) : '';

        # slice the files and keep the key unchanged
        $s = 0;$sliced_files=array();
        foreach($files as $k=>$v)
        {
            $s++;
            if($s>$this->max_uploads) break;
            $sliced_files[$k]=$v;;
        }
        $files = $sliced_files;

        ($hook = YABPlugin::fetch_hook('uploadfile_inputcheck_end',__FILE__,__LINE__)) ? eval($hook) : '';

        if(count($files)==0) $this->setError('No upload files found!');
        
        ($hook = YABPlugin::fetch_hook('uploadfile_progress_preparestart',__FILE__,__LINE__)) ? eval($hook) : '';

        # get total size for url upload and ftp upload
        if($this->use_progbar&&$this->upload_mode!=1&&$this->upload_mode!=4)
        {
            if($this->progbar=='total')
            {
                $this->upload_start = time();
                $files = $this->getTotalSize($files);
            }
            # syn progress
            if($this->progtype=='syn')
            {
                flush();
                # avoid cache in IE browser!
                echo str_repeat(' ',256);
            }
            # ajax progress
            if($this->progtype=='ajax'&&$this->progbar=='total')
            {
                $monitor_file = $this->upload_session.'_flength';
                $fp2=fopen($this->temp_dir.'/'.$monitor_file,'wb');
                fwrite($fp2,$this->total_size);
                fclose($fp2);
            }
        }

        ($hook = YABPlugin::fetch_hook('uploadfile_progress_prepareend',__FILE__,__LINE__)) ? eval($hook) : '';

        flush();

        ($hook = YABPlugin::fetch_hook('acceptfile_start',__FILE__,__LINE__)) ? eval($hook) : '';

        # process every file
        foreach($files as $id=>$tmpfile)
        {
            ($hook = YABPlugin::fetch_hook('acceptfile_check',__FILE__,__LINE__)) ? eval($hook) : '';

            # get html id to identify the description and password for flash upload
            if($this->upload_mode==4) $id = 0;
            if($this->upload_mode==1&&PHPUPLOADMODULE==1) {$id = substr($id,11);}

            # assign start time
            if($this->progbar=='single') $this->upload_start = time();

            # get file
            ($hook = YABPlugin::fetch_hook('acceptfile_getfile',__FILE__,__LINE__)) ? eval($hook) : '';

            $function = $this->get_func[$this->upload_mode];
            $file     = $this->$function($tmpfile);

            $file[name] = unhtmlspecialchars($file[name],1);
            $file[name] = str_replace(' ','_',$file[name]);
            $file[name] = str_replace('%20','_',$file[name]);

            if($file[error]) {$this->setError($file[errinfo]);continue;}

            $allow_copy = 1;

            # calculate MD5 string
            $md5_hash = md5_file($file[tmp_name]);
            $file[md5_hash] = $md5_hash;

            # the file is banned?
            $db->setQuery("select * from bannedfiles where md5_hash='$md5_hash' and filesize='$file[size]'");
            $db->query();
            if($db->getNumRows()>0)
            {
                # File is banned!
                $this->setError('Upload failed: the file:' . basename($file[filename]) .' is banned for some reason');
                continue;
            }

            # find duplicate files
            $db->setQuery("select id, file, server_id from files where md5_hash='$md5_hash'");
            $db->query();
            if($db->getNumRows()>0)
            {
                # find it!
                $allow_copy = 0;
                if($this->upload_server[keep_name]=='yes') rmdir($this->upload_dir.'/'.dirname($file[filename]));

                $filerow = $db->loadRow();
                $file[filename]  = $filerow[file];
                if($filerow[server_id]!=$this->server_id) $file[server_id] = $filerow[server_id];
            }

            # move the temporay file to upload_dir
            ($hook = YABPlugin::fetch_hook('acceptfile_copy',__FILE__,__LINE__)) ? eval($hook) : '';

            if($allow_copy==1&&!copy($file[tmp_name], $this->upload_dir.'/'.$file[filename]))
            {
                ($hook = YABPlugin::fetch_hook('acceptfile_copyfail',__FILE__,__LINE__)) ? eval($hook) : '';

                $this->setError('Copy error: Upload directory:' .$this->upload_dir .' can not be written in:'.basename($file[filename]));
                continue;
            }
            
            # get extras information
            $this->temps = $extras  = array('descr'=>$this->extras['descr'][($id)],'password'=>$this->extras['password'][($id)]);

            ($hook = YABPlugin::fetch_hook('insertfile_start',__FILE__,__LINE__)) ? eval($hook) : '';

            # record into db
            $fileobj  = $this->insertDB($file,$extras);

            # check insert...
            $insertid = $fileobj->id;

            # create thumbnails for images
            require_once( ROOT.'/includes/image.class.php' );
            $this->createThumb($fileobj,$file);

            # add tags for files
            require_once( ROOT.'/includes/tag.class.php' );
            $tag = new Tag($db);
            $tags = $tag->add(convert_urlencoded_unicode(htmlspecialchars($this->extras['tags'][($id)])),$insertid);

            ($hook = YABPlugin::fetch_hook('insertfile_end',__FILE__,__LINE__)) ? eval($hook) : '';

            # insert fails
            if($insertid==0) break;

            #delete the temporay files
            @unlink($file[tmp_name]);

            ($hook = YABPlugin::fetch_hook('acceptfile_end',__FILE__,__LINE__)) ? eval($hook) : '';

            #uploaded...
            $this->uploaded_num++;
            $this->uploaded_files[$insertid] = $fileobj;
            $this->uploaded_size=$this->uploaded_size+$file[size];
        }
        
        ($hook = YABPlugin::fetch_hook('acceptfile_done',__FILE__,__LINE__)) ? eval($hook) : '';

        ($hook = YABPlugin::fetch_hook('uploadfile_progress_createsignal',__FILE__,__LINE__)) ? eval($hook) : '';

        # ajax progress
        if($this->use_progbar&&$this->upload_mode!=1 && $this->progtype=='ajax' && $this->progbar=='total')
        {
            $signal_file  = $this->upload_session.'_signal';
            $fp2=fopen($this->temp_dir.'/'.$signal_file,'wb');
            fclose($fp2);
        }
        
        ($hook = YABPlugin::fetch_hook('uploadfile_progress_endsignal',__FILE__,__LINE__)) ? eval($hook) : '';

        # upload is finished,do some updates on user's stats and redirect...
        $this->uploadStats();
        
        ($hook = YABPlugin::fetch_hook('uploadfile_done',__FILE__,__LINE__)) ? eval($hook) : '';

    }
    function inputExtras($prefix,$customfields=array())
    {
    global $input;
         foreach($customfields as $fieldname)
         $this->extras[$fieldname] = $input[$prefix.$fieldname]=='null'? '' : $input[$prefix.$fieldname];
    }
    function createThumb(&$fileobj,$file=array())
    {
    global $db,$user,$input,$ImageFile,$ImageFile2,$VideoFile;
        $server = $this->upload_server;
        $mod_status = split(',',$server[mod_status]);

        /**
        * initiate Image class
        */
        $i = new Image();
        $i->ImageFile  = $ImageFile;
        $i->ImageFile2 = $ImageFile2;
        $i->VideoFile  = $VideoFile;
        $i->setWorkDirs(($file[server_id]!=$this->server_id ? '' : $server[upload_dir]),'thumb',$server[php_temp_dir]);
        $i->setModuleStatus($mod_status[0],$mod_status[1],$mod_status[2]);

        $i->MPLAYER_PATH = $server[mplayer_path];
        $i->FFMPEG_PATH  = $server[ffmpeg_path];
        $i->IM_PATH      = $server[im_path];

        $i->USE_MPLAYER  = $mod_status[1]?1:0;
        $i->USE_IM       = $mod_status[0]?1:0;

        $i->thumb_width  = $user->setting[thumb_width];
        $i->thumb_height = $user->setting[thumb_height];
        $i->thumb_type   = $user->setting[thumb_type];

        # filename
        $filename        = $file[server_id]!=$this->server_id ? $file[tmp_name] : $fileobj->file;
        $ext_sep         = $server[keep_name]=='no' ? (getExt($fileobj->file,'_')=='' ? '.' : '_') : '.';

        # thumbnail, replace _ with .
        $thumbfilename   =  'thumb_' . $fileobj->id . '.' . getExt($fileobj->file,$ext_sep);

        /**
        * create thumbnails for Image or Video files
        */
        if($i->canThumb($fileobj->file,$ext_sep))
        {
            if($i->isImage($fileobj->file,$ext_sep))
            {
                $image = array(
                'name'  => $filename,
                'thumb' => $thumbfilename,
                );
                $result = $i->createThumb($image,0);
            }
            if($i->isVideo($fileobj->file,$ext_sep))
            {
                $thumbfilename = $i->convertFiletype($thumbfilename,'jpg',1);
                $image = array(
                'name'  => $filename,
                'thumb' => $thumbfilename,
                );
                $result = $i->createVideoThumb($image,0);
            }
            if($result!=-1)
            {
                $db->setQuery("update files set thumb=1 where id='$fileobj->id'");
                $db->query();
                
                $fileobj->thumb = 1;
            }
        }
    }
    function getTotalSize($files)
    {
        ($hook = YABPlugin::fetch_hook('uploadfile_gettotalsize_start',__FILE__,__LINE__)) ? eval($hook) : '';

        $returns = array();
        $this->total_size = 0;
        # process every file
        foreach($files as $key=>$tmpfile)
        {
            if(strlen($tmpfile)==0) continue;

            ($hook = YABPlugin::fetch_hook('uploadfile_getfilesize_start',__FILE__,__LINE__)) ? eval($hook) : '';

            # get file size
            $function = $this->size_func[$this->upload_mode];
            $file     = $this->$function($tmpfile);

            ($hook = YABPlugin::fetch_hook('uploadfile_getfilesize_end',__FILE__,__LINE__)) ? eval($hook) : '';

            if($file[error]) {$this->setError($file[errinfo]);continue;}
            
            $returns[$key] = $tmpfile;
            $this->total_size=$this->total_size+$file[size];
        }

        ($hook = YABPlugin::fetch_hook('uploadfile_gettotalsize_end',__FILE__,__LINE__)) ? eval($hook) : '';

        return $returns;
    }
    function uploadStats()
    {
    global $db;
        ($hook = YABPlugin::fetch_hook('uploadfile_updatestats_start',__FILE__,__LINE__)) ? eval($hook) : '';

        # update the users stats
        if($this->uploader_id!=0&&$this->uploaded_num)
        {
            $db->setQuery("update users set files=files+$this->uploaded_num where id='$this->uploader_id'");
            $db->query();
        }
        # update the server stats
        if($this->uploaded_num)
        {
            $db->setQuery("update server set hosted=hosted+$this->uploaded_num,webspace=webspace+$this->uploaded_size where server_id='$this->server_id'");
            $db->query();
        }

        # update upload stats
        updateUploadStats();

        ($hook = YABPlugin::fetch_hook('uploadfile_updatestats_end',__FILE__,__LINE__)) ? eval($hook) : '';

    }
    function getUploadIDs()
    {
    global $db;
        ($hook = YABPlugin::fetch_hook('uploader_getuploadids',__FILE__,__LINE__)) ? eval($hook) : '';

        $db->setQuery("select id,name,filetype,size,descr,password,delete_id,upload_id,thumb,server_id from files where upload_session='$this->upload_session'");
        $db->query();
        return $db->loadRowList();
    }
    function checkFile(&$file)
    {
        ($hook = YABPlugin::fetch_hook('filelimitions_check_start',__FILE__,__LINE__)) ? eval($hook) : '';

        $filesize = $file[size];
        $filetype = getExt($file[name]);
        if($filesize>$this->sizelimit
           ||($this->typelimit&&!in_array($filetype,$this->typelimit))
           ||($this->typelimit2&&in_array($filetype,$this->typelimit2)))
        {
            $file[error] = 1;
            $file['errinfo']="Size $filesize ($this->sizelimit bytes) or type $filetype error";
        }
        else
        {
            $file[error] = 0;
        }
        
        ($hook = YABPlugin::fetch_hook('filelimitions_check_end',__FILE__,__LINE__)) ? eval($hook) : '';

        return !$file[error];
    }
    function getUrlFile($uri)
    {
        ($hook = YABPlugin::fetch_hook('geturlfile_start',__FILE__,__LINE__)) ? eval($hook) : '';

        $filename=basename($uri);
        $filetype=getExt($filename);
        
        # system used file
        $data_file     = $this->upload_session.'_postdata';
        $progress_file = $this->upload_session.'_progress';
        $monitor_file  = $this->upload_session.'_flength';
        $signal_file   = $this->upload_session.'_signal';
        
        # construct the tmpfile
        $tmpfile=array('name'=>$filename);

        # initaiting http class and setting
        $http = new http_class();
        
        $http->timeout = $this->timeout;
        $http->data_timeout = $this->timeout;

        ($hook = YABPlugin::fetch_hook('geturlfile_http_request',__FILE__,__LINE__)) ? eval($hook) : '';

        $error=$http->GetRequestArguments($uri,$arguments);
        $arguments["Headers"]["Pragma"]="nocache";
        $error=$http->Open($arguments);
        if($error=="")
        {
            $error=$http->SendRequest($arguments);
            if($error=="")
            {
                ($hook = YABPlugin::fetch_hook('geturlfile_read_header',__FILE__,__LINE__)) ? eval($hook) : '';

                $headers=array();
                $error=$http->ReadReplyHeaders($headers);
                if($error=="")
                {
                    # get file size
                    if($http->content_length_set==1)
                    {
                        $filesize=$http->content_length;
                        $tmpfile['size'] = $filesize;
                    }
                    
                    # get the exact file info
                    global $filename;
                    $filename=basename($http->request_uri);
                    $filetype=getExt($filename);
                    $tmpfile['name']=$filename;

                    $filename = str_replace(' ','_',$filename);
                    $filename = str_replace('%20','_',$filename);

                    # check file limitions
                    if(!$this->checkFile($tmpfile)) return $tmpfile;

                    ($hook = YABPlugin::fetch_hook('geturlfile_progressinfo_start',__FILE__,__LINE__)) ? eval($hook) : '';

                    # set progress bar info
                    $dtstart = $this->upload_start;
                    $iTotal  = $this->progbar=='single' ? $filesize : $this->total_size;
                    $iRead   = $this->progbar=='single' ? 0 : $this->uploaded_size;

                    # record filesize into $flength_name
                    if($this->use_progbar&&$this->progtype=='ajax'&&$this->progbar=='single')
                    {
                        $fp2=fopen($this->temp_dir.'/'.$monitor_file,'wb');
                        fwrite($fp2,$iTotal);
                        fclose($fp2);
                    }

                    # create temporary file
                    $fp=fopen($this->temp_dir.'/'.$data_file,'wb');
                    $tmpfile['tmp_name'] = $this->temp_dir.'/'.$data_file;   
                    # and downloading file
                    for($i=0;;)
  		            {
                        ($hook = YABPlugin::fetch_hook('geturlfile_data_arrive',__FILE__,__LINE__)) ? eval($hook) : '';

                        # read response body
                        $error=$http->ReadReplyBody($body,4096);
                        if($error!="")
                        {
                            $http->Close();
                            fclose($fp);
                            $tmpfile['error']    = 1;
                            $tmpfile['errinfo']  = 'Remote file error';
                            return $tmpfile;
                        }
                        
                        # read size
                        $readlength=strlen($body);
                        $iRead +=$readlength;
                        
                        ($hook = YABPlugin::fetch_hook('geturlfile_progressinfo_update',__FILE__,__LINE__)) ? eval($hook) : '';

                        # progress bar
                        # if($this->progtype=='syn'&&$i%100==0) sleep(1);
                        if($this->use_progbar&&$this->progtype=='syn'&&$readlength!=0)
                        {
                            //showProgStatus($iTotal,$iRead,$dtstart,&$dtRemainingf,&$dtelapsedf,&$bSpeedf,&$percent);
                            calculateProgress($iTotal,$iRead,$dtstart,'syn');
                        }
                        elseif($this->use_progbar&&$i%5==0)
                        {
                            $this->writeContents($this->temp_dir.'/'.$progress_file, $iRead.':'.$filename);
                        }

                        if($readlength==0) break;

                        # write response contents to temporary file
                        fwrite($fp,$body);

                        # progress bar
                        if($this->use_progbar&&$this->progtype=='syn'&&$i%5==0)
                        {
                            calculateProgress($iTotal,$iRead,$dtstart,'syn');
                        }
                        
                        # record loops
                        $i++;
		            }
                    fclose($fp);
                    
                    ($hook = YABPlugin::fetch_hook('geturlfile_data_finish',__FILE__,__LINE__)) ? eval($hook) : '';
                    
                    # check filesize again
                    $tmpfile[size] = $iRead - $this->uploaded_size;
                    if(!$this->checkFile($tmpfile)) return $tmpfile;

                    ($hook = YABPlugin::fetch_hook('geturlfile_progressinfo_finish',__FILE__,__LINE__)) ? eval($hook) : '';

                    # create signal file
                    if($this->use_progbar&&$this->progtype=='ajax'&&$this->progbar=='single')
                    {
                        $fp2=fopen($this->temp_dir.'/'.$signal_file,'wb');
                        fclose($fp2);
                    }

                    $tmpfile['error']=0;
                }
                else
                {
                    $tmpfile['error']=1;
                }
	      	}
            else
            {
                $tmpfile['error']=1;
            }
        }
        else
        {
            $tmpfile['error']=1;
        }
	    $http->Close();

        if($tmpfile['error']==0) $tmpfile['filename'] = $this->keep_name ? $this->tempname_ex($filename) : $this->tempname($filetype);

        return $tmpfile;
    }
    function getUrlFileSize($uri)
    {
        $filename=basename($uri);
        $filetype=getExt($filename);

        # construct the tmpfile
        $tmpfile=array('name'=>$filename);

        $http = new http_class();

        $error=$http->GetRequestArguments($uri,$arguments);
        $arguments["Headers"]["Pragma"]="nocache";
        $error=$http->Open($arguments);
        if($error=="")
        {
            $error=$http->SendRequest($arguments);
            if($error=="")
            {
                $headers=array();
                $error=$http->ReadReplyHeaders($headers);
                if($error=="")
                {
                    #get file size
                    foreach($headers as  $header_name => $header_value)
			        {
			    		if($header_name=='content-length')
			    		{
                            $filesize=$header_value;
                            $tmpfile['size']     = $filesize;

                            if(!$this->checkFile($tmpfile)) return $tmpfile;
                            break;
			    		}
			    	}
                }
                else
                {
                    $tmpfile['error']=1;
                }
	      	}
            else
            {
                $tmpfile['error']=1;
            }
        }
        else
        {
            $tmpfile['error']=1;
        }
	    $http->Close();
        if($tmpfile['error']==1&&$error) $tmpfile['errinfo']=$error;
        return $tmpfile;
    }
    function getFTPFile($uri)
    {
        # system used file
        $data_file     = $this->upload_session.'_postdata';
        $progress_file = $this->upload_session.'_progress';
        $monitor_file  = $this->upload_session.'_flength';
        $signal_file   = $this->upload_session.'_signal';
        
        $ftp = new ftp();
        $ftp->debug = TRUE;

        # parse ftp url
        $parts=myparseurl($uri);
        $ftp_host=$parts[host];
        $ftp_port=$parts[port]?$parts[port]:'21';
        $ftp_user=$parts[user]?$parts[user]:'anonymous';
        $ftp_pass=$parts[pass]?$parts[pass]:'anonymous';
        $remote_filename=$parts[path];

        $filename=basename($uri);
        $filetype=getExt($filename);

        # construct the tmpfile
        $tmpfile=array('name'=>$filename);
        
        # connect to ftp host
        if (!$ftp->ftp_connect($ftp_host,$ftp_port))
        {
            $tmpfile['error']=1;
            $tmpfile['errinfo']='Cannot connect';
            return $tmpfile;
        }

        # login with username and password
        if (!$ftp->ftp_login($ftp_user, $ftp_pass)) {
    	    $ftp->ftp_quit();
            $tmpfile['error']=1;
            $tmpfile['errinfo']='Login failed';
            return $tmpfile;
        }

        # get file size
        $filesize = $ftp->ftp_size($remote_filename);
        if($filesize == -1)
        {
            $tmpfile['error']=1;
            $tmpfile['errinfo']='Could not get file size';
            return $tmpfile;
        }
        else
        {
            $tmpfile['size']=$filesize;
        }

        # check file by us
        if(!$this->checkFile($tmpfile)) return $tmpfile;

        # create temporary file
        # $stored_name=mytempname($this->temp_dir, '', $filetype);
        $tmpfile['tmp_name'] = $this->temp_dir.'/'.$data_file;
        $fp=fopen($tmpfile['tmp_name'],'wb');
        
        $iTotal  = $filesize;
        $iTotal  = $this->progbar=='single' ? $filesize : $this->total_size;

        # assign var to ftp calss
        $ftp->total_size    = $iTotal;
        $ftp->progtype      = $this->progtype;
        $ftp->use_progbar   = $this->use_progbar;
        $ftp->progress_file = $this->temp_dir.'/'.$progress_file;
        
        # record filesize into $flength_name
        if($this->use_progbar&&$this->progtype=='ajax')
        {
            $fp2=fopen($this->temp_dir.'/'.$monitor_file,'wb');
            fwrite($fp2,$iTotal);
            fclose($fp2);
        }

        # downloading the file
        if (!$ftp->ftp_get($tmpfile['tmp_name'],$remote_filename))
        {
    	    $ftp->ftp_quit();
            $tmpfile['error']=1;
            $tmpfile['errinfo']='Download error';

            return $tmpfile;
        }
        
        # create signal file
        if($this->use_progbar&&$this->progtype=='ajax'&&$this->progbar=='single')
        {
            $fp2=fopen($this->temp_dir.'/'.$signal_file,'wb');
            fclose($fp2);
        }
                    
        $ftp->ftp_quit();

        if($tmpfile['error']==0) $tmpfile['filename'] = $this->keep_name ? $this->tempname_ex($filename) : $this->tempname($filetype);

        return $tmpfile;
    }
    function getFTPFileSize($uri)
    {
        $ftp = new ftp();
        $ftp->debug = TRUE;

        # parse ftp url
        $parts=myparseurl($uri);
        $ftp_host=$parts[host];
        $ftp_port=$parts[port]?$parts[port]:'21';
        $ftp_user=$parts[user]?$parts[user]:'anonymous';
        $ftp_pass=$parts[pass]?$parts[pass]:'anonymous';
        $remote_filename=$parts[path];

        $filename=basename($uri);
        $filetype=getExt($filename);

        # construct the tmpfile
        $tmpfile=array('name'=>$filename);

        # connect to ftp host
        if (!$ftp->ftp_connect($ftp_host,$ftp_port))
        {
            $tmpfile['error']=1;
            $tmpfile['errinfo']='Cannot connect';
            return $tmpfile;
        }

        # login with username and password
        if (!$ftp->ftp_login($ftp_user, $ftp_pass)) {
    	    $ftp->ftp_quit();
            $tmpfile['error']=1;
            $tmpfile['errinfo']='Login failed';
            return $tmpfile;
        }

        # get file size
        $filesize = $ftp->ftp_size($remote_filename);
        if($filesize == -1)
        {
            $tmpfile['error']=1;
            $tmpfile['errinfo']='Could not get file size';
            return $tmpfile;
        }
        else
        {
            $tmpfile['size']=$filesize;
        }

        # check file by us
        if(!$this->checkFile($tmpfile)) return $tmpfile;
        
        return $tmpfile;
    }
    function getLocalFile($file)
    {
        $filetype=getExt($file['name']);

        # check file by us
        $this->checkFile($file);
        $file['filename'] = $this->keep_name ?
                            $this->tempname_ex($file['name'])
                            :
                            $this->tempname($filetype);
        return $file;
    }
    /**
    * this function create a unique filename on servers to store uploaded files
    */
    function tempname($filetype)
    {
        # format: 7 chars name + server id + ext
        # return mytempname($this->upload_dir, '', $this->server_id) . (!$this->keep_ext?'_':'.') . $filetype;
        # format: 8 chars name + .server id + ext
        return mytempname($this->upload_dir) . '.' . $this->server_id . (!$this->keep_ext ? '_' : '.') . $filetype;
        # format: unqiue server id + 7 chars name +  ext
        //return mytempname($this->upload_dir, $this->server_id) . (!$this->keep_ext?'_':'.') . $filetype;
        # format: server id + 7 chars name +  ext
        //return mytempname($this->upload_dir, $this->server_id, (!$this->keep_ext?'_':'.').$filetype);
        # format: 8 chars name +  ext
        //return mytempname($this->upload_dir, '', (!$this->keep_ext?'_':'.').$filetype);
    }
    /**
    * this function try to create a digtal subdirectory for storing files with original filename
    * the original filname are encoded by rawurlencode for system and language compatibility
    */
    function tempname_ex($filename)
    {
        # do the first check
        do
        {
            $do_times++;
            $r = rand(100,999);
            $r = str_pad($r,4-strlen($r),0,STR_PAD_LEFT);
            if(!is_dir($this->upload_dir.'/'.$r))
            {
                mkdir($this->upload_dir.'/'.$r);
                break;
            }
        }
        while(file_exists($this->upload_dir.'/'.$r.'/'.rawurlencode($filename)));

        return $r.'/'.rawurlencode($filename);
    }
    function getUploadID($filename)
    {
    global $db;
        return sprintf("%08x", $this->upload_time).$this->server_id;
        if($this->keep_name)
        {
            return sprintf("%08x", $this->upload_time).$this->server_id;
            # may not increase if upload is quick!
            //return sprintf("%08x", filemtime($this->upload_dir.'/'.$filename)+$i).$this->server_id;
            // Create the upload id
	        /*do {
		        $rand_id = substr(md5(microtime()), 0, 4);
	        } while (file_exists($this->upload_dir.'/'.$filedir.'/'.$this->server_id.$rand_id));

            return $filedir.$this->server_id.$rand_id; */
        }
        else
        {
            return substr($filename,0,8).$this->server_id;
            // Create the upload id
	        /*do {
		        $upload_id = substr(md5(microtime()), 0, 8);
                $db->setQuery("select * from files where upload_id='$upload_id' limit 1");
                $db->query();
                $exists = $db->getNumRows();
	        } while ($exists);*/
        }
    }
    function writeContents($filename, $contents)
    {
        $fwriteHandle = @fopen($filename, "w");
        if (!is_resource($fwriteHandle))
        {
            return false;
        }

        fwrite($fwriteHandle, $contents);
        fclose($fwriteHandle);

        return true;
    }
    /**
    *5:store infomation in db:make the uplaod time is unique by "fake" uploadtime
    */
    function InsertDB($file,$extras=array())
    {
    global $db,$user,$input,$FileExtensions;
        ($hook = YABPlugin::fetch_hook('dbinsert_start',__FILE__,__LINE__)) ? eval($hook) : '';

        # get upload ip
        $upload_ip = $input[uploadmode]!=1?$input[IP_CLIENT]:$input[IP_CGI];
        $upload_ip = empty($input[IP_CGI])?$input[IP_CLIENT]:$input[IP_CGI];

        # generate unique upload id and delete id
        $upload_id = strtoupper($this->getUploadID($file[filename]));
        $delete_id = strtoupper(substr(md5(microtime()), 0, 4));

        # prepare data
        $filetable = new TABLE($db,'files','id');
        $filetable->time        = $this->upload_time;
        $filetable->server_id   = is_numeric($file[server_id]) && $file[server_id] > 0 ? $file[server_id] : $this->server_id;
        $filetable->upload_session = $this->upload_session;
        $filetable->upload_method  = $this->upload_mode;
        $filetable->uid         = $this->uploader_id;
        $filetable->password    = $user->dl_password==1?$extras[password]:'';
        $filetable->descr       = $extras[descr];
        
        $filetable->ip          = $upload_ip;
        $filetable->file        = $file[filename];
        $filetable->size        = $file[size];
        $filetable->name        = $file[name];

        $filetable->upload_id   = $upload_id;
        $filetable->delete_id   = $delete_id;

        $filetype = getExt($file[name]);
        foreach($FileExtensions as $typeid => $extensions)
        {
            if(in_array($filetype, $extensions)) $filetable->filetype = $typeid;
        }
        if($filetable->filetype == 0) $filetable->filetype = $typeid;

        $filetable->md5_hash    = $file[md5_hash];

        ($hook = YABPlugin::fetch_hook('dbinsert_prepare',__FILE__,__LINE__)) ? eval($hook) : '';

        # inserting
        $filetable->insert();
        
        ($hook = YABPlugin::fetch_hook('dbinsert_done',__FILE__,__LINE__)) ? eval($hook) : '';

        # increase upload time to avoid repeat one!
        $this->upload_time++;
        $_SESSION[upload_time] = $this->upload_time;
        
        # return file id
        $filetable->id         = $filetable->insertid();
        return $filetable;
    }
    function setError($err)
    {
        echo $err;
        $this->upload_errors .= $err."\n";
    }
}
?>
