<?php
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: ywyhnchina@163.com
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
|   > Last updated: 8th Feb 2008
+--------------------------------------------------------------------------
*/
/**
* @package MFHS
* Email
*/
class Email
{
	var $msg;
    var $handler;
    var $template;

	function Email($tpl_dir)
	{
        # template parser
        $this->template = new SmartTemplate( $tpl_dir );
        $this->template->reuse_code=0;

        # email handler
        $this->handler = new PHPMailer();
	}

	// Sets an email address to send to
	function to($address, $realname = '')
	{
		$addr = trim($address);
		$name = strpos($address,'<')===false && strpos($address,'>')===false ? trim($realname) : '';
        $this->handler->AddAddress($addr,$name);
	}

	function replyto($address, $realname = '')
	{
		$this->handler->AddReplyTo($address, $realname);
	}

	function from($address,$realname='')
	{
        $addr = trim($address);
		$name = strpos($address,'<')===false && strpos($address,'>')===false ? trim($realname) : '';

        $this->handler->From = ($addr);
		$this->handler->FromName = ($name);
	}
 
	// Send the mail out to the recipients set previously in var $this->address
	function send($handle,$HTMLCode='')
	{
		global $LANG;

        // load the email template
        if(strlen($handle))
        $this->msg = $this->template->assign_var_from_handle('', $handle,1,1);
        else
        $this->msg = $this->template->result2($HTMLCode);

		// We now try and pull a subject from the email body ... if it exists,
		// do this here because the subject may contain a variable
		$drop_header = '';
		$match = array();
		if (preg_match('#^(Subject:(.*?))$#m', $this->msg, $match))
		{
			$this->handler->Subject = (trim($match[2]) != '') ? trim($match[2]) : (($this->handler->Subject != '') ? $this->handler->Subject : $LANG['NO_SUBJECT']);
			$drop_header .= '[\r\n]*?' . preg_quote($match[1], '#');
		}
		else
		{
			$this->handler->Subject = (($this->handler->Subject != '') ? $this->handler->Subject : $LANG['NO_SUBJECT']);
		}
		if (preg_match('#^(Charset:(.*?))$#m', $this->msg, $match))
		{
			$this->handler->Charset = (trim($match[2]) != '') ? trim($match[2]) : trim($LANG['Charset']);
			$drop_header .= '[\r\n]*?' . preg_quote($match[1], '#');
		}
		else
		{
			$this->handler->Charset = trim($LANG['charset']);
		}
        if (preg_match('#^(HtmlEmail:(.*?))$#m', $this->msg, $match))
		{
            $ContentType = (trim($match[2]) != '') ? trim($match[2]) : trim($LANG['HtmlEmail']);
			$this->handler->IsHTML($ContentType=='text/html');
			$drop_header .= '[\r\n]*?' . preg_quote($match[1], '#');
		}
		else
		{
			$this->handler->IsHTML(false);
		}
		if ($drop_header)
		{
			$this->msg = trim(preg_replace('#' . $drop_header . '#s', '', $this->msg));
		}

        $this->handler->Body = implode("\n", preg_split("/\r?\n/", $this->msg));
                    
		$this->handler->Send();;

        $this->handler->ClearAddresses();
        $this->handler->ClearAttachments();
    }

}
?>
