<?php
/*
+--------------------------------------------------------------------------
|   Auto installer v1.0
|   ========================================
|   by Stephen Yabziz
|   (c) 2005 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: ywyhnchina@163.com
+---------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 7th Jan 2006
+--------------------------------------------------------------------------
*/
class install {
	var $config = array();
    var $vars   = array();
    var $lang   = array();
    var $_begin = '##';
    var $_end   = '##';
    var $_begin2= '!#';
    var $_end2  = '!#';
    var $step   = 0;
    var $class_hash = '9acb78c4ad37d315f572ed01ac6148b7';
    var $debug  = true;
    
	function install( $ini='' )
    {
        if(!file_exists($ini)) exit("Fata error:Install config file $ini can not be found!");
        $this->config = parse_ini_file($ini,1);
        $info=$this->getSection('INSTALL');
        $this->_begin  = $info['var_begin'];
        $this->_end    = $info['var_end'];
        $this->_begin2 = $info['lng_begin'];
        $this->_end2   = $info['lng_end'];
        $this->debug   = $info['debug'];
        
        if(!is_file('lang/'.$info['lang'].'.php')) return '';
        include_once( 'lang/'.$info['lang'].'.php' );
        $this->lang    = $lang;
	}
    /**
    * decide to extract the source file for the install or not
    */
    function checkAutoInstall()
    {
    global $input;
        $info=$this->getSection('INSTALL');
        $this->auto_install = intval($info[auto_install]==1&&!file_exists($info[install_dir].'/'.$info[check_file]));

        if($this->auto_install==1&&$this->step!=-2) $this->step = -1;
        elseif($this->step==-1)
        {
            if(isset($input['back'])) $this->step = -2;
            if(isset($input['continue'])) $this->step = 0;
        }

        $this->install_data = $info[install_data];
        $this->install_dir  = dirname(getcwd());//$info[install_dir];
    }
    /**
    * dectect the envoiment before the install
    */
    function detectENV()
    {
        $vars=$this->getSection('REQUIRMENT');
        foreach($vars as $var=>$val)
        {
            list($type,$num)=explode('.',$var);
            $pos=strpos($val,':');
            list($name,$okmsg,$warnmsg)=split(':',$val);
            if($type=='module')
            {
                $ok=extension_loaded($name);
            }
            elseif($type=='dir')
            {
                $ok=is_writable($this->install_dir.'/'.$name);
            }
            elseif($type=='function')
            {
                $ok=function_exists($name);
            }
            else
            {
                $ok=0;
            }
            $msg=$ok?$this->evalLang($okmsg):$this->evalLang($warnmsg);
            $this->results[$type][]=array('status'=>$ok,'name'=>($name),'descr'=>ucfirst($msg));
        }
    }
    /**
    * $result=array('status'=>$ok,'name'=>$name,'descr'=>$msg)
    */
    function addENVResult($type,$result)
    {
        if(!empty($type))$this->results[$type][]=$result;
    }
    /**
    * write config file:eval the predefined value of file content
    */
    function writeConfig()
    {
        $vars=$this->getSection('CONFIG');
        foreach($vars as $sfile => $dfile)
        {
            if(file_exists('config/'.$sfile))
            {
                $ok = 1;
                $content=$this->evalValue(file_get_contents ('config/'.$sfile));
                if(!$fp=@fopen($this->install_dir.'/'.$dfile,'wb')) $ok=0;
                if(!@fputs($fp,$content)) $ok=0;
                @fclose($fp);
                $return[$this->install_dir.'/'.$dfile]=array($ok,$content);
            }
            elseif($sfile)
            $this->debug("CONFIG File [config/$sfile] Lost");
        }
        return $return;
    }
    /**
    * form display funtion
    */
    function printFormHeader()
    {
        echo "<form action='?' method=POST>";
    }
    function printFormFooter()
    {
        switch($this->step)
        {
        case '-3' :
            $continue = "Continue";
            break;
        case '-2' :
            $continue = $this->auto_install?"Extract the source":"Begin install";
            break;
        case '-1' :
            $continue = "Continue";
            break;
        case '0' :
            $continue = $this->can_install?"Continue":"Refresh";
            break;
        case '1' :
            $continue = "Register";
            break;
        case '2' :
            $continue = "Continue";
            break;
        case '3' :
            $continue = "Install";
            break;
        case '4' :
            $continue = "Finish";
            break;
        case '5' :
            $continue = "Continue";
            break;
        }
        echo "<input type=hidden name=step value='$this->step'>";
        echo ($this->step==-1||$this->step==-2||$this->step==-3?'':"<input type=submit name=back value='back'>");
        echo ($this->step==5?'':"<input type=submit name=".($this->step!=0||$this->can_install?'continue':'refresh')." value='$continue'>");
        if($this->step==0&&!$this->can_install) echo "<input type=submit name='continue' value='Ignore'>";
        echo "</form>";
    }
    function buildForm()
    {
        $this->loadCustom();
        $vars=$this->getSection('SECTION');
        foreach($this->fields as $group=>$fields)
        {
            printHeader($this->evalLang($vars[$group]));
            foreach($fields as $name => $field)
            {
                $data=array('name'=>$this->evalLang($name),'descr'=>$this->evalLang($field[descr]),'value'=>!empty($this->vars[$name])&&$field[type]=='text'?$this->evalValue($this->vars[$name]):$this->evalValue($this->evalLang($field[value])),'type'=>$field[type]);
                printRow($data);
            }
            printFooter();
        }
    }
    function loadCustom()
    {
        $vars=$this->getSection('CUSTOM');
        foreach($vars as $var=>$val)
        {
            list($group,$type,$name)=explode('.',$var);
            $pos=strpos($val,':');
            if($pos===false) $pos=strlen($val);

            $this->fields[$group][$name]=array('value'=>substr($val,$pos+1),'descr'=>substr($val,0,$pos),'type'=>$type);
        }
    }
    function buildHiddenFields()
    {
        $vars=$this->getSection('CUSTOM');
        foreach($vars as $var=>$val)
        {
            list($group,$type,$name)=explode('.',$var);
            if($type=='hidden') echo "<input type=hidden name=$name value=".$this->evalLang($val).">";
        }
    }
    /**
    * assign value from user input to the var defined in ini file
    */
    function assignVars($input)
    {
        $vars=$this->getSection('CUSTOM');
        foreach($vars as $var=>$val)
        {
            list($group,$type,$name)=explode('.',$var);
            $this->vars[$name]=$input[$name];
        }
        $vars=$this->getSection('MYSQL');
        foreach($vars as $var=>$val)
        {
            $this->vars[$var]=$input[$var];
        }
        $this->vars=array_intersect($this->vars,$input);
        
        if(dirname($_SERVER[PHP_SELF])!='/')
        $guessurl=$baseWeb="http://".$_SERVER[HTTP_HOST].dirname($_SERVER[PHP_SELF]);
        else
        $guessurl=$baseWeb="http://".$_SERVER[HTTP_HOST];

        $this->addVar('scriptUrl',dirname($guessurl));
        $this->addVar('scriptDir',dirname(getcwd()));
        $this->addVar('remotesqlhost',$_SERVER[HTTP_HOST]);
        $this->addVar('scriptDomain',substr(dirname($guessurl),7));
        $this->addVar('cgiUrl',substr(dirname($guessurl),7).'/cgi-bin');
        $this->addVar('downloadDir',dirname(getcwd()).'/data/files/');
        $this->addVar('backupDir',dirname(getcwd()).'/data/backup/');
    }
    /**
    * add single var to $this->vars
    */
    function addVar($name,$value)
    {
        if(!empty($name))$this->vars[$name]=$value;
    }
    /**
    * execute the custom query defined in ini file
    */
    function execSQLQuery()
    {
        $this->sqlQuery=$this->getSection('QUERY');
        $return = array();
        foreach($this->sqlQuery as $query)
        {
            $return[] = $this->evalValue($query);
        }
        return $return;
    }
    /**
    * execute the external sql file in the directory "sql"
    */
    function execSQLFile()
    {
        $sqlfiles=$this->getSection('SQLFILE');
        $SQL = $return = array();
        foreach($sqlfiles as $sqlfile)
        {
            if(file_exists('sql/'.$sqlfile)&&strlen($sqlfile))
            $SQL=array_merge($SQL,readSqlFile('sql/'.$sqlfile));
            elseif($sqlfile)
            $this->debug("SQL File [sql/$sqlfile] Lost");
        }

        foreach($SQL as $query)
        {
            $return[] = $this->evalValue($query);
        }
        return $return;
    }
    /**
    * execute the custom script located in directory inc
    */
    function execINC($step,$location='start')
    {
        $incs=$this->getSection('INC');
        $file=$incs['inc.'.$step.'.'.$location];
        if(file_exists('inc/'.$file)&&strlen($file))
        require_once('inc/'.$file);
        elseif($file)
        $this->debug("INC File [inc/$file] Lost");
        
        return true;
        foreach($incs as $inc=>$file)
        {
            list($inc,$step,$location)=explode('.',$var);
            if(file_exists('inc/'.$file)&&strlen($file)&&$step==$install_step)
            require_once('inc/'.$file);
        }
    }
    function evalValue($str)
    {
        return preg_replace('/('.$this->_begin.')([a-zA-Z0-9\_]+)('.$this->_end.')/ieU','$this->vars[\\2]',$str);
    }
    function evalLang($str)
    {
        return preg_replace('/('.$this->_begin2.')([a-zA-Z0-9\_]+)('.$this->_end2.')/ieU','$this->lang[\\2]',$str);
    }
    function getSection($name)
    {
        return $this->config[$name];
    }
    function debug($text)
    {
        if($this->debug) echo $text;
    }
}
function readSqlFile($sqlfile)
{
global  $cfg,$table_prefix,$input;
    $sql_query='';

    $ext=strtolower(strrchr(basename($sqlfile),'.'));
    if($ext=='.sql')
    {
        $sql_query = @fread(@fopen($sqlfile, 'r'), @filesize($sqlfile));
    }
    else
    {
        $zp = gzopen($sqlfile, "r");
        if ($zp)
        while (!gzeof($zp))
        {
           $sql_query .= gzgets ($zp, 4096) ;
        }
    }

    if ( get_magic_quotes_runtime()!=0 )
    {
        $sql_query = stripslashes($sql_query);
   	}
    
	$sql_query = remove_remarks($sql_query);
	$sql_query = split_sql_file($sql_query, $delimiter_basic=';');

    return  $sql_query;
}
function remove_comments(&$output)
{
	$lines = explode("\n", $output);
	$output = "";

	// try to keep mem. use down
	$linecount = count($lines);

	$in_comment = false;
	for($i = 0; $i < $linecount; $i++)
	{
		if( preg_match("/^\/\*/", preg_quote($lines[$i])) )
		{
			$in_comment = true;
		}

		if( !$in_comment )
		{
			$output .= $lines[$i] . "\n";
		}

		if( preg_match("/\*\/$/", preg_quote($lines[$i])) )
		{
			$in_comment = false;
		}
	}

	unset($lines);
	return $output;
}

//
// remove_remarks will strip the sql comment lines out of an uploaded sql file
//
function remove_remarks($sql)
{
	$lines = explode("\n", $sql);

	// try to keep mem. use down
	$sql = "";

	$linecount = count($lines);
	$output = "";

	for ($i = 0; $i < $linecount; $i++)
	{
		if (($i != ($linecount - 1)) || (strlen($lines[$i]) > 0))
		{
			if ($lines[$i][0] != "#")
			{
				$output .= $lines[$i] . "\n";
			}
			else
			{
				$output .= "\n";
			}
			// Trading a bit of speed for lower mem. use here.
			$lines[$i] = "";
		}
	}

	return $output;

}

//
// split_sql_file will split an uploaded sql file into single sql statements.
// Note: expects trim() to have already been run on $sql.
//
function split_sql_file($sql, $delimiter)
{
	// Split up our string into "possible" SQL statements.
	$tokens = explode($delimiter, $sql);

	// try to save mem.
	$sql = "";
	$output = array();

	// we don't actually care about the matches preg gives us.
	$matches = array();

	// this is faster than calling count($oktens) every time thru the loop.
	$token_count = count($tokens);
	for ($i = 0; $i < $token_count; $i++)
	{
		// Don't wanna add an empty string as the last thing in the array.
		if (($i != ($token_count - 1)) || (strlen($tokens[$i] > 0)))
		{
			// This is the total number of single quotes in the token.
			$total_quotes = preg_match_all("/'/", $tokens[$i], $matches);
			// Counts single quotes that are preceded by an odd number of backslashes,
			// which means they're escaped quotes.
			$escaped_quotes = preg_match_all("/(?<!\\\\)(\\\\\\\\)*\\\\'/", $tokens[$i], $matches);

			$unescaped_quotes = $total_quotes - $escaped_quotes;

			// If the number of unescaped quotes is even, then the delimiter did NOT occur inside a string literal.
			if (($unescaped_quotes % 2) == 0)
			{
				// It's a complete sql statement.
				$output[] = $tokens[$i];
				// save memory.
				$tokens[$i] = "";
			}
			else
			{
				// incomplete sql statement. keep adding tokens until we have a complete one.
				// $temp will hold what we have so far.
				$temp = $tokens[$i] . $delimiter;
				// save memory..
				$tokens[$i] = "";

				// Do we have a complete statement yet?
				$complete_stmt = false;

				for ($j = $i + 1; (!$complete_stmt && ($j < $token_count)); $j++)
				{
					// This is the total number of single quotes in the token.
					$total_quotes = preg_match_all("/'/", $tokens[$j], $matches);
					// Counts single quotes that are preceded by an odd number of backslashes,
					// which means they're escaped quotes.
					$escaped_quotes = preg_match_all("/(?<!\\\\)(\\\\\\\\)*\\\\'/", $tokens[$j], $matches);

					$unescaped_quotes = $total_quotes - $escaped_quotes;

					if (($unescaped_quotes % 2) == 1)
					{
						// odd number of unescaped quotes. In combination with the previous incomplete
						// statement(s), we now have a complete statement. (2 odds always make an even)
						$output[] = $temp . $tokens[$j];

						// save memory.
						$tokens[$j] = "";
						$temp = "";

						// exit the loop.
						$complete_stmt = true;
						// make sure the outer loop continues at the right point.
						$i = $j;
					}
					else
					{
						// even number of unescaped quotes. We still don't have a complete statement.
						// (1 odd and 1 even always make an odd)
						$temp .= $tokens[$j] . $delimiter;
						// save memory.
						$tokens[$j] = "";
					}

				} // for..
			} // else
		}
	}

	return $output;
}
class unzipfile
{
	var $zipname;

	function unzipfile($zipname)
	{
		$this->zipname = $zipname;
	}

	function extract($to)
	{
        if($to=='') $to='.';
        $fp = @fopen($this->zipname, "rb");

		@fseek($fp, filesize($this->zipname)-18);

		$centralDir = unpack('vdisk/vdisk_start/vdisk_entries/ventries/Vsize/Voffset/vcomment_size', @fread($fp, 18));
        //print_r($centralDir);
		$pos = $centralDir['offset'];

		for ($i = 0, $extracted = 0; $i < $centralDir['entries']; $i++) {

			@rewind($fp);
			@fseek($fp, $pos);

			$data = unpack('Vid', @fread($fp, 4));
			if ($data['id'] != 0x02014b50)
				return -1;

			$fileHeader = unpack('vversion/vversion_extracted/vflag/vcompression/vmtime/vmdate/Vcrc/Vcompressed_size/Vsize/vfilename_len/vextra_len/vcomment_len/vdisk/vinternal/Vexternal/Voffset', @fread($fp, 42));

			$fileHeader['filename'] = fread($fp, $fileHeader['filename_len']);
			$fileHeader['extra'] = ($fileHeader['extra_len'] > 0) ? fread($fp, $fileHeader['extra_len']) : '';
			$fileHeader['comment'] = ($fileHeader['comment_len'] > 0) ? fread($fp, $fileHeader['comment_len']) : '';

			$isDirectory = 0;
			if (substr($fileHeader['filename'], -1) == '/')
				$isDirectory = 1;

			$fileHeader['mtime'] = $this->toUnixTimeStamp($fileHeader['mdate'], $fileHeader['mtime']);

			$pos = ftell($fp);

			@rewind($fp);
			@fseek($fp, $fileHeader['offset']);

			// ----- File entry
			$data = unpack('Vid', @fread($fp, 4));
			if ($data['id'] != 0x04034b50)
				return -1;

			$fileHeader = unpack('vversion/vflag/vcompression/vmtime/vmdate/Vcrc/Vcompressed_size/Vsize/vfilename_len/vextra_len', @fread($fp, 26));

			$fileHeader['filename'] = fread($fp, $fileHeader['filename_len']);
			$fileHeader['extra'] = ($fileHeader['extra_len'] > 0) ? fread($fp, $fileHeader['extra_len']) : '';

			$fileHeader['mtime'] = $this->toUnixTimeStamp($fileHeader['mdate'], $fileHeader['mtime']);

            if ($isDirectory) {
                $dirs = explode('/', $fileHeader['filename']);
				array_pop($dirs);
				$path ='';

				// ----- Create directories which are necessary
				foreach ($dirs as $dir) {
					$path .= $dir;
					if (!file_exists($to."/".$path) || !is_dir($to."/".$path))
						mkdir($to."/".$path);

					$path .= '/';
				}
            }
			// ----- Do the extraction (if not a directory)
			if (!$isDirectory) {

                $last=strtolower(strrchr($fileHeader['filename'],'.'));
                $last=substr($last,1);

                if($last!='css'&&$last!='jpeg'&&$last!='gif'&&$last!='jpg'&&$last!='png')
                {
                    //continue;
                }
				$dirs = explode('/', $fileHeader['filename']);
				array_pop($dirs);
				$path ='';

				// ----- Create directories which are necessary to store file
				foreach ($dirs as $dir) {
					$path .= $dir;
					if (!file_exists($to."/".$path) || !is_dir($to."/".$path))
						mkdir($to."/".$path);

					$path .= '/';
				}

				// ----- Look for not compressed file
				if ($fileHeader['compressed_size'] == $fileHeader['size']) {
					if (($destFile = @fopen($to."/".$fileHeader['filename'], 'wb')) == 0)
						return -1;

					$fsize = $fileHeader['compressed_size'];
					while ($fsize != 0) {
						$readSize = ($fsize < 2048 ? $fsize : 2048);
						$buffer = fread($fp, $readSize);
						@fwrite($destFile, pack('a'.$readSize, $buffer), $readSize);
						$fsize -= $readSize;
					}

					fclose($destFile);

					touch($to."/".$fileHeader['filename'], $fileHeader['mtime']);

				} else {

					if (($destFile = @fopen($to."/".$fileHeader['filename'], 'wb')) == 0)
						return -1;

					$buffer = @fread($fp, $fileHeader['compressed_size']);

					// ----- Decompress the file
					$fileContent = gzinflate($buffer);
					unset($buffer);

					// ----- Write the uncompressed data
					fwrite($destFile, $fileContent, $fileHeader['size']);
					unset($fileContent);

					fclose($destFile);

					// ----- Change the file mtime
					touch($to."/".$fileHeader['filename'], $fileHeader['mtime']);
				}
			}
		}
	}

	function toUnixTimeStamp ($mdate, $mtime)
	{
		if ($mdate && $mtime) {
			$hour = ($mtime & 0xF800) >> 11;
			$minute = ($mtime & 0x07E0) >> 5;
			$second = ($mtime & 0x001F) * 2;

			$year = (($mdate & 0xFE00) >> 9) + 1980;
			$month = ($mdate & 0x01E0) >> 5;
			$day = $mdate & 0x001F;

			return mktime($hour, $minute, $second, $month, $day, $year);

		} else
			return time();
	}
}
?>
