<?
/*
+--------------------------------------------------------------------------
|   Auto installer v1.0
|   ========================================
|   by Stephen Yabziz
|   (c) 2005 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: ywyhnchina@163.com
+---------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 7th Jan 2006
+--------------------------------------------------------------------------
*/
error_reporting  (E_ERROR | E_WARNING | E_PARSE );
include "includes/install.php";
include "includes/form.inc.php";

$input = parse_incoming();

$product       = 1;
$need_account_register = 1;
$need_register = 0;

$candroptable = isset($input['droptable'])?intval($input['droptable']):$_COOKIE['droptable'];
/**
* load the install class
*/
$install =new install('includes/install.ini');
$install->assignVars($input);

$step = isset($input[step])?intval($input[step]):-2;
if(isset($input['refresh'])) $step=$step;
if(isset($input['continue'])) $step=$step+1;
if(isset($input['back']))     $step=$step-1;

/**
* if the register is disabled,ignore this step
*/
if($need_register==0&&($step==1||$step==2)&&isset($input['continue'])) $step=3;
if($need_register==0&&($step==1||$step==2)&&isset($input['back'])) $step=0;

$install->step = $step;

$install->checkAutoInstall();

/**
* lock the installer!
*/
if(file_exists('install.locked')) $install->step = $step = -3;

require 'includes/header.html';
switch($install->step)
{

   /**
   * Step -3
   */
   case '-3' :
   $install->execINC($install->step,'start');
   
   $install->printFormHeader();
   printMsg($install->lang['welcome_title'],$install->lang['installer_locked']);
   $install->printFormFooter();

   break;
   /**
   * Step -2:welcome message
   */
   case '-2' :
   $install->execINC($install->step,'start');

   $install->printFormHeader();
   printMsg($install->lang['welcome_title'],$install->lang['welcome_text']);
   $install->printFormFooter();

   break;
   /**
   * Step -1:extract the data
   */
   case '-1' :
   $install->execINC($install->step,'start');
   
   $ok=0;
   if(extension_loaded('zlib'))
   {
       if(!file_exists($install->install_data))
       {
           printMsg($install->lang['msg_title'],sprintf($install->lang['installdata_lost'],$install->install_data));
       }
       elseif(!is_writable($install->install_dir))
       {
           printMsg($install->lang['msg_title'],sprintf($install->lang['installdir_notwrite'],$install->install_dir));
       }
       else
       {
           $unzip=new unzipfile($install->install_data);
           $unzip->extract($install->install_dir);
           $ok=1;
           printMsg($install->lang['msg_title'],$install->lang['installdata_extracted']);
           $install->step = $install->step + 1;
       }
   }
   else
   {
       printMsg($install->lang['msg_title'],$install->lang['zlib_lost']);
   }
   if($ok==0)break;
   /**
   * Step 0
   */
   case '0' :
   $install->execINC($install->step,'start');
   
   $install->printFormHeader();
   $install->detectENV();
   $install->can_install = 1;
   foreach($install->results as $type=>$results)
   {
       printHeader($install->lang[$type]);
       foreach($results as $row)
       {
           if(!$row[status]) $install->can_install = 0;
           $row[value]=$row[status]==1?'<font color=blue>'.$row[descr].'</font>':'<font color=red>Warning:'.$row[descr].'</font>';
           $row[type] ='label';
           $row[descr]=$row[name];
           printRow($row);
       }
       printFooter($type);
   }
   $install->printFormFooter();
   $install->execINC($install->step,'end');
   break;
   /**
   * Step 1:optional step,collect infomation to register the licenses
   */
   case '1' :
   $install->execINC($install->step,'start');
   printRegisterForm();
   $install->execINC($install->step,'end');
   break;
   /**
   * Step 2:optional step,do register the licenses
   */
   case '2' :
   $install->execINC($install->step,'start');
   
   $info=array(
   'username'  => $input[username],
   'password'  => $input[password],
   'product'   => $product,
   'server'    => $_SERVER,
   );

   $ok=$install->registerInstall($info,$result);
   $status = $code[$result]!=''?$code[$result]:str_replace('{[RESULT]}',$result);
   $status = str_replace('<b>'.$file.'</b>',$status);
       $step = $step + 1;
       $install->printFormHeader();
       printMsg($install->lang['msg_title'],$status);
       $install->printFormFooter();
   $install->execINC($install->step,'end');
   break;
   /**
   * Step 4:write config files,excute sql query
   */
   case '4' :
   $install->execINC($install->step,'start');

   $sql_errors=$sql_details='';
   $mysql = $install->getSection('MYSQL');
   if($mysql)
   {
       if(!@mysql_connect( $input[sqlhost], $input[sqluser], $input[sqlpass] ))
       {
           $sql_errors =( 'FATAL ERROR: Connection to database server failed.'.mysql_error().'<br>');
       }
	   if(!@mysql_select_db($input[sqldb]))
       {
           $sql_errors .=("FATAL ERROR: Database not found. Operation failed with error: ".mysql_error());
       }
       if(strlen($sql_errors)==0)
       {
           $support_charset = strcmp (mysql_get_server_info(),'4.1')>=0;
           $support_engine  = strcmp (mysql_get_server_info(),'4.0.18')>=0;

           $SQL=$install->execSQLFile();
           $SQL=array_merge($SQL,$install->execSQLQuery());

           if($SQL)
           foreach($SQL as $query)
           {
               $query=trim($query);
               $parts=split("\n",$query);
               $act=strtolower(substr($query,0,6));
               if($act=='create')
               {
                   if(!$support_charset)
                   {
                       $query = preg_replace('/DEFAULT\s*CHARSET=([^\s]*)/isx','',$query);
                       $query = preg_replace('/character\s*set\s*([^\s]*)/isx','',$query);
                   }
                   if(!$support_engine)
                   {
                       $query = preg_replace('/ENGINE\s*=/isx','TYPE=',$query);
                   }
                   else
                   {
                       $query = preg_replace('/TYPE\s*=/isx','ENGINE=',$query);
                   }
                   preg_match("'create\s*table\s*([\`])?(?(1) (.*?)\\1 | ([^\s]+))'isx",$query,$match);
                   $table=$match[1]=='`'?$match[2]:$match[3];
               }
               if($act=='insert')
               {
                   preg_match("'insert\s*into\s*([\`])?(?(1) (.*?)\\1 | ([^\s]+))'isx",$query,$match);
                   $table=$match[1]=='`'?$match[2]:$match[3];
               }
               if($act=='update')
               {
                   preg_match("'update\s*([\`])?(?(1) (.*?)\\1 | ([^\s]+))'isx",$query,$match);
                   $table=$match[1]=='`'?$match[2]:$match[3];
               }
               if($act=='delete')
               {
                   preg_match("'delete\s*from\s*([\`])?(?(1) (.*?)\\1 | ([^\s]+))'isx",$query,$match);
                   $table=$match[1]=='`'?$match[2]:$match[3];
               }
               if(!@mysql_query($query))
               {
                   $errorline    = '<font color=red>'.mysql_error()."</font>\n";
                   if($candroptable==1&&$act=='create')
                   {
                       if(!mysql_query('DROP TABLE '.$table)){
                       $errorline   = '<font color=red>'.mysql_error().'</font>DROP TABLE '.$table."\n";
                       $sql_errors .= $errorline;
                       $sql_details.= $errorline;
                       }
                       else {
                       mysql_query($query);
                       $sql_details .= "Table '$table' droped\n";
                       }
                   }
                   else
                   {
                       $sql_errors  .= $errorline;
                       $sql_details .= $errorline;
                   }
               }
               elseif(in_array($act,array('create','insert','update','delete')))
               {
                   $sql_details .= ucfirst($act)." table '".$table."' sucessfull\n";
               }
           }
       }
   }
   if(strlen($sql_errors)==0)
   {
       /**
       * save the config vars to files
       */
       $config_results = $install->writeConfig();
       if($config_results) printCFGResults($config_results);
       
       /**
       * print the sql query details to screen
       */
       if(strlen($sql_details))printSQLResults($sql_details);
       $install->printFormHeader();
       
       /**
       * print the finish infomation to screen
       */
       printMsg($install->lang['msg_title'],$install->lang['install_ok']);
       $install->printFormFooter();
       break;
   }
   else
   {
       printMsg($install->lang['msg_title'],nl2br($sql_errors));
       $install->step = $install->step - 1;
   }
   $install->execINC($install->step,'end');
   /**
   * Step 3:collect install infomation:sql host...
   */
   case '3' :
   $install->execINC($install->step,'start');
   
   $install->printFormHeader();
   $install->buildHiddenFields();

   $mysql = $install->getSection('MYSQL');
   if($mysql)
   {
       printHeader($install->lang['sql_caption']);
       foreach($mysql as $name => $value)
       {
           $val = $input[$name];
           $data=array('name'=>$name,'descr'=>$install->evalLang($value),'value'=>$name=='sqlhost'?'localhost':$val,'type'=>'text');
           printRow($data);
       }
       $data=array('name'=>'droptable','descr'=>$install->lang['droptable'],'value'=>'1=yes,0=no','type'=>'radio');
       printRow($data);
       printFooter();
   }
            
   $install->buildForm();
   $install->printFormFooter();
   $install->execINC($install->step,'end');
   break;
   /**
   * Step 5:last step,finish the install and lock the installer
   */
   case '5' :
   $install->execINC($install->step,'start');
   
   fopen('install.locked','wb');
   printMsg($install->lang['msg_title'],$install->lang['installer_locked']);
   $install->execINC($install->step,'end');
   break;
   
}

require 'includes/footer.html';
?>
<?
function printRegisterForm()
{
global $install,$need_account_register,$show_domain,$text;

   $install->printFormHeader();
   if($need_account_register)
   {
       $row = array(
       'value' => $input[username],
       'type'  =>'text',
       'name'  =>'username',
       'descr' =>'Username',
       );
       printRow($row);
       $row = array(
       'value' => $input[password],
       'type'  =>'text',
       'name'  =>'password',
       'descr' =>'Password',
       );
       printRow($row);
   }
   printFooter();
   $install->printFormFooter();
}
function printSQLResults($details)
{
    $details=nl2br($details);
    echo "<table width=80% cellSpacing=1 cellPadding=2 align=center class=tableborder>\n<tr><td align=center class=titlerow>SQL Results:</td></tr>\n";

    echo "<tr><td class=tdrow1 width=100%><a name=1><a href='#1' onclick='showhide(\"details\")'><b>Show mysql query details</b></a><div id=details class=info style='display:none'>$details";

    echo "</div></td></tr>\n</table>\n";
}
function printCFGResults($details)
{
    echo "<table width=80% cellSpacing=1 cellPadding=2 align=center class=tableborder>\n<tr><td align=center class=titlerow>Config Results:</td></tr>\n";

    foreach($details as $file=>$result)
    {
        $i++;
        $content=highlight_string($result[1],1);
        if(!file_exists($file)) $info = "Please chmod ".dirname($file) ." to 0777";
        if(file_exists($file)&&!is_readable($file)) $info = "Please chmod ".($file) ." to 0666";

        echo "<tr><td class=tdrow1 width=100%><a name=1></a><b>$file</b>".($result[0]?'':"<font color=red>[Error:Can't be saved, $info!]</font>").":<a href='#1' onclick='showhide(\"details$i\",this)'><b>Show file contents</b></a><div id=details$i class=info style='display:none'>$content</div></td></tr>\n";
    }

    echo "</table>\n";
}
?>
