CREATE TABLE `admin_menus` (
  `menu_id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(64) default NULL,
  `parent_id` int(11) default '0',
  `url` varchar(128) default NULL,
  `urltarget` tinyint(4) default NULL,
  `admin` varchar(32) default NULL,
  `allow_actions` varchar(255) default NULL,
  `split` tinyint(1) default '0',
  `hint` varchar(255) default NULL,
  `icon` varchar(128) default NULL,
  `big_icon` varchar(128) default NULL,
  `orders` int(11) default NULL,
  `group_id` int(11) default NULL,
  PRIMARY KEY  (`menu_id`)
) TYPE=MyISAM;

INSERT INTO `admin_menus` VALUES (1,'Home',0,'index.php',0,NULL,NULL,1,'Control Panel','css/Theme/home.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (2,'Site',0,'',0,NULL,NULL,1,'Site Management','css/Theme/controlpanel.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (3,'Files',0,'',0,NULL,NULL,1,'Files Management','css/Theme/folder.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (4,'Host Package',0,'',0,NULL,NULL,1,'Host Package','css/Theme/users.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (5,'Members',0,'',0,NULL,NULL,1,'Members Management','css/Theme/user.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (6,'Servers',0,'?admin=server',0,NULL,NULL,1,'Servers Management','css/Theme/computer.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (7,'Crontabs',0,'',0,NULL,NULL,1,'Manage Crontabs','css/Theme/cronjob.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (8,'Billing',0,'',0,NULL,NULL,1,'Billing','css/Theme/transactions.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (9,'Template & Language',0,'',0,NULL,NULL,1,'Template','css/Theme/template.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (10,'Tools',0,'',0,NULL,NULL,1,'Site Tools','css/Theme/toolbox.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (11,'Help',0,'',0,NULL,NULL,0,'Site Help','css/Theme/help.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (12,'Configuration',2,'?admin=set',0,NULL,NULL,0,'Configuration','css/Theme/controlpanel.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (13,'Site Ads',2,'?admin=siteads',0,NULL,NULL,0,'Change/Edit Site Ads','css/Theme/template.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (14,'News System',2,'?admin=news',0,NULL,NULL,0,'Manage news','css/Theme/news.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (15,'Newsletter',2,'?admin=newsletter',0,NULL,NULL,0,'Mange Newsletter','css/Theme/mass_email.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (16,'FAQ Manager',2,'?admin=faqs',0,NULL,NULL,0,'Manage FAQS','css/Theme/package.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (18,'Files',3,'?admin=images',0,NULL,NULL,0,'List/Search/Delete Files','css/Theme/files.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (19,'Top Downloads Files',18,'?admin=images&img_orderby=f.downloads&img_AD=DESC&search=1',0,NULL,NULL,0,'List Top Downloads Files','css/Theme/favorits.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (20,'Validated Files',18,'?admin=images&img_filter=validated&search=1',0,NULL,NULL,0,'List Validated Files','css/Theme/checkin.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (21,'Deleted Files',18,'?admin=images&img_filter=deleted&search=1',0,NULL,NULL,0,'List Deleted Files','css/Theme/trash.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (22,'Download',3,'',0,NULL,NULL,0,'File Download','css/Theme/download.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (23,'Sessions',22,'?admin=dlsessions',0,NULL,NULL,0,'List download sessions','css/Theme/package.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (24,'History',22,'?admin=dlhistory',0,NULL,NULL,0,'List download history','css/Theme/history.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (25,'Reports',3,'?admin=report',0,NULL,NULL,0,'Process Reports','css/Theme/checkin.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (26,'Prune',3,'?admin=imgprune',0,NULL,NULL,0,'Prune Files','css/Theme/trash.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (27,'List Package',4,'?admin=group',0,NULL,NULL,0,'Add/Edit/Delete Package','css/Theme/users.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (28,'Reward Center',4,'?admin=promotion',0,NULL,NULL,0,'Reward Center','css/Theme/dollar.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (29,'Download Rules',4,'?admin=rule',0,NULL,NULL,0,'Mange Download Rules','css/Theme/download.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (30,'Package Template',4,'?admin=showtemplate',0,NULL,NULL,0,'Customise Package Template','css/Theme/template.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (31,'List Members',5,'?admin=user',0,NULL,NULL,0,'Search/Edit/Add Members','css/Theme/user.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (32,'Add Member',5,'?admin=user&act=add',0,NULL,NULL,0,'Add Members','css/Theme/user_add.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (33,'Points History',5,'?admin=points',0,NULL,NULL,0,'Mange Points History','css/Theme/money.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (34,'Crontabs',7,'?admin=crontab',0,NULL,NULL,0,'Crontabs Setting','css/Theme/cronjob.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (35,'Crontab Logs',7,'?admin=cronlog',0,NULL,NULL,0,'View Crontab Logs','css/Theme/history.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (36,'Transactions',8,'?admin=payment',0,NULL,NULL,0,'View Transactions','css/Theme/transactions.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (37,'Gateway Setting',8,'?admin=gateway',0,NULL,NULL,0,'Setup Payment Gateway','css/Theme/config.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (38,'Template Manager',9,'?admin=template',0,NULL,NULL,0,'Add/Edit/Download Template','css/Theme/template.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (39,'Language Manager',9,'?admin=lang',0,NULL,NULL,0,'Edit/Export Language','css/Theme/language.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (40,'Email Template',9,'?admin=emails',0,NULL,NULL,0,'Configure Email Template','css/Theme/mass_email.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (41,'Backup Database',10,'?admin=backup',0,NULL,NULL,0,'Backup/Email Database','css/Theme/folder_down.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (42,'Database Restore',10,'?admin=restore',0,NULL,NULL,0,'Restore Backup','css/Theme/folder_up.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (43,'Maintain Database',10,'?admin=maintain',0,NULL,NULL,0,'Maintain Database','css/Theme/config.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (44,'Admin Menus',10,'?admin=menu',0,NULL,NULL,0,'Maitain Site Menus','css/Theme/menu.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (45,'Site Plugins',10,'?admin=plugins',0,NULL,NULL,0,'Manage Site Plugins','css/Theme/apps.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (46,'Support forum',11,'http://yabsoft.com/forum/',1,NULL,NULL,0,'Support forum','css/Theme/forum.png','',NULL,NULL);
INSERT INTO `admin_menus` VALUES (47,'File Links Codes',2,'?admin=link',0,NULL,NULL,0,'Mange Files Links Code Templates','css/Theme/link.png','',0,NULL);
INSERT INTO `admin_menus` VALUES (48,'Show All Files',18,'?admin=images&search=1',0,NULL,NULL,0,'Show All Uploaded Files','css/Theme/files.png','',NULL,NULL);

CREATE TABLE `cronlogs` (
  `log_id` int(11) unsigned NOT NULL auto_increment,
  `results` text,
  `date` int(11) default NULL,
  `cron_id` varchar(255) default NULL,
  PRIMARY KEY  (`log_id`)
) TYPE=MyISAM;

CREATE TABLE `crontabs` (
  `cron_id` int(6) unsigned NOT NULL auto_increment,
  `code_id` varchar(128) default NULL,
  `name` varchar(255) default NULL,
  `descr` text,
  `cronscript` varchar(255) default NULL,
  `interval` int(11) default NULL,
  `last_update` int(11) default NULL,
  `enabled` tinyint(1) default '1',
  `multiple` tinyint(1) default '0',
  PRIMARY KEY  (`cron_id`)
) TYPE=MyISAM;

INSERT INTO `crontabs` VALUES (1,'deltmp','Delete Temp Files','Delete Temp Files','deltmp.php',3600,1251303900,1,1);
INSERT INTO `crontabs` VALUES (2,'cronhistory','Update Download History',NULL,'cronhistory.php',3600,1250112775,1,0);
INSERT INTO `crontabs` VALUES (3,'crondelete','Delete files',NULL,'crondelete.php',3600,1250344173,1,1);
INSERT INTO `crontabs` VALUES (4,'cronaccounts','Delete Inactive Accounts','','cronaccounts.php',3600,1168676051,1,0);
INSERT INTO `crontabs` VALUES (5,'crondbbackup','Database Backup','Database Backup stored in backup directory and emailed to your admin email.','crondbbackup.php',604800,1248527767,1,0);
INSERT INTO `crontabs` VALUES (6,'cronpackage','Updating Expired Premium Users','Updating Expired Premium Users and sending email notifications!','cronpackage.php',86400,1248667370,1,0);

CREATE TABLE `dlsessions` (
  `dl_id` int(11) NOT NULL auto_increment,
  `file_id` int(11) default NULL,
  `file_uid` int(11) default NULL,
  `uid` int(11) default '0',
  `ip` varchar(32) default '',
  `start_time` int(11) default '0',
  `last_update` int(11) default '0',
  `dl_size` varchar(32) default '0',
  `size` varchar(32) default '0',
  `points` tinyint(3) default '0',
  `threads` int(11) default '1',
  `access_key` varchar(64) default '',
  `server_id` int(11) default NULL,
  `done` tinyint(1) default '0',
  `area` char(2) default 'NA',
  PRIMARY KEY  (`dl_id`),
  KEY `access_key` (`access_key`)
) ENGINE=InnoDB;


CREATE TABLE `downloadhistory` (
  `history_id` int(11) NOT NULL auto_increment,
  `uid` int(11) default NULL,
  `date` varchar(8) default NULL,
  `points` int(11) default NULL,
  `downloads` int(11) default NULL,
  `size` bigint(19) default NULL,
  `status` enum('valid','invalid','pend') default 'pend',
  PRIMARY KEY  (`history_id`),
  KEY `uid` (`uid`,`date`)
) TYPE=MyISAM;


CREATE TABLE `downloadrules` (
  `rule_id` int(11) NOT NULL auto_increment,
  `dl_gid` int(11) default NULL,
  `dl_area` text,
  `dl_points` varchar(255) default NULL,
  `dl_filesizes` varchar(255) default NULL,
  `dl_donebytes` varchar(64) default NULL,
  `dl_maxbytes` varchar(64) default NULL,
  `dl_lastupdate` int(11) default NULL,
  PRIMARY KEY  (`rule_id`),
  KEY `dl_gid` (`dl_gid`)
) TYPE=MyISAM;

INSERT INTO `downloadrules` VALUES (1,2,'US','1,2,3,5','5,20,50,100','0','10737418240',1169305349);
INSERT INTO `downloadrules` VALUES (2,2,'DE,GB,JP','1,2,3,5','10,30,100,200','0','10737418240',1165249060);
INSERT INTO `downloadrules` VALUES (3,2,'AT,AU,BE,BR,CA,CZ,DK,ES,FR,GR,ID,IE,IL,IN,IT,MX,NL,NO,NZ,PL,PT,RU,SE,SG,SK,SZ,TH,TR','1,2,3,5','10,50,100,300','0','10737418240',1165503359);
INSERT INTO `downloadrules` VALUES (4,3,'US','1,2,3,5','5,20,50,100','0','10737418240',1169305349);
INSERT INTO `downloadrules` VALUES (5,3,'DE,GB,JP','1,2,3,5','10,30,100,200','0','10737418240',1165249060);
INSERT INTO `downloadrules` VALUES (6,3,'AT,AU,BE,BR,CA,CZ,DK,ES,FR,GR,ID,IE,IL,IN,IT,MX,NL,NO,NZ,PL,PT,RU,SE,SG,SK,SZ,TH,TR','1,2,3,5','10,50,100,300','0','10737418240',1165503359);

CREATE TABLE `faq` (
  `faq_id` int(11) unsigned NOT NULL auto_increment,
  `section` varchar(255) default NULL,
  `p_id` int(11) default '0',
  `question` text,
  `answer` text,
  `order` int(11) default NULL,
  `lang` varchar(4) default 'en',
  PRIMARY KEY  (`faq_id`)
) TYPE=MyISAM;

INSERT INTO `faq` VALUES (1,'Membership',0,NULL,NULL,3,'en');
INSERT INTO `faq` VALUES (2,NULL,2,'How do I sign up for an account?','You can sign up for a free account on the <a href=\"register.php\">sign up</a> page. You need to choose a username and password that you will use to upload images to your account. We also require you to enter a valid email address when you join. We send a confirmation email to this address with instructions on how to activate your account.',NULL,'en');
INSERT INTO `faq` VALUES (3,NULL,2,'Can I sign up for more than 1 account?','Free accounts are limited to 1 (one) per individual. If we catch anyone abusing this limit, we may delete all their accounts without any notice. ',NULL,'en');
INSERT INTO `faq` VALUES (4,'Unanswered Questions',0,NULL,NULL,34,'en');
INSERT INTO `faq` VALUES (5,'File Download Questions',0,NULL,NULL,2,'en');
INSERT INTO `faq` VALUES (6,NULL,2,'How do I access my account?','Once you have <a href=\"register.php\">signed up</a> and confirmed your account, you can <a href=\"login.php\">login</a> to it on the login page. While logged in to your account you can <a href=\"index.php\">Form upload</a>,<a href=\"index.php?uploadmode=2\">URL upload</a> files,>,<a href=\"index.php?uploadmode=3\">FTP upload</a> files, <a href=\"index.php?showlinks=1\">browse</a> the files you have already uploaded, get the urls required to download/delete the files.',NULL,'en');
INSERT INTO `faq` VALUES (7,NULL,12,'What is the maximum allowed size for uploaded files?','The maximum filesize you can upload depends on what account you registered. Files with a larger filesize than the allowed maximum will be rejected. \n\nYou can view the maximum sizes allowed on our <a href=\"service.php\">service</a> page. ',NULL,'en');
INSERT INTO `faq` VALUES (8,NULL,2,'Help! I\'ve forgotten my username or password.','If you forget your login details for your account we can send a reminder to the email address you registered with us when you created your account. Just follow the instructions on the <a href=\"login.php?act=getpass\">password reminder</a> page. \n',NULL,'en');
INSERT INTO `faq` VALUES (9,NULL,2,'How do I upgrade to a paid account?','If you have outgrown the features provided by our free account, you can upgrade to a paid account on the <a href=\"members.php?upgrade=1\">upgrade</a> page. Payments are accepted through <a href=http://paypal.com>PayPal</a>,<a href=\"http://e-gold.com\">E-Gold</a>,<a href=\"moneybookers.com\">Moneybookers</a> and in most cases your account will be upgraded automatically after payment. ',NULL,'en');
INSERT INTO `faq` VALUES (10,NULL,7,'Contact us!','If you have any further questions not answered in this document, please <a href=\"contact.php\">contact</a> us directly. ',NULL,'en');
INSERT INTO `faq` VALUES (11,NULL,12,'Can I resume broken downloads?','Yes, but only if you own a Premium-account.Premium-account support download-accelerators. Those programs support resume of broken files and even segmented downloads. This means, you can download the same file with many streams, resulting in higher download-speed.',NULL,'en');
INSERT INTO `faq` VALUES (12,NULL,12,'Can I delete my uploaded files?','Sure you can! After your upload, you will get two links. The download-link, which you give to everyone you want, and a delete-link, which you keep for yourself. Just click on the delete-link and your file will be deleted immediately.\n',NULL,'en');
INSERT INTO `faq` VALUES (13,NULL,12,'Which download accelerators can I use? ','You may use any of the major accelerators, a few popular ones are: Speedget, Download Accelerator Plus, GetRight, FlashGet and GoZilla.\n',NULL,'en');
INSERT INTO `faq` VALUES (14,NULL,12,'I have upgrade to Premium account, Why is my download slow?','Please make sure you have enabled cookies on your browser.Since our system recognize Premium download by cookie.Also make sure you do not have software installed, which blocks sending of cookies. Some firewalls for example like to do this.',NULL,'en');


CREATE TABLE `files` (
  `id` int(11) NOT NULL auto_increment,
  `file` varchar(250) NOT NULL,
  `name` varchar(250) NOT NULL default '',
  `uid` int(11) default '0',
  `size` bigint(19) NOT NULL default '0',
  `ip` varchar(16) default NULL,
  `time` int(11) NOT NULL default '0',
  `bandwidth` bigint(19) default '0',
  `downloads` int(11) default '0',
  `lastdownload` int(11) default NULL,
  `server_id` int(11) default NULL,
  `deleted` tinyint(1) default '0',
  `password` varchar(255) default NULL,
  `descr` text,
  `upload_id` varchar(12) NOT NULL default '',
  `delete_id` varchar(4) default '',
  `validate` tinyint(1) default '0',
  `thumb` tinyint(1) default '0',
  `featured` tinyint(1) default '0',
  `upload_session` varchar(32) default NULL,
  `extra_servers` varchar(11) default NULL,
  `upload_method` tinyint(4) default NULL,
  PRIMARY KEY  (`upload_id`),
  UNIQUE KEY `id` (`id`),
  KEY `uid` (`uid`)
) TYPE=MyISAM;

CREATE TABLE `folders` (
  `fid` int(11) NOT NULL auto_increment,
  `uid` int(11) default '0',
  `name` varchar(255) default NULL,
  `descr` text,
  `file_ids` text,
  `password` varchar(32) default NULL,
  `friends` varchar(255) default NULL,
  `admin_password` varchar(32) default NULL,
  PRIMARY KEY  (`fid`)
) TYPE=MyISAM;


CREATE TABLE `gateway` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `Provider` varchar(20) default NULL,
  `PayeeAccount` varchar(255) default NULL,
  `Currency` varchar(255) default NULL,
  `MD5AccountPassword` varchar(255) default NULL,
  `TestMode` tinyint(4) default '1',
  `Enabled` tinyint(1) default '1',
  `BusinissAccount` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

INSERT INTO `gateway` VALUES (1,'PP','','USD','0',1,1,'');
INSERT INTO `gateway` VALUES (2,'EG','','USD','',0,0,NULL);
INSERT INTO `gateway` VALUES (3,'MB','','USD','',0,1,NULL);
INSERT INTO `gateway` VALUES (4,'2CO','','USD','',1,1,NULL);

CREATE TABLE `groups` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `name` varchar(200) default NULL,
  `sizelimit` varchar(255) default '0',
  `allowed_filetype` text,
  `disabled_filetype` text,
  `show_site_ads` tinyint(1) default '1',
  `show_sponser_ads` tinyint(1) default '1',
  `subscr_unit` varchar(255) default 'M',
  `subscr_period` varchar(255) default '0',
  `subscr_fee` varchar(255) default '0',
  `payment_type` enum('instant','subscriptions') default 'subscriptions',
  `dl_resume` tinyint(1) default '1',
  `dl_speed` int(11) default '0',
  `dl_threads` tinyint(3) default '5',
  `dl_ips` int(11) default '0',
  `dl_password` tinyint(1) default '0',
  `dl_waittime` tinyint(3) default '30',
  `dl_captcha` tinyint(1) default '1',
  `dl_timeout` int(11) default '12',
  `dl_sizebyhour` int(11) default '0',
  `dl_checkarea` tinyint(1) default '0',
  `dl_direct` tinyint(1) default '0',
  `formupload` tinyint(1) default '1',
  `urlupload` tinyint(1) default '1',
  `ftpupload` tinyint(1) default '1',
  `flashupload` tinyint(1) default '1',
  `max_uploads` int(11) default '1',
  `cron_days` int(11) default '0',
  `cron_views` int(11) default '1',
  `cron_enabled` tinyint(1) default '0',
  `folder` tinyint(1) default '1',
  `guest` tinyint(1) default '0',
  `server_id` int(11) default NULL,
  `validate_type` enum('auto','admin','instant') default 'auto',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

INSERT INTO `groups` VALUES (1,'Guest','104857600','','',0,0,'M','','','subscriptions',1,50,1,100,1,30,1,30,104857600,0,1,1,0,0,1,1,30,1,1,1,1,0,'auto');
INSERT INTO `groups` VALUES (2,'Registered','314572800','','',1,1,'D','','','instant',1,100,5,1000,1,15,1,60,524288000,1,0,1,1,1,1,5,30,1,1,1,0,0,'auto');
INSERT INTO `groups` VALUES (3,'Premium','524288000','','',0,0,'M,M,M,M','1,3,6,12','5,15,25,50','instant',1,0,5,0,1,0,1,120,0,1,1,1,1,1,1,5,30,1,1,1,0,0,'auto');
INSERT INTO `groups` VALUES (32,'Private','524288000','','',0,0,'','','','subscriptions',1,1000,5,10000,0,0,0,60,1073741824,1,0,1,1,1,1,5,0,1,0,1,-1,0,'auto');

CREATE TABLE `hookpoint` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(128) default '',
  `file` varchar(255) default NULL,
  `line` int(11) default NULL,
  `env` text,
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) TYPE=MyISAM;

INSERT INTO `hookpoint` VALUES (1,'ajax_start','ajax.php',28,NULL);
INSERT INTO `hookpoint` VALUES (2,'ajax_end','ajax.php',107,NULL);
INSERT INTO `hookpoint` VALUES (3,'captcha_load_module','captcha.php',30,NULL);
INSERT INTO `hookpoint` VALUES (4,'contact_captcha_check','contact.php',30,NULL);
INSERT INTO `hookpoint` VALUES (5,'contact_captcha_fail','contact.php',46,NULL);
INSERT INTO `hookpoint` VALUES (6,'contact_captcha_ok','contact.php',50,NULL);
INSERT INTO `hookpoint` VALUES (7,'contact_details_validate','contact.php',56,NULL);
INSERT INTO `hookpoint` VALUES (8,'contact_details_sending','contact.php',76,NULL);
INSERT INTO `hookpoint` VALUES (9,'contact_details_sent','contact.php',83,NULL);
INSERT INTO `hookpoint` VALUES (10,'cronjob_load_job','cronjob.php',24,NULL);
INSERT INTO `hookpoint` VALUES (11,'cronjob_process_job','cronjob.php',34,NULL);
INSERT INTO `hookpoint` VALUES (12,'cronjob_log_results','cronjob.php',65,NULL);
INSERT INTO `hookpoint` VALUES (13,'deletefile_loadingfile','delete.php',23,NULL);
INSERT INTO `hookpoint` VALUES (14,'deletefile_checkfile','delete.php',38,NULL);
INSERT INTO `hookpoint` VALUES (15,'deletefile_noexists','delete.php',43,NULL);
INSERT INTO `hookpoint` VALUES (16,'deletefile_start','delete.php',49,NULL);
INSERT INTO `hookpoint` VALUES (17,'deletefile_end','delete.php',67,NULL);
INSERT INTO `hookpoint` VALUES (18,'deletefile_showdetails','delete.php',72,NULL);
INSERT INTO `hookpoint` VALUES (19,'downloadfile_loading','download.php',37,NULL);
INSERT INTO `hookpoint` VALUES (20,'downloadfile_verify','download.php',46,NULL);
INSERT INTO `hookpoint` VALUES (21,'downloadfile_geturls','download.php',82,NULL);
INSERT INTO `hookpoint` VALUES (22,'download_verify_start','download.php',110,NULL);
INSERT INTO `hookpoint` VALUES (23,'download_checkcaptcha_start','download.php',118,NULL);
INSERT INTO `hookpoint` VALUES (24,'download_checkcaptcha_end','download.php',129,NULL);
INSERT INTO `hookpoint` VALUES (25,'download_checkpassword_start','download.php',133,NULL);
INSERT INTO `hookpoint` VALUES (26,'download_checkpassword_end','download.php',143,NULL);
INSERT INTO `hookpoint` VALUES (27,'download_checksizebyhour_start','download.php',147,NULL);
INSERT INTO `hookpoint` VALUES (28,'download_check_currentsize','download.php',152,NULL);
INSERT INTO `hookpoint` VALUES (29,'downloaderr_getmaxsize','download.php',164,NULL);
INSERT INTO `hookpoint` VALUES (30,'download_checksizebyhour_end','download.php',166,NULL);
INSERT INTO `hookpoint` VALUES (31,'download_checkips_start','download.php',170,NULL);
INSERT INTO `hookpoint` VALUES (32,'download_check_currentips','download.php',175,NULL);
INSERT INTO `hookpoint` VALUES (33,'downloaderr_getmaxip','download.php',184,NULL);
INSERT INTO `hookpoint` VALUES (34,'download_checkips_end','download.php',186,NULL);
INSERT INTO `hookpoint` VALUES (35,'downloadrule_load_start','download.php',193,NULL);
INSERT INTO `hookpoint` VALUES (36,'download_check_currentsessions','download.php',209,NULL);
INSERT INTO `hookpoint` VALUES (37,'downloadrule_load_end','download.php',220,NULL);
INSERT INTO `hookpoint` VALUES (38,'download_checkarea_start','download.php',224,NULL);
INSERT INTO `hookpoint` VALUES (39,'download_check_currentarea','download.php',229,NULL);
INSERT INTO `hookpoint` VALUES (40,'download_checkarea_end','download.php',247,NULL);
INSERT INTO `hookpoint` VALUES (41,'download_verify_end','download.php',251,NULL);
INSERT INTO `hookpoint` VALUES (42,'download_buildlink_start','download.php',257,NULL);
INSERT INTO `hookpoint` VALUES (43,'download_buildlink_end','download.php',331,NULL);
INSERT INTO `hookpoint` VALUES (44,'directdownload_start','download.php',335,NULL);
INSERT INTO `hookpoint` VALUES (45,'download_prepare_vars','download.php',342,NULL);
INSERT INTO `hookpoint` VALUES (46,'download_showdownloadurl','download.php',366,NULL);
INSERT INTO `hookpoint` VALUES (47,'download_showverifyform','download.php',373,NULL);
INSERT INTO `hookpoint` VALUES (48,'downloadtemplate_loading','download.php',384,NULL);
INSERT INTO `hookpoint` VALUES (49,'downloadtemplate_check','download.php',393,NULL);
INSERT INTO `hookpoint` VALUES (50,'downloadtemplate_end','download.php',398,NULL);
INSERT INTO `hookpoint` VALUES (51,'faq_loading','faq.php',24,NULL);
INSERT INTO `hookpoint` VALUES (52,'faq_done','faq.php',76,NULL);
INSERT INTO `hookpoint` VALUES (53,'getfile_start','getfile.php',26,NULL);
INSERT INTO `hookpoint` VALUES (54,'getfile_loadsetting','getfile.php',48,NULL);
INSERT INTO `hookpoint` VALUES (55,'getfile_checkproxy','getfile.php',58,NULL);
INSERT INTO `hookpoint` VALUES (56,'getfile_checkproxy_fails','getfile.php',62,NULL);
INSERT INTO `hookpoint` VALUES (57,'getfile_checkcaptcha','getfile.php',102,NULL);
INSERT INTO `hookpoint` VALUES (58,'getfile_checkcaptcha_fails','getfile.php',105,NULL);
INSERT INTO `hookpoint` VALUES (59,'getfile_checktimeout','getfile.php',118,NULL);
INSERT INTO `hookpoint` VALUES (60,'getfile_checktimeout_fails','getfile.php',123,NULL);
INSERT INTO `hookpoint` VALUES (61,'getfile_checkfileexists','getfile.php',130,NULL);
INSERT INTO `hookpoint` VALUES (62,'getfile_checkfileexists_fails','getfile.php',137,NULL);
INSERT INTO `hookpoint` VALUES (63,'getfile_checkthread','getfile.php',150,NULL);
INSERT INTO `hookpoint` VALUES (64,'getfile_checkthread_fails','getfile.php',160,NULL);
INSERT INTO `hookpoint` VALUES (65,'getfile_apply_limitions','getfile.php',181,NULL);
INSERT INTO `hookpoint` VALUES (66,'getfile_threadupdate','getfile.php',191,NULL);
INSERT INTO `hookpoint` VALUES (67,'getfile_session_create','getfile.php',203,NULL);
INSERT INTO `hookpoint` VALUES (68,'getfile_downloadrule_update','getfile.php',222,NULL);
INSERT INTO `hookpoint` VALUES (69,'getfile_startdownload','getfile.php',229,NULL);
INSERT INTO `hookpoint` VALUES (70,'getfile_update_sessions','getfile.php',234,NULL);
INSERT INTO `hookpoint` VALUES (71,'getfile_end','getfile.php',239,NULL);
INSERT INTO `hookpoint` VALUES (72,'folder_checkperms','folders.php',26,NULL);
INSERT INTO `hookpoint` VALUES (73,'folder_logout','folders.php',33,NULL);
INSERT INTO `hookpoint` VALUES (74,'folder_loadfolder','folders.php',45,NULL);
INSERT INTO `hookpoint` VALUES (75,'folderlogin_start','folders.php',90,NULL);
INSERT INTO `hookpoint` VALUES (76,'folderlogin_ok','folders.php',94,NULL);
INSERT INTO `hookpoint` VALUES (77,'folderlogin_fail','folders.php',104,NULL);
INSERT INTO `hookpoint` VALUES (78,'folderlogin_end','folders.php',110,NULL);
INSERT INTO `hookpoint` VALUES (79,'folderadminlogin_start','folders.php',117,NULL);
INSERT INTO `hookpoint` VALUES (80,'folderadminlogin_ok','folders.php',121,NULL);
INSERT INTO `hookpoint` VALUES (81,'folderadminlogin_fail','folders.php',134,NULL);
INSERT INTO `hookpoint` VALUES (82,'folderadminlogin_end','folders.php',140,NULL);
INSERT INTO `hookpoint` VALUES (83,'folder_create_start','folders.php',186,NULL);
INSERT INTO `hookpoint` VALUES (84,'folder_create_prepare','folders.php',192,NULL);
INSERT INTO `hookpoint` VALUES (85,'folder_create_done','folders.php',196,NULL);
INSERT INTO `hookpoint` VALUES (86,'folder_edit_start','folders.php',212,NULL);
INSERT INTO `hookpoint` VALUES (87,'folder_edit_prepare','folders.php',218,NULL);
INSERT INTO `hookpoint` VALUES (88,'folder_edit_done','folders.php',222,NULL);
INSERT INTO `hookpoint` VALUES (89,'delfolderfile_start','folders.php',230,NULL);
INSERT INTO `hookpoint` VALUES (90,'delfolderfile_prepare','folders.php',242,NULL);
INSERT INTO `hookpoint` VALUES (91,'delfolderfile_end','folders.php',247,NULL);
INSERT INTO `hookpoint` VALUES (92,'delfolder_start','folders.php',255,NULL);
INSERT INTO `hookpoint` VALUES (93,'delfolder_end','folders.php',260,NULL);
INSERT INTO `hookpoint` VALUES (94,'addfolderfile_start','folders.php',268,NULL);
INSERT INTO `hookpoint` VALUES (95,'addfolderfile_end','folders.php',287,NULL);
INSERT INTO `hookpoint` VALUES (96,'folderstats_update_start','folders.php',289,NULL);
INSERT INTO `hookpoint` VALUES (97,'folderstats_update_end','folders.php',304,NULL);
INSERT INTO `hookpoint` VALUES (98,'folderfiles_show_start','folders.php',316,NULL);
INSERT INTO `hookpoint` VALUES (99,'folderfiles_show_data','folders.php',323,NULL);
INSERT INTO `hookpoint` VALUES (100,'folderfiles_show_end','folders.php',337,NULL);
INSERT INTO `hookpoint` VALUES (101,'site_footer','footer.php',22,NULL);
INSERT INTO `hookpoint` VALUES (102,'global_end','footer.php',25,NULL);
INSERT INTO `hookpoint` VALUES (103,'get_uploadids_start','getlinks.php',30,NULL);
INSERT INTO `hookpoint` VALUES (104,'get_uploadids_end','getlinks.php',34,NULL);
INSERT INTO `hookpoint` VALUES (105,'show_downloadlink_start','getlinks.php',77,NULL);
INSERT INTO `hookpoint` VALUES (106,'build_downloadlink_data','getlinks.php',82,NULL);
INSERT INTO `hookpoint` VALUES (107,'show_downloadlink_end','getlinks.php',120,NULL);
INSERT INTO `hookpoint` VALUES (108,'show_uploadresults_start','getlinks.php',134,NULL);
INSERT INTO `hookpoint` VALUES (109,'show_uploadresults_end','getlinks.php',162,NULL);
INSERT INTO `hookpoint` VALUES (110,'siteheader_start','header.php',18,NULL);
INSERT INTO `hookpoint` VALUES (111,'siteheader_loadlanglist','header.php',46,NULL);
INSERT INTO `hookpoint` VALUES (112,'siteheader_end','header.php',69,NULL);
INSERT INTO `hookpoint` VALUES (113,'userlogin_start','login.php',32,NULL);
INSERT INTO `hookpoint` VALUES (114,'userlogin_success','login.php',49,NULL);
INSERT INTO `hookpoint` VALUES (115,'userlogin_error','login.php',61,NULL);
INSERT INTO `hookpoint` VALUES (116,'user_validate_start','login.php',71,NULL);
INSERT INTO `hookpoint` VALUES (117,'user_validate_fails','login.php',77,NULL);
INSERT INTO `hookpoint` VALUES (118,'user_validate_pass','login.php',83,NULL);
INSERT INTO `hookpoint` VALUES (119,'validate_email_data','login.php',89,NULL);
INSERT INTO `hookpoint` VALUES (120,'validate_email_sending','login.php',103,NULL);
INSERT INTO `hookpoint` VALUES (121,'validateduser_trylogin','login.php',110,NULL);
INSERT INTO `hookpoint` VALUES (122,'user_validate_end','login.php',118,NULL);
INSERT INTO `hookpoint` VALUES (123,'user_getpassword_start','login.php',129,NULL);
INSERT INTO `hookpoint` VALUES (124,'getpasswordemail_start','login.php',134,NULL);
INSERT INTO `hookpoint` VALUES (125,'getpasswordemail_sending','login.php',150,NULL);
INSERT INTO `hookpoint` VALUES (126,'getpasswordemail_sent','login.php',155,NULL);
INSERT INTO `hookpoint` VALUES (127,'getpasswordemail_showerror','login.php',163,NULL);
INSERT INTO `hookpoint` VALUES (128,'user_getpassword_end','login.php',170,NULL);
INSERT INTO `hookpoint` VALUES (129,'user_getpasswordemail_showform','login.php',178,NULL);
INSERT INTO `hookpoint` VALUES (130,'user_resendcode_start','login.php',188,NULL);
INSERT INTO `hookpoint` VALUES (131,'resendcode_email_start','login.php',193,NULL);
INSERT INTO `hookpoint` VALUES (132,'resendcode_email_sending','login.php',210,NULL);
INSERT INTO `hookpoint` VALUES (133,'resendcode_email_sent','login.php',215,NULL);
INSERT INTO `hookpoint` VALUES (134,'user_resendcode_fails','login.php',223,NULL);
INSERT INTO `hookpoint` VALUES (135,'user_resendcode_end','login.php',229,NULL);
INSERT INTO `hookpoint` VALUES (136,'user_resendform_show','login.php',234,NULL);
INSERT INTO `hookpoint` VALUES (137,'user_loginform_show','login.php',245,NULL);
INSERT INTO `hookpoint` VALUES (138,'trigor_errors','redirect.php',22,NULL);
INSERT INTO `hookpoint` VALUES (139,'register_checkinput_start','register.php',27,NULL);
INSERT INTO `hookpoint` VALUES (140,'register_checkinput_end','register.php',71,NULL);
INSERT INTO `hookpoint` VALUES (141,'register_userdata_build','register.php',98,NULL);
INSERT INTO `hookpoint` VALUES (142,'register_userdata_insert','register.php',131,NULL);
INSERT INTO `hookpoint` VALUES (143,'register_user_added','register.php',136,NULL);
INSERT INTO `hookpoint` VALUES (144,'registeremail_sending','register.php',148,NULL);
INSERT INTO `hookpoint` VALUES (145,'registeremail_sent','register.php',155,NULL);
INSERT INTO `hookpoint` VALUES (146,'registeruser_trylogin','register.php',157,NULL);
INSERT INTO `hookpoint` VALUES (147,'registeruser_makepayment','register.php',169,NULL);
INSERT INTO `hookpoint` VALUES (148,'register_finish','register.php',178,NULL);
INSERT INTO `hookpoint` VALUES (149,'register_fails','register.php',182,NULL);
INSERT INTO `hookpoint` VALUES (150,'registerform_start','register.php',188,NULL);
INSERT INTO `hookpoint` VALUES (151,'paymentgateway_start','register.php',193,NULL);
INSERT INTO `hookpoint` VALUES (152,'paymentgateway_data','register.php',201,NULL);
INSERT INTO `hookpoint` VALUES (153,'paymentgateway_end','register.php',212,NULL);
INSERT INTO `hookpoint` VALUES (154,'load_usegroups_start','register.php',214,NULL);
INSERT INTO `hookpoint` VALUES (155,'build_usegroups_data','register.php',223,NULL);
INSERT INTO `hookpoint` VALUES (156,'load_usegroups_end','register.php',251,NULL);
INSERT INTO `hookpoint` VALUES (157,'registerform_end','register.php',253,NULL);
INSERT INTO `hookpoint` VALUES (158,'report_file_loading','report.php',25,NULL);
INSERT INTO `hookpoint` VALUES (159,'report_captcha_check','report.php',55,NULL);
INSERT INTO `hookpoint` VALUES (160,'report_captcha_fail','report.php',70,NULL);
INSERT INTO `hookpoint` VALUES (161,'report_captcha_ok','report.php',74,NULL);
INSERT INTO `hookpoint` VALUES (162,'report_start','report.php',80,NULL);
INSERT INTO `hookpoint` VALUES (163,'report_insert','report.php',89,NULL);
INSERT INTO `hookpoint` VALUES (164,'report_added','report.php',93,NULL);
INSERT INTO `hookpoint` VALUES (165,'reportemail_start','report.php',100,NULL);
INSERT INTO `hookpoint` VALUES (166,'reportemail_sending','report.php',121,NULL);
INSERT INTO `hookpoint` VALUES (167,'reportemail_sent','report.php',125,NULL);
INSERT INTO `hookpoint` VALUES (168,'reportemail_end','report.php',130,NULL);
INSERT INTO `hookpoint` VALUES (169,'reportform_show','report.php',134,NULL);
INSERT INTO `hookpoint` VALUES (170,'uploading_start','uploading.php',24,NULL);
INSERT INTO `hookpoint` VALUES (171,'formupload_start','uploading.php',57,NULL);
INSERT INTO `hookpoint` VALUES (172,'formupload_done','uploading.php',84,NULL);
INSERT INTO `hookpoint` VALUES (173,'flashupload_start','uploading.php',98,NULL);
INSERT INTO `hookpoint` VALUES (174,'flashupload_done','uploading.php',108,NULL);
INSERT INTO `hookpoint` VALUES (175,'urlupload_start','uploading.php',132,NULL);
INSERT INTO `hookpoint` VALUES (176,'urlupload_done','uploading.php',159,NULL);
INSERT INTO `hookpoint` VALUES (177,'ftpupload_start','uploading.php',182,NULL);
INSERT INTO `hookpoint` VALUES (178,'ftpupload_done','uploading.php',209,NULL);
INSERT INTO `hookpoint` VALUES (179,'uploading_finish','uploading.php',223,NULL);
INSERT INTO `hookpoint` VALUES (180,'uploadprogess_synmode_start','uploading.php',228,NULL);
INSERT INTO `hookpoint` VALUES (181,'uploadprogess_ajaxmode_start','uploading.php',258,NULL);
INSERT INTO `hookpoint` VALUES (182,'upload_error_redirect','uploading.php',262,NULL);
INSERT INTO `hookpoint` VALUES (183,'upload_success_redirect','uploading.php',267,NULL);
INSERT INTO `hookpoint` VALUES (184,'downloadrule_loading','includes/function.php',37,NULL);
INSERT INTO `hookpoint` VALUES (185,'downloadrule_loaded','includes/function.php',52,NULL);
INSERT INTO `hookpoint` VALUES (186,'downloadrule_loaddefault','includes/function.php',58,NULL);
INSERT INTO `hookpoint` VALUES (187,'uploadform_start','includes/function.php',68,NULL);
INSERT INTO `hookpoint` VALUES (188,'uploadform_data_assign','includes/function.php',89,NULL);
INSERT INTO `hookpoint` VALUES (189,'site_offline','includes/function.php',142,NULL);
INSERT INTO `hookpoint` VALUES (190,'uploadform_end','includes/function.php',169,NULL);
INSERT INTO `hookpoint` VALUES (191,'showfiles_start','includes/function.php',212,NULL);
INSERT INTO `hookpoint` VALUES (192,'showfiles_end','includes/function.php',237,NULL);
INSERT INTO `hookpoint` VALUES (193,'build_filerow_begin','includes/function.php',251,NULL);
INSERT INTO `hookpoint` VALUES (194,'build_filerow_data','includes/function.php',283,NULL);
INSERT INTO `hookpoint` VALUES (195,'build_filerow_end','includes/function.php',287,NULL);
INSERT INTO `hookpoint` VALUES (196,'build_emaildownloadlinks_start','includes/function.php',297,NULL);
INSERT INTO `hookpoint` VALUES (197,'build_emaildownloadlinks_data','includes/function.php',302,NULL);
INSERT INTO `hookpoint` VALUES (198,'build_emaildownloadlinks_end','includes/function.php',318,NULL);
INSERT INTO `hookpoint` VALUES (199,'email_downloadlinks_start','includes/function.php',323,NULL);
INSERT INTO `hookpoint` VALUES (200,'email_downloadlinks_sending','includes/function.php',341,NULL);
INSERT INTO `hookpoint` VALUES (201,'email_downloadlinks_end','includes/function.php',349,NULL);
INSERT INTO `hookpoint` VALUES (202,'build_linkcodes_begin','includes/function.php',359,NULL);
INSERT INTO `hookpoint` VALUES (203,'build_linkcodes_assignvars','includes/function.php',381,NULL);
INSERT INTO `hookpoint` VALUES (204,'build_linkcodes_end','includes/function.php',387,NULL);
INSERT INTO `hookpoint` VALUES (205,'build_packageinfo_data','includes/function.php',398,NULL);
INSERT INTO `hookpoint` VALUES (206,'listpackages_start','includes/function.php',424,NULL);
INSERT INTO `hookpoint` VALUES (207,'build_packages_data','includes/function.php',445,NULL);
INSERT INTO `hookpoint` VALUES (208,'listpackages_end','includes/function.php',513,NULL);
INSERT INTO `hookpoint` VALUES (209,'topfiles_loading','includes/function.php',536,NULL);
INSERT INTO `hookpoint` VALUES (210,'topfiles_start','includes/function.php',555,NULL);
INSERT INTO `hookpoint` VALUES (211,'build_topfiles_data','includes/function.php',597,NULL);
INSERT INTO `hookpoint` VALUES (212,'topfiles_end','includes/function.php',600,NULL);
INSERT INTO `hookpoint` VALUES (213,'getfiles_nums_start','includes/function.php',609,NULL);
INSERT INTO `hookpoint` VALUES (214,'getfiles_nums_end','includes/function.php',630,NULL);
INSERT INTO `hookpoint` VALUES (215,'get_downloadurl_start','includes/function.php',641,NULL);
INSERT INTO `hookpoint` VALUES (216,'get_downloadurl_process','includes/function.php',672,NULL);
INSERT INTO `hookpoint` VALUES (217,'get_downloadurl_end','includes/function.php',692,NULL);
INSERT INTO `hookpoint` VALUES (218,'validate_downloadurl_start','includes/function.php',702,NULL);
INSERT INTO `hookpoint` VALUES (219,'validate_downloadurl_process','includes/function.php',716,NULL);
INSERT INTO `hookpoint` VALUES (220,'validate_downloadurl_ids','includes/function.php',751,NULL);
INSERT INTO `hookpoint` VALUES (221,'validate_downloadurl_end','includes/function.php',760,NULL);
INSERT INTO `hookpoint` VALUES (222,'get_folderurl_start','includes/function.php',772,NULL);
INSERT INTO `hookpoint` VALUES (223,'get_folderurl_end','includes/function.php',776,NULL);
INSERT INTO `hookpoint` VALUES (224,'sitestats_start','includes/function.php',857,NULL);
INSERT INTO `hookpoint` VALUES (225,'sitestats_getdetails','includes/function.php',870,NULL);
INSERT INTO `hookpoint` VALUES (226,'sitestats_end','includes/function.php',894,NULL);
INSERT INTO `hookpoint` VALUES (227,'sitenews_start','includes/function.php',903,NULL);
INSERT INTO `hookpoint` VALUES (228,'sitenews_loading','includes/function.php',911,NULL);
INSERT INTO `hookpoint` VALUES (229,'build_sitenews_data','includes/function.php',928,NULL);
INSERT INTO `hookpoint` VALUES (230,'sitenews_end','includes/function.php',939,NULL);
INSERT INTO `hookpoint` VALUES (231,'cronlog_start','includes/function.php',945,NULL);
INSERT INTO `hookpoint` VALUES (232,'cronlog_end','includes/function.php',957,NULL);
INSERT INTO `hookpoint` VALUES (233,'encryptstr_start','includes/function.php',1071,NULL);
INSERT INTO `hookpoint` VALUES (234,'encryptstr_end','includes/function.php',1082,NULL);
INSERT INTO `hookpoint` VALUES (235,'decryptstr_start','includes/function.php',1094,NULL);
INSERT INTO `hookpoint` VALUES (236,'decryptstr_end','includes/function.php',1105,NULL);
INSERT INTO `hookpoint` VALUES (237,'redirect_start','includes/function.php',1690,NULL);
INSERT INTO `hookpoint` VALUES (238,'redirect_headermode','includes/function.php',1698,NULL);
INSERT INTO `hookpoint` VALUES (239,'redirect_simplemode','includes/function.php',1708,NULL);
INSERT INTO `hookpoint` VALUES (240,'redirect_standbymode','includes/function.php',1727,NULL);
INSERT INTO `hookpoint` VALUES (241,'template_init','includes/inc.php',85,NULL);
INSERT INTO `hookpoint` VALUES (242,'uploader_initiating','includes/upload.class.php',68,NULL);
INSERT INTO `hookpoint` VALUES (243,'uploader_server_loading','includes/upload.class.php',78,NULL);
INSERT INTO `hookpoint` VALUES (244,'uploader_apply_setting','includes/upload.class.php',95,NULL);
INSERT INTO `hookpoint` VALUES (245,'uploader_initiated','includes/upload.class.php',104,NULL);
INSERT INTO `hookpoint` VALUES (246,'uploader_setuploadmode_start','includes/upload.class.php',109,NULL);
INSERT INTO `hookpoint` VALUES (247,'uploader_setuploadmode_end','includes/upload.class.php',126,NULL);
INSERT INTO `hookpoint` VALUES (248,'uploader_uploadsession_create','includes/upload.class.php',131,NULL);
INSERT INTO `hookpoint` VALUES (249,'uploader_uploadsession_finish','includes/upload.class.php',137,NULL);
INSERT INTO `hookpoint` VALUES (250,'uploader_uploadsession_validate','includes/upload.class.php',142,NULL);
INSERT INTO `hookpoint` VALUES (251,'uploader_uploadsession_loaduser','includes/upload.class.php',151,NULL);
INSERT INTO `hookpoint` VALUES (252,'uploader_uploadsession_ok','includes/upload.class.php',176,NULL);
INSERT INTO `hookpoint` VALUES (253,'uploader_uploadsession_fail','includes/upload.class.php',181,NULL);
INSERT INTO `hookpoint` VALUES (254,'uploadfile_inputcheck_start','includes/upload.class.php',195,NULL);
INSERT INTO `hookpoint` VALUES (255,'uploadfile_inputcheck_end','includes/upload.class.php',207,NULL);
INSERT INTO `hookpoint` VALUES (256,'uploadfile_progress_preparestart','includes/upload.class.php',211,NULL);
INSERT INTO `hookpoint` VALUES (257,'uploadfile_progress_prepareend','includes/upload.class.php',238,NULL);
INSERT INTO `hookpoint` VALUES (258,'acceptfile_start','includes/upload.class.php',242,NULL);
INSERT INTO `hookpoint` VALUES (259,'acceptfile_check','includes/upload.class.php',247,NULL);
INSERT INTO `hookpoint` VALUES (260,'acceptfile_getfile','includes/upload.class.php',257,NULL);
INSERT INTO `hookpoint` VALUES (261,'acceptfile_copy','includes/upload.class.php',266,NULL);
INSERT INTO `hookpoint` VALUES (262,'acceptfile_copyfail','includes/upload.class.php',270,NULL);
INSERT INTO `hookpoint` VALUES (263,'insertfile_start','includes/upload.class.php',279,NULL);
INSERT INTO `hookpoint` VALUES (264,'insertfile_end','includes/upload.class.php',291,NULL);
INSERT INTO `hookpoint` VALUES (265,'acceptfile_end','includes/upload.class.php',299,NULL);
INSERT INTO `hookpoint` VALUES (266,'acceptfile_done','includes/upload.class.php',307,NULL);
INSERT INTO `hookpoint` VALUES (267,'uploadfile_progress_createsignal','includes/upload.class.php',309,NULL);
INSERT INTO `hookpoint` VALUES (268,'uploadfile_progress_endsignal','includes/upload.class.php',319,NULL);
INSERT INTO `hookpoint` VALUES (269,'uploadfile_done','includes/upload.class.php',324,NULL);
INSERT INTO `hookpoint` VALUES (270,'uploadfile_gettotalsize_start','includes/upload.class.php',396,NULL);
INSERT INTO `hookpoint` VALUES (271,'uploadfile_getfilesize_start','includes/upload.class.php',405,NULL);
INSERT INTO `hookpoint` VALUES (272,'uploadfile_getfilesize_end','includes/upload.class.php',411,NULL);
INSERT INTO `hookpoint` VALUES (273,'uploadfile_gettotalsize_end','includes/upload.class.php',419,NULL);
INSERT INTO `hookpoint` VALUES (274,'uploadfile_updatestats_start','includes/upload.class.php',426,NULL);
INSERT INTO `hookpoint` VALUES (275,'uploadfile_updatestats_end','includes/upload.class.php',441,NULL);
INSERT INTO `hookpoint` VALUES (276,'uploader_getuploadids','includes/upload.class.php',447,NULL);
INSERT INTO `hookpoint` VALUES (277,'filelimitions_check_start','includes/upload.class.php',455,NULL);
INSERT INTO `hookpoint` VALUES (278,'filelimitions_check_end','includes/upload.class.php',471,NULL);
INSERT INTO `hookpoint` VALUES (279,'geturlfile_start','includes/upload.class.php',477,NULL);
INSERT INTO `hookpoint` VALUES (280,'geturlfile_http_request','includes/upload.class.php',497,NULL);
INSERT INTO `hookpoint` VALUES (281,'geturlfile_read_header','includes/upload.class.php',507,NULL);
INSERT INTO `hookpoint` VALUES (282,'geturlfile_check_httpheader','includes/upload.class.php',516,NULL);
INSERT INTO `hookpoint` VALUES (283,'geturlfile_progressinfo_start','includes/upload.class.php',541,NULL);
INSERT INTO `hookpoint` VALUES (284,'geturlfile_data_arrive','includes/upload.class.php',562,NULL);
INSERT INTO `hookpoint` VALUES (285,'geturlfile_progressinfo_update','includes/upload.class.php',579,NULL);
INSERT INTO `hookpoint` VALUES (286,'geturlfile_data_finish','includes/upload.class.php',610,NULL);
INSERT INTO `hookpoint` VALUES (287,'geturlfile_progressinfo_finish','includes/upload.class.php',616,NULL);
INSERT INTO `hookpoint` VALUES (288,'dbinsert_start','includes/upload.class.php',951,NULL);
INSERT INTO `hookpoint` VALUES (289,'dbinsert_prepare','includes/upload.class.php',979,NULL);
INSERT INTO `hookpoint` VALUES (290,'dbinsert_done','includes/upload.class.php',984,NULL);
INSERT INTO `hookpoint` VALUES (291,'user_set_sessiontype','includes/user.class.php',93,NULL);
INSERT INTO `hookpoint` VALUES (292,'user_session_check','includes/user.class.php',97,NULL);
INSERT INTO `hookpoint` VALUES (293,'user_bannedip_check','includes/user.class.php',105,NULL);
INSERT INTO `hookpoint` VALUES (294,'user_session_timeout','includes/user.class.php',125,NULL);
INSERT INTO `hookpoint` VALUES (295,'user_update_lastlogin','includes/user.class.php',135,NULL);
INSERT INTO `hookpoint` VALUES (296,'user_loaddata','includes/user.class.php',144,NULL);
INSERT INTO `hookpoint` VALUES (297,'user_autologin_start','includes/user.class.php',156,NULL);
INSERT INTO `hookpoint` VALUES (298,'user_autologin_end','includes/user.class.php',171,NULL);
INSERT INTO `hookpoint` VALUES (299,'user_set_autologin','includes/user.class.php',179,NULL);
INSERT INTO `hookpoint` VALUES (300,'user_set_loginstatus','includes/user.class.php',200,NULL);
INSERT INTO `hookpoint` VALUES (301,'user_create_session','includes/user.class.php',217,NULL);
INSERT INTO `hookpoint` VALUES (302,'user_group_loading','includes/user.class.php',227,NULL);
INSERT INTO `hookpoint` VALUES (303,'user_group_loaded','includes/user.class.php',271,NULL);
INSERT INTO `hookpoint` VALUES (304,'user_details_assign','includes/user.class.php',273,NULL);
INSERT INTO `hookpoint` VALUES (305,'user_set_adsetting','includes/user.class.php',327,NULL);
INSERT INTO `hookpoint` VALUES (306,'user_lang_loading','includes/user.class.php',343,NULL);
INSERT INTO `hookpoint` VALUES (307,'user_lang_loaded','includes/user.class.php',360,NULL);
INSERT INTO `hookpoint` VALUES (308,'user_load_server','includes/user.class.php',373,NULL);
INSERT INTO `hookpoint` VALUES (309,'user_initiated','includes/user.class.php',387,NULL);
INSERT INTO `hookpoint` VALUES (310,'server_loaddetails_start','includes/user.class.php',402,NULL);
INSERT INTO `hookpoint` VALUES (311,'server_loaddetails_end','includes/user.class.php',436,NULL);
INSERT INTO `hookpoint` VALUES (312,'server_assignurl_done','includes/user.class.php',447,NULL);
INSERT INTO `hookpoint` VALUES (313,'server_statuscheck_start','includes/user.class.php',461,NULL);
INSERT INTO `hookpoint` VALUES (314,'server_statuscheck_end','includes/user.class.php',490,NULL);
INSERT INTO `hookpoint` VALUES (315,'serverstatus_email_start','includes/user.class.php',497,NULL);
INSERT INTO `hookpoint` VALUES (316,'serverstatus_email_info','includes/user.class.php',521,NULL);
INSERT INTO `hookpoint` VALUES (317,'serverstatus_email_sending','includes/user.class.php',533,NULL);
INSERT INTO `hookpoint` VALUES (318,'serverstatus_email_sent','includes/user.class.php',543,NULL);
INSERT INTO `hookpoint` VALUES (319,'user_load_bannedips','includes/user.class.php',553,NULL);
INSERT INTO `hookpoint` VALUES (320,'user_is_ipbanned','includes/user.class.php',565,NULL);
INSERT INTO `hookpoint` VALUES (321,'user_ipban_pass','includes/user.class.php',570,NULL);
INSERT INTO `hookpoint` VALUES (322,'user_updatestats_start','includes/user.class.php',581,NULL);
INSERT INTO `hookpoint` VALUES (323,'user_updatestats_done','includes/user.class.php',597,NULL);
INSERT INTO `hookpoint` VALUES (324,'sitesetting_loaded','includes/user.class.php',636,NULL);
INSERT INTO `hookpoint` VALUES (325,'siteservers_loaded','includes/user.class.php',653,NULL);
INSERT INTO `hookpoint` VALUES (326,'siteskin_loaded','includes/user.class.php',669,NULL);
INSERT INTO `hookpoint` VALUES (327,'sitelang_loaded','includes/user.class.php',700,NULL);
INSERT INTO `hookpoint` VALUES (328,'sitelang_guess_start','includes/user.class.php',711,NULL);
INSERT INTO `hookpoint` VALUES (329,'sitelang_guess_end','includes/user.class.php',732,NULL);
INSERT INTO `hookpoint` VALUES (330,'user_login_start','includes/user.class.php',771,NULL);
INSERT INTO `hookpoint` VALUES (331,'user_is_logined','includes/user.class.php',787,NULL);
INSERT INTO `hookpoint` VALUES (332,'user_login_failed','includes/user.class.php',793,NULL);
INSERT INTO `hookpoint` VALUES (333,'user_logout_start','includes/user.class.php',805,NULL);
INSERT INTO `hookpoint` VALUES (334,'user_logout_end','includes/user.class.php',813,NULL);
INSERT INTO `hookpoint` VALUES (335,'user_check_available','includes/user.class.php',821,NULL);
INSERT INTO `hookpoint` VALUES (336,'user_exists','includes/user.class.php',828,NULL);
INSERT INTO `hookpoint` VALUES (337,'user_is_available','includes/user.class.php',833,NULL);
INSERT INTO `hookpoint` VALUES (338,'loaduser_start','includes/user.class.php',844,NULL);
INSERT INTO `hookpoint` VALUES (339,'loaduser_fail','includes/user.class.php',854,NULL);
INSERT INTO `hookpoint` VALUES (340,'loaduser_ok','includes/user.class.php',859,NULL);

CREATE TABLE `hooks` (
  `hook_id` int(11) NOT NULL auto_increment,
  `name` varchar(128) default NULL,
  `location` varchar(128) default '',
  `code` text,
  `vars` varchar(225) default NULL,
  `enabled` tinyint(1) default '1',
  `plugin_id` int(11) default '1',
  PRIMARY KEY  (`hook_id`)
) TYPE=MyISAM;

INSERT INTO `hooks` VALUES (1,'Update default wait time! ','download_prepare_vars','## set waittime based on the filesize\n$waittime_options = array(\n\'0KB\'=>0,//0.0 percent of wait time defined by admin\n\'10KB\'=>10,//0.1\n\'1MB\'=>30,//0.5\n\'1GB\'=>60,//1.0\n);\nforeach($waittime_options as $sizestr => $waittime)\n{\n    eval(\"\\$filesize = (str_replace(array(\'KB\',\'MB\',\'GB\'),array(\'*1024\',\'*1024*1024\',\'*1024*1024*1024\'),\\$sizestr));\");\n    eval(\"\\$filesize = $filesize;\");\n    if($filerow[size]>$filesize)\n    $sizewaittime = strlen($waittime)>=2&&$waittime<=1 ?\n                    intval($user->dl_waittime*$waittime):\n                    $waittime;\n}\nif(isset($sizewaittime)) $user->dl_waittime = $sizewaittime;',NULL,1,1);
INSERT INTO `hooks` VALUES (2,'Captcha Setting','captcha_load_module','# comment or uncomment to load different captcha module\n$module_path = \'plugins/captcha/\';\n$module_path = \'plugins/enhancedcaptcha2/\';\n$module_path = \'plugins/enhancedcaptcha/\';',NULL,1,2);

CREATE TABLE `links` (
  `id` tinyint(6) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `unique_id` varchar(32) default NULL,
  `code` mediumtext NOT NULL,
  `filetype` mediumtext NOT NULL,
  `enable` tinyint(1) NOT NULL default '1',
  `ordering` tinyint(6) default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

INSERT INTO `links` VALUES (1,'Website Code','WEBSITECODE','{FILENAME}<br><a href=\"{FILEURL}\" target=\"_blank\"><img src=\"{THUMBURL}\" alt=\"Free Filehosting At {SITENAME}\"/></a>','all',1,0);
INSERT INTO `links` VALUES (2,'Forum Code','FORUMCODE','{FILENAME}:\r\n[URL={FILEURL}][IMG]{THUMBURL}[/IMG][/URL]','all',1,0);
INSERT INTO `links` VALUES (3,'Download Url','DOWNLOADURL','{FILENAME}:{FILEURL}','all',1,0);
INSERT INTO `links` VALUES (4,'Share Link','SHARELINK','{FILENAME}:{SHAREURL}','all',1,0);

CREATE TABLE `news` (
  `news_id` int(11) unsigned NOT NULL auto_increment,
  `title` text,
  `body` text,
  `public` tinyint(1) default '1',
  `start_date` int(11) default NULL,
  `end_date` int(11) default NULL,
  `date` int(11) default NULL,
  `lang` varchar(4) default NULL,
  PRIMARY KEY  (`news_id`)
) TYPE=MyISAM;


CREATE TABLE `plugins` (
  `plugin_id` int(11) NOT NULL auto_increment,
  `unique_id` varchar(64) default NULL,
  `name` varchar(64) default '',
  `descr` varchar(255) default '',
  `install_code` text,
  `uninstall_code` text,
  `version` varchar(12) default '',
  `author` varchar(32) default '',
  `homepage` varchar(128) default '',
  `enabled` int(11) default NULL,
  `dependent` varchar(255) default '',
  `plugin_type` enum('3rd','offical','custom') default 'offical',
  `plugin_priority` int(11) default '1',
  `run_type` enum('eval','function') default 'eval',
  PRIMARY KEY  (`plugin_id`)
) TYPE=MyISAM;

INSERT INTO `plugins` VALUES (1,'waittimeonfilesize','Wait time depending on filesize!','This plugin will set wait time of download links based on its filesize.','','','1.0','Stephen Yabziz','',1,'','offical',0,'eval');
INSERT INTO `plugins` VALUES (2,'captchaselector','Captcha Module','Choose Different Type of Captcha Images','','','1.0','Stephen Yabziz','',1,'','offical',0,'eval');

CREATE TABLE `pointhistory` (
  `history_id` int(11) NOT NULL auto_increment,
  `uid` int(11) default NULL,
  `promotion_id` int(11) default NULL,
  `points` int(11) default NULL,
  `date` int(11) default NULL,
  `status` enum('complete','pending') default 'pending',
  `type` enum('upgrade','payout') default 'upgrade',
  `user_note` text,
  `admin_note` text,
  PRIMARY KEY  (`history_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


CREATE TABLE `promotions` (
  `promotion_id` int(11) NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `descr` text,
  `source_gid` int(11) default NULL,
  `dest_gid` int(11) default NULL,
  `months` int(11) default NULL,
  `points` int(11) default NULL,
  `money` varchar(11) default NULL,
  `points_fee` int(11) default NULL,
  `note` text,
  `start_date` int(11) default NULL,
  `end_date` int(11) default NULL,
  `expire_date` int(11) default NULL,
  PRIMARY KEY  (`promotion_id`)
) TYPE=MyISAM;

INSERT INTO `promotions` VALUES (1,'Download Promotion For Registered Users','This promotion will help you quickly earn points to upgrade to Premium package or cash out by converting points!',2,3,1,500,'5',1000,'The minimum payout amount is $30. Payouts are sent via PayPal. We send payouts by your request. All payout requests are processed within 7 days',0,0,0);
INSERT INTO `promotions` VALUES (2,'Download Promotion For Premium Users','This promotion will help you quickly earn points to extend your Premium membership or cash out by converting points!',3,3,1,200,'5',800,'The minimum payout amount is $30. Payouts are sent via PayPal. We send payouts by your request. All payout requests are processed within 7 days',0,0,0);

CREATE TABLE `records` (
  `record_id` int(11) unsigned NOT NULL auto_increment,
  `txn_id` varchar(32) default NULL,
  `txn_ref` varchar(255) default NULL,
  `provider` varchar(20) default NULL,
  `item_name` varchar(255) default NULL,
  `item_number` varchar(255) default NULL,
  `amount` varchar(11) default NULL,
  `fee` varchar(11) default NULL,
  `currency` varchar(32) default NULL,
  `quantity` int(11) default NULL,
  `payment_status` varchar(30) default NULL,
  `payment_type` varchar(255) default NULL,
  `pending_reason` varchar(255) default NULL,
  `payment_date` int(11) default NULL,
  `subscr_id` varchar(255) default NULL,
  `subscr_ref` varchar(255) default NULL,
  `subscr_unit` enum('D','M','Y') default NULL,
  `subscr_period` int(11) default NULL,
  `subscr_amount` varchar(11) default NULL,
  `trial_unit` enum('D','M','Y') default NULL,
  `trial_period` int(11) default NULL,
  `trial_amount` varchar(11) default NULL,
  `payee_account` varchar(255) default NULL,
  `payer_account` varchar(255) default NULL,
  `note` text,
  `data` text,
  `uid` int(11) default NULL,
  `descr` text,
  `record_date` int(11) default NULL,
  PRIMARY KEY  (`record_id`)
) TYPE=MyISAM;


CREATE TABLE `reports` (
  `report_id` int(11) unsigned NOT NULL auto_increment,
  `upload_id` varchar(12) character set utf8 default NULL,
  `file_id` int(11) default NULL,
  `username` varchar(32) default NULL,
  `subject` varchar(255) default NULL,
  `problems` varchar(255) default NULL,
  `details` text,
  `date` int(11) default NULL,
  `fullname` varchar(255) default NULL,
  `email` varchar(255) default NULL,
  `IP` varchar(32) default NULL,
  PRIMARY KEY  (`report_id`)
) TYPE=MyISAM;


CREATE TABLE `server` (
  `server_id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `http` enum('http://','https://') default 'http://',
  `domain` varchar(255) default NULL,
  `cgiurl` varchar(255) default NULL,
  `php_temp_dir` varchar(32) default 'temp',
  `cgi_temp_dir` varchar(32) default 'temp',
  `upload_dir` varchar(32) default 'files',
  `keep_ext` enum('yes','no') default 'no',
  `keep_name` enum('yes','no') default 'no',
  `iswin` enum('yes','no') default 'yes',
  `lighttpd` tinyint(1) default '0',
  `lighttpd_url` varchar(255) default NULL,
  `webspace` varchar(255) default '0',
  `max_webspace` varchar(255) default '0',
  `warn_webspace` varchar(255) default '0',
  `mod_status` varchar(255) default '0,0,0,0',
  `im_path` varchar(64) default NULL,
  `ffmpeg_path` varchar(64) default NULL,
  `mplayer_path` varchar(64) default NULL,
  `hosted` bigint(19) default '0',
  `enabled` tinyint(1) default '0',
  `allow_download` tinyint(1) default '1',
  `formupload_type` enum('cgi','php') default 'cgi',
  `url_prog_mode` enum('syn','ajax') default 'ajax',
  `ftp_prog_mode` enum('syn','ajax') default 'ajax',
  `time_diff` int(11) default NULL,
  PRIMARY KEY  (`server_id`)
) TYPE=MyISAM;

CREATE TABLE `setting` (
  `set_id` int(11) NOT NULL default '0',
  `admin` varchar(32) default NULL,
  `pass` varchar(255) default NULL,
  `pass_salt` varchar(3) default NULL,
  `admin_lastclick` int(11) default NULL,
  `admin_ip` varchar(32) default NULL,
  `reset_date` int(11) default NULL,
  `last_login` int(11) default NULL,
  `last_fail` int(11) default NULL,
  `fail_times` tinyint(3) default '0',
  `max_failtimes` tinyint(4) default '3',
  `adminemail` varchar(100) NOT NULL default '',
  `servermoniter_emails` varchar(255) default NULL,
  `validate` char(1) default '0',
  `banip` mediumtext,
  `sitename` varchar(200) default NULL,
  `server` varchar(11) default '0',
  `language` varchar(32) default '-1',
  `lang_page` enum('static','dyn') default 'static',
  `newsletter_subject` varchar(255) default NULL,
  `newsletter_body` text,
  `newsletter_target` varchar(4) default NULL,
  `in_process` tinyint(4) default '0',
  `site_keyword` text,
  `site_descr` text,
  `emailsign` text,
  `skin_dir` varchar(255) default NULL,
  `cached` tinyint(3) default '0',
  `notifyreport` tinyint(1) default '1',
  `site_offline` tinyint(1) default '0',
  `descr` tinyint(1) default '1',
  `password` tinyint(1) default '1',
  `sitestats` tinyint(1) default '1',
  `static_url` enum('dyn','short','seo') default NULL,
  `allow_php` tinyint(1) default '0',
  `shaketime` int(11) default '2000',
  `startshow` int(11) default '2000',
  `adtop` int(11) default '200',
  `adleft` int(11) default '500',
  `slidestep` int(11) default '15',
  `slideinternal` int(11) default '10',
  `show_featured_files` tinyint(1) default '1',
  `show_guest_package` tinyint(1) default '1',
  `thumb_width` int(11) default '165',
  `thumb_height` int(11) default '165',
  `thumb_type` enum('fix','soft') default 'soft',
  `validate_type` enum('auto','admin') default 'auto',
  `featured_type` tinyint(1) default '0',
  `featured_ads` tinyint(3) default NULL,
  `featured_files` int(11) default NULL,
  `featured_users` text,
  `top_page` enum('static','dyn') default 'dyn',
  `download_code` varchar(64) default NULL,
  `check_download_ip` tinyint(1) default '1',
  `download_prefix` varchar(32) default NULL,
  `cache_sessions` tinyint(4) default '1',
  `allow_proxy` tinyint(1) default '0',
  `mfhs_version` varchar(64) default NULL,
  `main` tinyint(1) default '1',
  `debug` enum('yes','no') default 'no',
  `admin_charset` varchar(32) default 'UTF-8',
  `report_captcha` tinyint(1) default '0',
  `contact_captcha` tinyint(1) default '0',
  `show_options` tinyint(1) default '1',
  `expired_package` int(11) default NULL,
  `use_flash_progress` tinyint(1) default '0',
  `mulurlupload` tinyint(3) default '1',
  `mulftpupload` tinyint(3) default '1',
  `inline_crontab` tinyint(1) default '1',
  `last_build` int(11) default NULL,
  `last_stats` varchar(64) default NULL,
  `smtp_host` varchar(128) default NULL,
  `smtp_port` int(4) default NULL,
  `smtp_user` varchar(64) default NULL,
  `smtp_pass` varchar(64) default NULL,
  `use_smtp` tinyint(1) default '0',
  `backup_dir` varchar(255) default '../backup',
  `reuse_code` tinyint(1) default '1',
  `use_plugin` tinyint(1) default '0',
  PRIMARY KEY  (`set_id`)
) TYPE=MyISAM;

INSERT INTO `setting` VALUES (1,'','','',1251278997,'127.0.0.1',1166338908,1251238646,1251203832,0,5,'','','0','','Mega File Hosting Script','1','-1','dyn','subject','body','',0,'hosting, webhosting, webspace, webserver, backup, file exchange, bandwidth, free download, free downloads, free upload, upload, uploading, download, downloads, mp3, movies, music, videos, shareware, remote desktop, file synchronization, flirt, download movies, spyware remover, firewall software download, chatroom, file transfer, software downloads, file sharing, music downloads, webcam, file mirroring, free software downloads, photoshop, paint shop, download, music downloading, toolbar, playlist, music, kiss tips, file recovery, toner cartridge, edonkey, emule, spyware free download, Singles, ecards, free download, free video, digital photos, free music, photos, video download','The best file hosting service! we provides free web space for your documents, pictures, music and movies.','','blue',0,1,0,1,1,0,'dyn',0,2000,2000,200,500,15,10,1,1,165,165,'soft','admin',0,1,24,NULL,NULL,'mycodehere',1,'[yabsoft]',0,0,'1.3',1,'no','UTF-8',0,1,0,2,1,1,1,0,NULL,'0','',NULL,'','',0,'../backup',0,0);

CREATE TABLE `users` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user` varchar(255) default NULL,
  `pass` varchar(255) default NULL,
  `email` varchar(255) default NULL,
  `bandwidth` varchar(255) default '0',
  `webspace` varchar(255) default '0',
  `files` int(11) default '0',
  `totaldownloads` bigint(19) NOT NULL default '0',
  `totalpoints` varchar(32) default '0',
  `gid` int(11) default NULL,
  `status` tinyint(4) default '1',
  `regdate` int(11) default NULL,
  `subscr_id` varchar(255) default NULL,
  `subscr_unit` enum('D','M','Y') default NULL,
  `subscr_period` int(11) default NULL,
  `subscr_fee` varchar(10) default NULL,
  `expire_date` int(11) default '0',
  `payment_type` enum('instant','subscriptions') default NULL,
  `referby` int(11) default NULL,
  `last_login` int(11) default NULL,
  `last_update` int(11) default NULL,
  `logined_ip` varchar(32) default NULL,
  `custom` enum('yes','no') default 'no',
  `data` text,
  `validate_code` varchar(32) default NULL,
  `sent` tinyint(4) default '0',
  `lang` varchar(4) default 'en',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
