<?
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
define("IN_PAGE",'REWARDS');
define("PAGE_TITLE",'SITEREWARDS');

include "includes/inc.php";

$baseUrl='rewards.php?';

$db->setQuery("select p.*, g.name as groupname
               from promotions as p
               left join groups as g on g.id=p.source_gid
               where g.guest!=1
               order by p.source_gid
               ");
$db->query();
$rows=$db->loadRowList();
$group_id = 0;

# group tabbed page
$group_ids = array();
$rule_ids = array();

if($rows)
foreach($rows as $row)
{
    if($group_id!=$row[source_gid])
    {
        $template->assign_block_vars('promotion',$row);
    }

    $row[upgradepay]  = '<li class="listed">Spend '.$row[points].' points to upgrade to/extend ['.$row[groupname].'] membership for '.$row[months].' months</li><br />';
    $row[upgradepay] .= '<li class="listed">Earn $'.$row[money].' for '.$row[points_fee].' points</li><br />';
    $template->assign_block_vars('promotion.sub',$row);

    # show download rules
    if($group_id!=$row[source_gid])
    {
        $group_id = $row[source_gid];
        # group ids
        $group_ids[] = $group_id;

        # load download rules
        $db->setQuery("select dl.* from downloadrules as dl where dl.dl_gid = '$group_id'");
        $db->query();
        $rules=$db->loadRowList();

        $num = 1;
        if($rules)
        foreach($rules as $rule)
        {
            # rule ids
            $rule_ids[$group_id][] = $rule[rule_id];

            $rule[country] = "Tier-$num Countries";
            $num++;

            $country_list = '';
            $countrynames = split(',',$rule[dl_area]);

            foreach($GEOIP_COUNTRY_NAMES as $id=>$country)
            {
                if($country&&in_array($GEOIP_COUNTRY_CODES[$id],$countrynames))
                $country_list .= '<b>'.$country.'</b>, ';
            }
            $rule[area_list] = substr($country_list,0,-1);

            $points_list = '';
            $dl_filesizes = split(',',$rule[dl_filesizes]);
            $dl_points = split(',',$rule[dl_points]);
            if($dl_filesizes)
            foreach($dl_filesizes as $k=>$filesize)
            {
                 #$filesize is MB
                 $points_list .= '<li class="listed">'.$dl_points[$k].' points per file with size between '.$filesize.'MB '.($dl_filesizes[$k+1]?'- '.$dl_filesizes[$k+1].'MB':'+').'</li><br />';
            }
            $rule[points_list] = $points_list;

            $template->assign_block_vars('promotion.rules',$rule);
        }
    }
}

# build js array
$group_js = "var group_pages = new Array(".implode(',',$group_ids).");";
$rule_js = 'var rule_pages = {';
foreach($rule_ids as $gid=>$rule_id)
{
    $rule_js .= "$gid: Array(".implode(',',$rule_id)."),";
}
$rule_js = substr($rule_js,0,-1);
$rule_js .= '};';
//echo  $group_js,$rule_js;
$template->assign_vars(array('group_js'=>$group_js,'rule_js'=>$rule_js));

require_once("header.php");
$template->set_filenames(array(
	'body' => 'rewards.html')
	);
$template->pparse('body');
include "footer.php";
?>
