<?php
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
define("IN_PAGE",'SITEMAP');
error_reporting  (E_ERROR | E_WARNING | E_PARSE );
define('ROOT','.');
include_once(ROOT.'/config.php');
include_once(ROOT.'/includes/sysvars.php');
include_once(ROOT.'/includes/database.php');
include_once(ROOT.'/includes/function.php');
include_once(ROOT.'/includes/user.class.php');

# sitemap setting
$siteurls = array(
''=>array('mod'  => time(),
          'freq' => 'daily',
          'priority'=> 1,
         ),
'service.php'=>array(
          'mod'  => '',
          'freq' => 'monthly',
          'priority'=> 0.9,
         ),
'rewards.php'=>array(
          'mod'  => '',
          'freq' => 'monthly',
          'priority'=> 0.9,
         ),
'faq.php'=>array(
          'mod'  => '',
          'freq' => 'monthly',
          'priority'=> 0.8,
         ),
'register.php'=>array(
          'mod'  => '',
          'freq' => 'yearly',
          'priority'=> 0.6,
         ),
'login.php'=>array(
          'mod'  => '',
          'freq' => 'yearly',
          'priority'=> 0.6,
         ),
'rules.php'=>array(
          'mod'  => '',
          'freq' => 'yearly',
          'priority'=> 0.6,
         )
);

$download_max_priority = 0.8;
$topfiles_max_priority = 0.8;

$support_lang = 0;

# initiate db connection
$db=new database($sql_host,$sql_user,$sql_pass,$sql_database,"");

# parse input
$input=parse_incoming();

# load Plugin class here
include_once(ROOT.'/includes/plugin.class.php');
$YABPlugin=& YABPlugin::init();

# initiate
$user=new user();

# detect languages ...
$langcodes = array();
if($support_lang)
{
    if ($dh = opendir("language/")) {
    while (($file = readdir($dh)) !== false)
    {
        if ($file != '..' && $file != '.'&& strlen($LANG_TO_CODE[$file]) && is_dir("language/".$file))
        {
            $langcodes[]=$LANG_TO_CODE[$file];
        }
    }
    closedir($dh);
    }
}
else
{
    $langcodes[]='';
}

# send header
header("Content-Type: text/xml;charset=iso-8859-1");

$xml_file = 'temp/sitemap.xml';
if(file_exists($xml_file))
{
    # now too old
    if(time()-filemtime($xml_file)<24*60*60)
    {
        $fp = fopen($xml_file, 'r');
        while($data=fread($fp,1024))
        {
            echo $data;
        }
        fclose($fp);
        exit;
    }
}

ob_start();
echo '<'.'?xml version="1.0" encoding="ISO-8859-1"?'.'>
<urlset xmlns="http://www.google.com/schemas/sitemap/0.84">';
echo "\n";
# static urls ...
foreach($siteurls as $siteurl=>$info)
{
    $last_mod = @filemtime('skin/'.$user->setting['skin_dir'].'/'.str_replace('.php','.html',$siteurl));
    if($last_mod<1) $last_mod = time();
    $siteurl_mod = date('Y-m-d', $info[mod]>0 ? $info[mod] : $last_mod);
    $siteurl_freq = $info[freq];
    $siteurl_priority = $info[priority];
    
    if($langcodes)
    foreach($langcodes as $langcode)
    {
        # langweb
        $siteurl_loc = $baseWeb.($user->setting['lang_page']=='static'&&$langcode?'/'.$langcode:'').'/'.$siteurl . ($user->setting['lang_page']!='static'&&$langcode?'?setlang='.$langcode:'');
?>
<url>
<loc><?=$siteurl_loc?></loc>
<lastmod><?=$siteurl_mod?></lastmod>
<changefreq><?=$siteurl_freq?></changefreq>
<priority><?=$siteurl_priority?></priority>
</url>
<?
    }
}
# file urls
$db->setQuery("select * from files where deleted=0");
$db->query();
$filerows = $db->loadRowList();
foreach($filerows as $fileobj)
{
    if($fileobj[lastdownload]) $daysbydl = intval(($fileobj[lastdownload]-$fileobj[time]) /86400) / $fileobj[downloads];
    else $daysbydl = intval((time()-$fileobj[time]) /86400);

    $siteurl_mod = date('Y-m-d', $fileobj[lastdownload]?$fileobj[lastdownload]:$fileobj[time]);
    
    if($daysbydl<3) $siteurl_freq = 'daily';
    else if($daysbydl<10)$siteurl_freq = 'weekly';
    else if($daysbydl<100)$siteurl_freq = 'monthly';
    else $daysbydl = 'yearly';

    $siteurl_priority = $download_max_priority;
    
    $urltype = $user->setting[static_url];
    if($langcodes)
    foreach($langcodes as $langcode)
    {
        # langweb
        $langWeb = $baseWeb.($user->setting['lang_page']=='static'&&$langcode?'/'.$langcode:'');
        $urls=getDownloadUrl(array(
        'id'=>$fileobj[id],
        'name'=>$fileobj[name],
        'upload_id'=>$fileobj[upload_id],
        'delete_id'=>$fileobj[delete_id],
        ));
        $siteurl_loc = $urls['downloadurl'] . ($urltype!='seo'?'&amp;':'').($user->setting['lang_page']!='static'&&$langcode?($urltype=='seo'?'?':'').'setlang='.$langcode:'');
?>
<url>
<loc><?=$siteurl_loc?></loc>
<lastmod><?=$siteurl_mod?></lastmod>
<changefreq><?=$siteurl_freq?></changefreq>
<priority><?=$siteurl_priority?></priority>
</url>
<?
    }
}
# topfiles urls
$filesperpage = $user->setting[featured_files];
$totalfiles   = GetFileNums();
$totalpages   = ($totalfiles%$filesperpage) ? intval($totalfiles/$filesperpage+2) : $totalfiles/$filesperpage;
for($page=1; $page<$totalpages; $page++)
{
    $siteurl_mod  = date('Y-m-d', $fileobj[lastdownload]?$fileobj[lastdownload]:$fileobj[time]);
    $siteurl_freq = 'daily';
    $siteurl_priority = $topfiles_max_priority;
    
    if($langcodes)
    foreach($langcodes as $langcode)
    {
        # langweb
        $langWeb = $baseWeb.($user->setting['lang_page']=='static'&&$langcode?'/'.$langcode:'');
        $urls=getDownloadUrl(array(
        'id'=>$fileobj[id],
        'name'=>$fileobj[name],
        'upload_id'=>$fileobj[upload_id],
        'delete_id'=>$fileobj[delete_id],
        ));
        $siteurl_loc  = $langWeb.'/topfiles/index'.($page>1?$page:'').'.html'.($user->setting['lang_page']!='static'&&$langcode ? '?setlang='.$langcode : '');
?>
<url>
<loc><?=$siteurl_loc?></loc>
<lastmod><?=$siteurl_mod?></lastmod>
<changefreq><?=$siteurl_freq?></changefreq>
<priority><?=$siteurl_priority?></priority>
</url>
<?
    }
}
echo '</urlset>';
$info = ob_get_contents();
ob_end_clean();

$fp = @fopen($xml_file,'wb');
@fputs($fp,$info);
@fclose($fp);

echo $info;
?>
