/******************************************
|   Upload Functions for Stylish template
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
******************************************/
/******************************************
* AjaxRequest()
* send progress bar request
******************************************/
var lastSuccessUrl = '';
function AjaxRequest(rParam)
{
    if(uploadDone == 1) return;
    lastSuccessParam = rParam;
    //var url=document.uploadform.returnurl.value;
    //alert(rParam+'&url='+progress_url+'&r='+Math.random());
    /*
    $.ajax({
    type: "GET",
    url: url,
    data: rParam+'&url='+escape(progress_url),
    success: showResponse,
    error: reportError
    });*/

    $.getJSON(progress_url+'?&callback=?',rParam,showResponse);
}
function reportError(request)
{
    alert('Sorry. There was an error.'+request);
}
var lastRead   = 0;
var uploadDone = 1;
var upStart    = 0;
/******************************************
* ch_mode(id)
* switch upload mode,and record the mode into cookie
* id: string file,url,ftp
******************************************/
function ch_mode(id)
{
    for(var i=1;i<=4;i++)
    {
       if(i==id)
       {
           currentmode=id;
           setcookie(CookiePrefix+'uploadmode',id);
           $('#uploadmode'+i).show();
           $('#uploadtype'+i).addClass("selected");
           if(currentmode==4) buildFlashUpload(flashPath);
           document.uploadform.action = actions[id];
           document.uploadform.uploadmode.value = currentmode;
       }
       else
       {
           $('#uploadmode'+i).hide();
           $('#uploadtype'+i).removeClass("selected");
       }
    }
    return false;
}
/******************************************
* newUploadField(type)
* generate new upload files
* type:string file,url,ftp
******************************************/
var attaIdx=1;
var fileNum=1;
var urlNum=1;
var ftpNum=1;
function newUploadField(type)
{
    if(type=='file') attaIdx = fileNum;
    if(type=='url')  attaIdx = urlNum;
    if(type=='ftp')  attaIdx = ftpNum;

    if(attaIdx>=max_uploads) {alert(MaxUploadsGot);return false;}

    var filecode=$('#'+type+'_'+'wraper0').html();
    filecode = filecode.replace(/_0/g,'_'+attaIdx+'');
    filecode = filecode.replace(/\[0\]/g,'['+attaIdx+']');

    //alert( filecode);
    $('#'+type+'list').append('<div id="'+type+'_wraper'+attaIdx+'">'+filecode+'</div>');

    //clear out the filled values
    if(type=='file') $('#upload'+type+'_'+attaIdx).click();
    else $('#upload'+type+'_'+attaIdx).text('');

    attaIdx++;

    if(type=='file') fileNum = attaIdx;
    if(type=='url')  urlNum  = attaIdx;
    if(type=='ftp')  ftpNum  = attaIdx;

    return false;
}
/******************************************
* postIt()
* submit upload form
******************************************/
var rParam='';
function postIt()
{
    // reset the form action url
    document.uploadform.action = actions[currentmode];

    // validate file types before uplaod
    var ok = validateUpload();

    if(ok==false) return false;

    // set uploading interface
    startUploading();

    // process flash upload
    if(currentmode==4)
    {
        flashObj("flashUpload").saveCookie(document.cookie);
        flashObj("flashUpload").uploadFiles();
        return;
    }

    // collect param to sen in progress url
    var sid = document.uploadform.sessionid.value;
	iTotal = escape("-1");
	rParam = "iTotal=" + iTotal;
	rParam += "&iRead=0";
	rParam += "&iStatus=1";
    //rParam += "&iNums="+max_uploads;
    rParam += "&iMode="+currentmode;
    rParam += "&dtstart="+upStart;
	rParam += "&sessionid=" + sid;
    rParam += "&dtnow="+upStart;

    // if progress is syn mode, disable the ajax use!
    if(currentmode==1&&cgi_prog_mode=='ajax') AjaxRequest(rParam);
    if(currentmode==2&&url_prog_mode=='ajax') AjaxRequest(rParam);
    if(currentmode==3&&ftp_prog_mode=='ajax') AjaxRequest(rParam);

    // submit form
 	document.uploadform.submit();
    return true;
}
/******************************************
* validateUpload()
* validate the uploads before submit
******************************************/
function validateUpload()
{
    var hasuploads=false;
    var invaliduploads = 0;
    var prefix = 'uploadfile';

    // prefix of field name
    if(currentmode==1) prefix = 'uploadfile';
    if(currentmode==2) prefix = 'uploadurl';
    if(currentmode==3) prefix = 'uploadftp';

    // flash will validate this itself!
    if(currentmode!=4&&!is_object(prefix+'s'))
    for(var i=0;i<max_uploads;i++)
    {
        if(!is_object(prefix+'_'+i)) continue;

        var filename = $('#'+prefix+'_'+i).val();

        if(filename.length) hasuploads = true;

        if(filename.length
           &&
           ((allowed_types&&!in_array(filename,allowed_types))
           ||
           (disabled_types&&in_array(filename,disabled_types)))
           )
         {
             //document.getElementById(prefix+'_'+i).className='warn';
             invaliduploads++;
         }
         else
         {
             //document.getElementById(prefix+'_'+i).className='textinput';
         }
    }
    if(currentmode!=4&&is_object(prefix+'s'))
    {
        var filename = $('#'+prefix+'s').val();

        if(filename.length) hasuploads = true;
    }
    // set hasFlashUploads from flash object
    if(currentmode==4)
    {
        hasuploads = hasFlashUploads;
    }

    // if no file select
    if(hasuploads==false)
    {
        alert(NoFileSelected);
        return false;
    }
    else if(invaliduploads)
    {
        if(allowed_types) alert(UploadInvalid+' '+allowed_types+' '+AllowedFiletypes);
        else alert(UploadInvalid+' '+disabled_types+' '+DisabledFiletypes);
        return false;
    }

    // detect the filed is available and check it meet the reqirement
    if(is_object('fromemail')&&is_object('toemail'))
    {
        var fromemail = $('#fromemail').val();
        var toemail = $('#toemail').val();
        if(fromemail.length&&!checkmail(fromemail))
        {
            alert(EmailInvalid);
            $('#fromemail').focus();
            return false;
        }
        if(fromemail.length==0&&toemail.length)
        {
            alert(SenderRequired);
            $('#fromemail').focus();
            return false;
        }
    }
    // check terms is aggreed
    if(is_object('terms'))
    {
        if($('#terms').attr('checked')==false)
        {
            alert(TOSUnchecked);
            $('#terms').focus();
            return false;
        }
    }

    return true;
}
/******************************************
* startUploading()
* initiate the upload interface once user click upload
******************************************/
function startUploading()
{
    try{
    // initiate upload status
    lastRead   = 0;
    uploadDone = 0;
    var myDate=new Date()
    upStart = parseInt(myDate.getTime()/1000)

    $('#uploaderror').hide();
    $('#emailwindow').hide();
    $('#uploadoverview').hide();
    $('#uploadresults').hide();

    currentmode!=4 ? $('#uploadwindow').hide():$('#uploadwindow').show();
    $('#helpwindow').hide();

    $('#progressbar').show();
    $('#progressbar2').show();

    // flash progress bar detect!
    if(use_flash_progress)
    {
        var version = deconcept.SWFObjectUtil.getPlayerVersion();
        if (document.getElementById && (version['major'] > 0)) {
            if(version['major']<6)
            {
                use_flash_progress = 0;
                $('#flash_progress_bar').hide();
                $('#progBar').show();
            }
            else
            {
                if(typeof(flashObj('flash_progress_bar'))=='object') return '';

                var so = new SWFObject(flashProgressPath, "flash_progress_bar", "364", "40", "7", "#ffffff");
                so.addParam('allowScriptAccess','always');
                so.addParam('wmode','transparent');
                so.write("flashprogressobj");
          
                if(is_object('progBar')) $('#progBar').hide();
            }
        }
    }

    }catch (e) {
        alert('startUploading:'+e)
    }
}
/******************************************
* submitEmailForm()
* submit email form after upload is done.
* Note:the form may be resubmitted for 10 times if no uploaded files is found at server
******************************************/
function submitEmailForm()
{
    // sending emails?
    if(document.emailform!=null)
    {
        //document.emailform.uploadmode.value = currentmode;
        setTimeout("document.emailform.submit();", 2000);
    }
    else
    {
        // get method to refresh emailframe page
        //alert(document.uploadform.sessionid.value)
        setTimeout("document.getElementById('emailframe').contentWindow.location = 'getlinks.php?sessionid='+document.uploadform.sessionid.value+'&submitnums=1'",2000);
    }
}
/******************************************
* showDownloadLinks()
* show the download links after the upload
******************************************/
function showDownloadLinks(totalsize)
{
    if(uploadDone==0)
    {
        calProgress(totalsize,totalsize,upStart);
        uploadDone = 1;
    }

    $('#uploadoverview').html( $('#emailframe').contents().find('#uploadoverview').html() );

    try{
       if(upload_window == 1)
       {
           //normal method to avoid the evalscripts by JQuery!
           document.getElementById('uploadresults').innerHTML = $('#emailframe').contents().find('#linksholder').html();
           showDownloadLinksWindow();
       }
       else
       {
           $('#uploadresults').html( $('#emailframe').contents().find('#linksholder').html() )
       }

       $('#uploadresults').show();
       $('#uploadresultsbar').show();

       $('#uploadoverview').hide();
       $('#helpwindow').hide();
       $('#progressbar').hide();
       $('#progressbar2').hide();

       if(currentmode==4) $('#uploadwindow').hide();

       document.title = $('#filename').html() + $('#filesize').html();
    }
    catch (e) {alert('showDownloadLinks:'+e)}
}
var uploadresultswindow;
function showDownloadLinksWindow()
{
    var scriptobj = $('#uploadresults script')

    uploadresultswindow=dhtmlmodal.open('uploadresultsbox', 'div', 'uploadresults', FileLinksWinTitle, 'width=534px,height=480px,center=1,resize=1,scrolling=1')
    uploadresultswindow.onclose=function(){
       $('#uploadresults').show();

       //remove original HTML to avoid DIV id repeatation
       this.contentarea.defaultHTML = this.contentarea.innerHTML;
       this.contentarea.innerHTML   = '';
       $('#uploadresults').html(this.contentarea.defaultHTML);
       scriptobj.each(function(i,script){jQuery.globalEval(script.innerHTML)})
       return true;
    }
}
/******************************************
* showDownloadErrors()
* show the download errors if the upload fails
******************************************/
function showDownloadErrors()
{
    try{

    $('#uploaderror').show();
    $('#uperror').html( $('#uploadframe').contents().find('#upload_errors').html() );

    resetUploadInterface();

    stopUpload();

    }catch (e) {
        alert('showDownloadErrors:'+e)
    }
}
/******************************************
* resetUploadInterface()
* show the upload interface again if the upload fails
******************************************/
function resetUploadInterface()
{
    try{
    lastRead=0;
    uploadDone=1;

    $('#emailwindow').show();
    $('#uploadwindow').show();

    $('#uploadoverview').hide();
    $('#uploadresults').hide();
    $('#helpwindow').hide();
    $('#progressbar').hide();
    $('#progressbar2').hide();

    }catch (e) {
        alert('resetUploadInterface:'+e)
    }
}
/******************************************
* resetProgressBar()
* show the progress bar
******************************************/
function resetProgressBar()
{
    $('#bread').html('unknown');
    $('#itotal').html('unknown');
    $('#dtremainingf').html('unknown');
    $('#dtelapsedf').html('unknown');
    $('#bspeedf').html('unknown');

    if(use_flash_progress)
    {
        document.flash_progress_bar.SetVariable("/:percentage", 0);
    }
    else
    {
        $('#progBar').html('');
    }
}
/******************************************
* newUploadSession()
* restart a new upload session without reloading pages
******************************************/
function newUploadSession()
{
    try{
        var success	= function(originalRequest){
            //get a new upload session,
            var params = originalRequest;
            parts = params.split(',');
            var newsessionid = parts[0];
            var newaccesskey = parts[1];

            var oldsessionid = document.uploadform.sessionid.value;
            var oldaccesskey = document.uploadform.AccessKey.value;

            actions[1] = actions[1].replace('='+oldsessionid,'='+newsessionid);
            actions[1] = actions[1].replace('='+oldaccesskey,'='+newaccesskey);

            flashPath  = flashPath.replace('='+oldsessionid,'='+newsessionid);
            flashPath  = flashPath.replace('='+oldaccesskey,'='+newaccesskey);

            document.uploadform.action = document.uploadform.action.replace('='+oldsessionid,'='+newsessionid);
            //document.uploadform.action = document.uploadform.action.replace('='+oldaccesskey,'='+newaccesskey);
            document.uploadform.sessionid.value = newsessionid;
            document.uploadform.AccessKey.value = newaccesskey;
            if(document.uploadform.APC_UPLOAD_PROGRESS!=null) document.uploadform.APC_UPLOAD_PROGRESS.value = newsessionid;

            window.frames["emailframe"].location.replace("about:blank");
            if(document.emailform)
            {
                document.emailform.sessionid.value = newsessionid;
                document.emailform.AccessKey.value = newaccesskey;
            }

            if(currentmode==4)
            {
                buildFlashUpload(flashPath);
            }
            FlashDone = 0;

            resetUploadInterface();
            resetProgressBar();
            return '';
        }
        
	    var failure	= function(t){alert('New upload session fails');}
        $.ajax({
        type: 'get',
        url: 'newuploadsession.php',
        data: '',
        success: success,
        error: failure
        });
    }catch (e) {
        alert('newUploadSession:'+e)
    }
    
    return false;
}
/******************************************
* showResponse()
* process the response of progress bar
******************************************/
function showResponse(originalRequest)
{
    var parts= new Array();
    var params=originalRequest;

    //alert('Response:'+params);

    var myDate=new Date()
    var dtnow = parseInt(myDate.getTime()/1000)

    //start to upload,
    if(params.substring(0,5)=='start')
    {
        rParam = params.substring(6);
        rParam = rParam + '&dtnow=' + dtnow;

        //alert('start to obtain progress:'+rParam);
        setTimeout("AjaxRequest(rParam);",2000);
    }
    else
    {
        parts = params.split(',');
        if(parts.length>5)
        {
            var url = parts[6];

            // fail to get the correct data, use lastSuccessParam
            if(url.substring(0,7)!='iTotal=' && url!='')
            {
                var url = lastSuccessParam;
            }
            else
            {
                showProgress(params);
            }
        }
        else
        {
            //alert('Fail Response:'+params+lastSuccessParam);
            var url = lastSuccessParam;
        }

        if(url.length>5)
        {
            url = url + '&dtnow=' + dtnow;
            setTimeout("AjaxRequest('"+url+"');",2000);
        }
    }
}
/******************************************
* stopUpload()
* disable future ajax request of progress bar
******************************************/
function stopUpload()
{
    var tmp = document.createElement("DIV");
    tmp.innerHTML = $('#helpwindow').html();
    if(uploadDone==0)
    return (trim(tmp.textContent||tmp.innerText));
}
/******************************************
* calsize()
* output the nice format of bytes
******************************************/
function calsize(obj,str)
{
    var size=obj.value;
    var unit = 'B';
    if(size=='') size=0;
    if(size>1024) { size=size/1024; unit='KB'; }
    if(size>1024) { size=size/1024; unit='MB'; }
    if(size>1024) { size=size/1024; unit='GB'; }
    size = Math.round(size*100)/100;

    document.getElementById(str).innerHTML=size+' '+unit;
}
/******************************************
* convertsize()
* output the raw format of bytes
******************************************/
function convertsize(size,unittype)
{
    var unit = 'B';
    var ok = 1;
    var sizestr = new String(size);
    if(size=='unknown') return size;
    if(sizestr.lastIndexOf(' ')!=-1)
    {
        var sizeunit=sizestr.substring(sizestr.lastIndexOf(' ')+1)
        if(sizeunit=='B'||sizeunit=='KB'||sizeunit=='MB'||sizeunit=='GB') return size;
    }
    size=parseInt(size);
    if(isNaN(size)) size = 0;
    if(unittype==unit) ok=0;
    if(size>1024&&ok) { size=size/1024; unit='KB';}
    if(unittype==unit) ok=0;
    if(size>1024&&ok) { size=size/1024; unit='MB';}
    if(unittype==unit) ok=0;
    if(size>1024&&ok) { size=size/1024; unit='GB';}

    //size = Math.round(size*100)/100);
    size = Math.round(size);

    return size+' '+unit;
}