<?
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
define("IN_UPLOADING",1);
include "includes/inc.php";
@set_time_limit(0);
$uploader = new uploader($server_id);
flush();

($hook = YABPlugin::fetch_hook('uploading_start',__FILE__,__LINE__)) ? eval($hook) : '';

/**
* CGI Form Upload: Data from upload.cgi
*/
if($input[uploadmode]==1)
{
    $uploader->setUploadMode(1);

    if(!defined('PHPUPLOADMODULE')||PHPUPLOADMODULE==0)
    {
        # load the query string from file or url
        $sid = $input['sessionid'];
        $qstr = @join("",@file($uploader->temp_dir."/{$sid}_qstring"));
        @unlink($uploader->temp_dir."/{$sid}_qstring");

        if ( get_magic_quotes_runtime()!=0 )
        {
           $qstr = stripslashes($qstr);
      	}

        # fail to load string from file? use the get string!
        if(!strlen($qstr)) $qstr = urldecode($input[qstring]);
    
        # reparse the query string
        parse_str($qstr,$_POST);
        $_POST[IP_CGI] =$_GET[IP_CGI];
        $input=parse_incoming();
    }

    # add extras fields
    $uploader->inputExtras('file_', $CustomFields);

    ($hook = YABPlugin::fetch_hook('formupload_start',__FILE__,__LINE__)) ? eval($hook) : '';

    # prepare files vars
    if(!defined('PHPUPLOADMODULE')||PHPUPLOADMODULE==0)
    {
        $_FILES=array();
        if($_POST[file])
        foreach($_POST[file][name] as $index => $name)
        {
            $_FILES[$index]= array(
            'name' => mybasename(stripslashes(stripslashes($name))),//basename(str_replace(base64_decode('XA=='),'/',$name)),
            'size' => $_POST[file][size][$index],
            'tmp_name' => $uploader->temp_dir . '/' . basename($_POST[file][tmp_name][$index]),//$_POST[file][tmp_name][$index],
            );
        }
    }

    # validate upload session
    $ok = $uploader->validate_session($user,$input[AccessKey],$input[sessionid]);

    # processing upload
    if($ok)  $uploader->accept($_FILES);

    ($hook = YABPlugin::fetch_hook('formupload_done',__FILE__,__LINE__)) ? eval($hook) : '';

    # debug
    if($debug)
    {
        trace_echo($qstr,$_POST, $input, $_FILES, $uploader);
    } 
}
/**
* Flash Upload: Direct Data from User Browser
*/
if($input[uploadmode]==4)
{
    $uploader->setUploadMode(4);

    # add extras fields
    $uploader->inputExtras('', $CustomFields);

    ($hook = YABPlugin::fetch_hook('flashupload_start',__FILE__,__LINE__)) ? eval($hook) : '';

    # validate upload session
    # using UploadSession!!
    $ok = $uploader->validate_session($user,$input[AccessKey],$input[UploadSession]);

    # processing upload
    if($ok)
    $uploader->accept($_FILES);

    ($hook = YABPlugin::fetch_hook('flashupload_done',__FILE__,__LINE__)) ? eval($hook) : '';

    # debug
    if($debug)
    {
        trace_write('temp/uploader_'.$input[UploadSession].'.txt',$input,$uploader,$_FILES);
    }
}

/**
* URL Upload: Direct Data from User Browser
*/
if($input[uploadmode]==2)
{
    require_once("includes/http.php");

    $uploader->setUploadMode(2);

    # set the mode of progress bar
    $uploader->progbar='total';

    # add extras fields
    $uploader->inputExtras('url_', $CustomFields);

    ($hook = YABPlugin::fetch_hook('urlupload_start',__FILE__,__LINE__)) ? eval($hook) : '';

    # validate upload session
    $ok = $uploader->validate_session($user,$input[AccessKey],$input[sessionid]);

    # multiple urls upload
    if($input[uploadurls])
    {
        $uploadurl1 = explode("\n",$input[uploadurls]);
        foreach($uploadurl1 as $k=>$v){
           $input[uploadurl][$k]=trim($v);
        }
    }
    
    # convert spaces to '%20'
    $uploadurls = array();
    foreach($input[uploadurl] as $k=>$v)
    {
        $uploadurls[$k] = str_replace(' ','%20',$v);
    }
    if(strlen($input[uploadurllists]))
    {
        $uploadurls = split("\n",$input[uploadurllists]);
    }
    # processing upload
    if($ok)  $uploader->accept($uploadurls);

    ($hook = YABPlugin::fetch_hook('urlupload_done',__FILE__,__LINE__)) ? eval($hook) : '';

    # debug
    if($debug)
    {
        trace_echo($input, $uploader);
    }
}
/**
* FTP Upload: Direct Data from User Browser
*/
if($input[uploadmode]==3)
{
    require_once("includes/ftp-client-class.php");
    
    $uploader->setUploadMode(3);

    # set the mode of progress bar
    $uploader->progbar='total';
    
    # add extras fields
    $uploader->inputExtras('ftp_', $CustomFields);

    ($hook = YABPlugin::fetch_hook('ftpupload_start',__FILE__,__LINE__)) ? eval($hook) : '';

    # validate upload session
    $ok = $uploader->validate_session($user,$input[AccessKey],$input[sessionid]);

    # multiple urls upload
    if($input[uploadftps])
    {
        $uploadurl1 = explode("\n",$input[uploadftps]);
        foreach($uploadurl1 as $k=>$v){
           $input[uploadftp][$k]=trim($v);
        }
    }
    
    # convert spaces to '%20'
    $uploadftps = array();
    foreach($input[uploadftp] as $k=>$v)
    {
        $uploadftps[$k] = str_replace(' ','%20',$v);
    }
    if(strlen($input[uploadftplists]))
    {
        $uploadftps = split("\n",$input[uploadftplists]);
    }
    # processing upload
    if($ok)  $uploader->accept($uploadftps);

    ($hook = YABPlugin::fetch_hook('ftpupload_done',__FILE__,__LINE__)) ? eval($hook) : '';

    # debug
    if($debug)
    {
        trace_echo($input, $uploader);
    }
}

#if($user->uid) $user->updateStats();
if($debug)echo '<pre>'.$db->allSql.'</pre>';
# close db
$db->close_db();

($hook = YABPlugin::fetch_hook('uploading_finish',__FILE__,__LINE__)) ? eval($hook) : '';

/**********************************************
* SYN Progress BAR: percents ...
* Upload Results Response: Error or Success
***********************************************/
# syn progress bar only for url and ftp upload
# accessed from cross.php
if($uploader->progtype=='syn')
{
    ($hook = YABPlugin::fetch_hook('uploadprogess_synmode_start',__FILE__,__LINE__)) ? eval($hook) : '';

    echo <<<EOF
<html><head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<title>Uploading....</title>
</head>
<body>
<div id="upload_errors">$uploader->upload_errors</div>
<script>
EOF;
    # show error
    if(strlen($uploader->upload_errors))
    {
        echo "parent.showDownloadErrors();";
    }
    else
    {
        echo "parent.submitEmailForm();";
    }
    echo <<<EOF
</script>
</body>
</html>
EOF;
exit;
}
# return url to main site ...
$returnurl = strlen($input[returnurl]) ? $input[returnurl] : $baseWeb . '/cross.php';

# ajax progress bar
if($uploader->progtype=='ajax')
{
    ($hook = YABPlugin::fetch_hook('uploadprogess_ajaxmode_start',__FILE__,__LINE__)) ? eval($hook) : '';

    unset($input[IP_ADDRESS]);
    unset($input[REQUEST_METHOD]);
    unset($input[phpuploadscript]); // which is only for SYN mode!
    if($uploader->upload_errors)
    {
        ($hook = YABPlugin::fetch_hook('upload_error_redirect',__FILE__,__LINE__)) ? eval($hook) : '';
        do_redirect($returnurl.'?&redir=1&error='.urlencode($uploader->upload_errors),'','simple');
    }
    else
    {
        ($hook = YABPlugin::fetch_hook('upload_success_redirect',__FILE__,__LINE__)) ? eval($hook) : '';
        do_redirect($returnurl.'?&redir=1','','simple');
    }
    # redirecting
    exit;
}
?>
